cdebug
clarge
C*************************************************************
C     
      SUBROUTINE ESPCOK
C     
C     Subroutine ESPCOK cross-validates an inputted data set 
C     given an initial set of parameters, ect listed in the
C     include file "cokrig.inc".
C     
C*************************************************************
C     
       include'cokrig.inc' 
      REAL XCB,YCB,ZCB,WGT1(MAXV),SUMEA(MAXV),SUMD(MAXV),
     1 SUMD2(MAXV),SUMKV(MAXV),SUMDV(MAXV),SUME(MAXV),
     2 SUME2(MAXV),SUMA(MAXV),SUMA2(MAXV),SUMED(MAXV),
     3 ACT(MAXNUM),PRE(MAXNUM),EAP(MAXNUM),EDV(MAXNUM)
      REAL ACT1(MAXV),PRE1(MAXV),VAR1(MAXV),ERRSTD(MAXV),
     1    WSUMD(MAXV),WSUMD2(MAXV),WSUMKV(MAXV),WSUMDV(MAXV),
     2    CORED(MAXV),COREA(MAXV)
      INTEGER NSUM(MAXV),NZSIG(MAXV)
      character*40 scratch
C     
C     Open scratch file for useage in cross-validation.
C     
      IP = 4
      OPEN(IP,ACCESS='SEQUENTIAL',FORM='UNFORMATTED',
     1     STATUS='SCRATCH')
C     
C     Initialize statistical variables.
C     
      TSUMD = 0.0
      TSUM2 = 0.0
      TSUMV = 0.0
      TSUM2V = 0.0
      DO 10 I = 1,MVAR
        NSUM(I)   = 0
        NZSIG(I)  = 0
        SUMD(I)   = 0.0
        SUMD2(I)  = 0.0
        SUMKV(I)  = 0.0
        SUMDV(I)  = 0.0
        SUME(I)   = 0.0
        SUME2(I)  = 0.0
        SUMA(I)   = 0.0
        SUMA2(I)  = 0.0
        SUMED(I)  = 0.0
        SUMEA(I)  = 0.0
        WSUMD(I)  = 0.0
        WSUMD2(I) = 0.0
        WSUMKV(I) = 0.0
        WSUMDV(I) = 0.0
        CORED(I)  = 0.0
        COREA(I)  = 0.0
 10   CONTINUE
C*****List header if desired.
      IF(ILIST.GE.1)THEN
        WRITE(IOUT,20)
 20     FORMAT('1',//,10X,'***Output of validation cokriging results***',
     1     //,' Variable         Location       Actual     Estimate',
     2         '        Error      Kriging',/,
     3        '                    Number        Value        Value',
     4         '        Value         Std.',/)
      ENDIF
      NG = 0
C*****Cross-validate the data set.
      scratch='Validating       of        locations...'
      write(scratch(21:26),'(i6)',err=28) numhol
 28   DO 200 IH = 1,NUMHOL
         write(scratch(12:16),'(i5)',err=29) ih
         call putstr(scratch,40,20,2,2)
 29      XCB  = X(IH)
        YCB  = Y(IH)
        ZCB  = Z(IH)
C*******Pull in nearest maxhol samples with the
C*******current kriging search radius parameters.
        DO 30 I = 1,NUMHOL
          DIST(I) = DELH(X(I),Y(I),Z(I),XCB,YCB,ZCB,
     1                   AFF1,AFF2,SAZM,CAZM,SDIP,CDIP)
 30     CONTINUE
        CALL IDSORT(NUMHOL,DIST,IHOL)
        ICOUNT = 0
        DO 40 I = 1,NUMHOL
          IF(DIST(IHOL(I)).GT.RADIIA) GO TO 45
          ICOUNT = ICOUNT + 1
          IF(ICOUNT.GE.MAXHOL) GO TO 45
 40     CONTINUE
C*******If have more than NXCOL samples in kriging nbhd, then cokrig.
 45     IF(((ICOUNT*MVAR).LE.NXCOL).OR.(ICOUNT.LT.MINHOL)) GO TO 200
C*******Loop on the variables.
        DO 195 IS = 1,MVAR
C*******IPTT is pointer to location of validation point in
C*******the array GRADE(*) which contains all the data points.
          IPTT = (IH-1)*MVAR + IS
          ACT1(IS) = GRADE(IPTT)
          IF(GRADE(IPTT).EQ.TEST(IS))THEN
            PRE1(IS)   = TEST(IS)
            VAR1(IS)   = TEST(IS)
            ERRSTD(IS) = TEST(IS)
            GO TO 195
          ENDIF
C*********Loop to make sure that at least NTERM(I) samples
C*********of attribute I are included in kriging nbhd.
          DO 50 I = 1,MVAR
            G(I) = 0.0
 50       CONTINUE
          NSAMP = 0
          DO 60 I = 1,ICOUNT
C*********IPT is pointer to location of data points to be included
C*********in validation NBHD in the array GRADE(*).  Array IHOL(*)
C*********has the hole numbers of points I in the validation NBHD.
            IPT = (IHOL(I) - 1)*MVAR
            DO 55 J = 1,MVAR
              IPT = IPT + 1
C*************Don't include validation point in estimator.
              IF((IHOL(I).EQ.IH).AND.(J.EQ.IS)) GO TO 55
C*************Include sample if not equal to test value.
              IF(GRADE(IPT).NE.TEST(J))THEN
                NSAMP = NSAMP + 1
                G(J) = G(J) + 1.0
                NHOL(NSAMP) = IHOL(I)
                NATR(NSAMP) = J
              ENDIF
 55         CONTINUE
 60       CONTINUE
C*********Check for possible singular design matrix.
C*********Loop away if design matrix is not independent.
          DO 65 I = 1,MVAR
            IF(G(I).LT.NTERM(I)) GO TO 200
 65       CONTINUE
C*********Set weights such that only validated sample attribute
C*********will be estimate in this loop.
          DO 70 I = 1,MVAR
            WGT1(I) = WGT(I)
            IF(IS.NE.I)THEN
              WGT(I) = 0.0
            ENDIF
 70       CONTINUE
C*********Echo points in kriging nbhd if desired.
          IF(IDBUG.EQ.1)THEN
            WRITE(IOUT,75) 
 75         FORMAT(//,' Echo of points in kriging NBHD!',//,
     1      '    Easting  Northing Elevation       Distance',
     2      '          Grade  Variable')     
            WRITE(IOUT,80)
 80         FORMAT(1X)
            DO 90 I = 1,NSAMP
              LOC = (NHOL(I)-1)*MVAR + NATR(I)
              WRITE(IOUT,85) X(NHOL(I)),Y(NHOL(I)),Z(NHOL(I)),
     1                       DIST(NHOL(I)),GRADE(LOC),NAME(NATR(I))
 85           FORMAT(1X,3F10.2,2E15.7,2X,A15)
 90         CONTINUE
          ENDIF
C*********Call subroutines to compute kriging estimate.
          CALL LEFT(IERROR)
          IF(IERROR.GE.1)THEN
C***********Singular design matrix so jump to
C***********the next estimation point.
            GO TO 200
          ELSEIF(IERROR.EQ.0)THEN
C***********Matrix factorizations ok, so finish
C***********with the cokriging estimator.
            CALL RIGHT(TCOKVA,XCB,YCB,ZCB)
          ENDIF
C*********Write results to output files.
          IF(EST(IS).LT.0.0)THEN
            EST(IS) = 0.0
          ENDIF
          PRE1(IS) = EST(IS)
          VAR1(IS) = COKVAR(IS)
          DELGRA = EST(IS) - GRADE(IPTT)
          ERRSTD(IS) = DELGRA/COKVAR(IS)
          IF(ILIST.GE.1)THEN
            WRITE(IOUT,100) NAME(IS),IH,GRADE(IPTT),EST(IS),DELGRA,
     1                      COKVAR(IS)
 100        FORMAT(1X,A15,I10,4E13.6)
          ENDIF
          WRITE(IP) IS,IH,GRADE(IPTT),EST(IS),COKVAR(IS)
          TSUMD     = TSUMD     + WGT(IS)*DELGRA
          TSUM2     = TSUM2     + WGT(IS)*DELGRA*DELGRA
          TSUMV     = TSUMV     + WGT(IS)*COKVAR(IS)
          IF(COKVAR(IS).GT.0.0)THEN
            TSUM2V    = TSUM2V    + WGT(IS)*DELGRA*DELGRA/COKVAR(IS)
          ENDIF
          SUME(IS)  = SUME(IS)  + EST(IS)
          SUME2(IS) = SUME2(IS) + EST(IS)*EST(IS)
          SUMA(IS)  = SUMA(IS)  + GRADE(IPTT)
          SUMA2(IS) = SUMA2(IS) + GRADE(IPTT)*GRADE(IPTT)
          SUMEA(IS) = SUMEA(IS) + EST(IS)*GRADE(IPTT)
          SUMED(IS) = SUMED(IS) + EST(IS)*DELGRA
          NSUM(IS)  = NSUM(IS)  + 1
          SUMD(IS)  = SUMD(IS)  + DELGRA
          SUMD2(IS) = SUMD2(IS) + DELGRA*DELGRA
          SUMKV(IS) = SUMKV(IS) + COKVAR(IS)
          SUMDV(IS) = SUMDV(IS) + DELGRA*DELGRA/COKVAR(IS)
          TSIG      = 2.0*COKVAR(IS)
          IF(ABS(DELGRA).GT.TSIG) NZSIG(IS) = NZSIG(IS) + 1
C     
          NG = NG + 1
          IF(NG.GT.1) IDBUG = 0
C     
C       Now re-update the weights on each variable.
C     
          DO 120 I = 1,MVAR
            WGT(I) = WGT1(I)
 120      CONTINUE
C         
          WRITE(IOUT,130) IH,IS,ACT1(IS),PRE1(IS),VAR1(IS),
     1                       ERRSTD(IS)
 130      FORMAT(' Location ',I3,' Attribute ',I1,' Actual = ',E15.7,
     1    ' Predicted = ',E15.7,/,' Standard Deviation = ',E15.7,
     2    ' Standardized Error = ',E15.7)
C         
 195    CONTINUE
C*******Write results to punch file.
        WRITE(IPCH,196) X(IH),Y(IH),Z(IH),
     1                  (ACT1(JJ),PRE1(JJ),VAR1(JJ),
     2                   ERRSTD(JJ),JJ=1,MVAR)
 196    FORMAT(4E15.7)
 200  CONTINUE
C     
      IF(ILIST.GE.1)THEN
        WRITE(IOUT,210) NG
        WRITE(IOUT,210) NG
 210    FORMAT(//,' Done validation cokriging of ',I5,' data points')
      ENDIF
C     
C     Up-date required statistics.
C     
      DO 400 IS = 1,MVAR
        IF(NSUM(IS).EQ.0) GO TO 400
        WSUMD(IS)  = SUMD(IS)/FLOAT(NSUM(IS))
        WSUMD2(IS) = SUMD2(IS)/FLOAT(NSUM(IS))
        WSUMKV(IS) = SUMKV(IS)/FLOAT(NSUM(IS))
        WSUMDV(IS) = SUMDV(IS)/FLOAT(NSUM(IS))
        SED    = SUMED(IS) - SUME(IS)*SUMD(IS)/FLOAT(NSUM(IS))
        SEE    = SUME2(IS) - SUME(IS)*SUME(IS)/FLOAT(NSUM(IS))
        SDD    = SUMD2(IS) - SUMD(IS)*SUMD(IS)/FLOAT(NSUM(IS))
        SEA    = SUMEA(IS) - SUME(IS)*SUMA(IS)/FLOAT(NSUM(IS))
        SAA    = SUMA2(IS) - SUMA(IS)*SUMA(IS)/FLOAT(NSUM(IS))
        IF((SEE.EQ.0.0).OR.(SDD.EQ.0.0))THEN
          CORED(IS) = 0.0
        ELSE
          CORED(IS)  = SED/((SEE*SDD)**0.5)
        ENDIF
        IF((SEE.EQ.0.0).OR.(SAA.EQ.0.0))THEN
          COREA(IS) = 0.0
        ELSE
          COREA(IS)  = SEA/((SEE*SAA)**0.5)
        ENDIF
        WRITE(IOUT,220) NAME(IS),NSUM(IS),WSUMD(IS),WSUMD2(IS),
     1   WSUMKV(IS),WSUMDV(IS),CORED(IS),COREA(IS)
 220    FORMAT('1',//,' Echo of Summary Statistics for ',A15,//,
     1  ' 1) Number of validated points ==============> ',I15,/,
     2  ' 2) Mean error  =============================> ',E15.5,/,
     3  ' 3) Mean sum of square errors ===============> ',E15.5,/,
     4  ' 4) Mean kriging variance ===================> ',E15.5,/,
     5  ' 5) Mean square error/mean krige var. =======> ',E15.5,/,
     6  ' 6) Correlation of est. and error ===========> ',E15.5,/,
     7  ' 7) Correlation of est. and act. ============> ',E15.5,/)
C     
C     Rewind scratch file, and compute histograms, scattergrams,
C     and list points with deviation greater than two krige std.
C     
        REWIND(IP)
        IF(NZSIG(IS).GT.0)THEN
          WRITE(IOUT,230) NZSIG(IS),NAME(IS)
 230      FORMAT('1',//,' Echo of ',I5,' sampled points for ',A15,//,
     1    ' These points have a difference between the estimated',/,
     2    ' and the actual value that is greater than two kriging',/,
     3    ' standard errors',//,
     4    '    Easting  Northing Elevation      Estimated',
     5    '         Actual        Kriging',/,
     6    '   Distance  Distance  Distance          Value',
     7    '          Value           Std.',/)
        ENDIF
        I = 0
        DO 300 J = 1,NG
          READ(IP) IIS,IIH,GRAD1,EST1,COK1
          IF(IIS.EQ.IS)THEN
            TSIG = 2.0*COK1
            DELGRA = EST1 - GRAD1
            IF(ABS(DELGRA).GT.TSIG)THEN
              WRITE(IOUT,240) X(IIH),Y(IIH),Z(IIH),EST1,GRAD1,COK1
 240          FORMAT(1X,3F10.2,3E15.7)
            ENDIF
            I = I + 1
            ACT(I) = GRAD1
            PRE(I) = EST1
            EAP(I) = DELGRA
            EDV(I) = DELGRA/COK1
          ENDIF
 300    CONTINUE
C     
C     Plot histograms or errors and kriging std. dev. weighted errors.
C     
        DO 310 J = 1,I
          IF(J.EQ.1)THEN
            RMAX1 = EAP(J)
            RMIN1 = EAP(J)
            RMAX2 = EDV(J)
            RMIN2 = EDV(J)
          ELSE
            IF(EAP(J).GT.RMAX1) RMAX1 = EAP(J)
            IF(EAP(J).LT.RMIN1) RMIN1 = EAP(J)
            IF(EDV(J).GT.RMAX2) RMAX2 = EDV(J)
            IF(EDV(J).LT.RMIN2) RMIN2 = EDV(J)
          ENDIF
 310    CONTINUE
C     
        NCELL = 10
        HWID  = (RMAX1 - RMIN1)/10.0
        XLOW  = RMIN1 + HWID
        WRITE(IOUT,320) NAME(IS)
 320    FORMAT('1',//,' Histogram of errors for ',A15)
        CALL HISTO(EAP,XLOW,HWID,NCELL,I,IOUT)
        HWID  = (RMAX2 - RMIN2)/10.0
        XLOW  = RMIN2 + HWID
        WRITE(IOUT,330) NAME(IS)
 330    FORMAT(//,' Histogram of kriging std. dev. weighted',
     1                ' errors for ',A15)
        CALL HISTO(EDV,XLOW,HWID,NCELL,I,IOUT)
C     
C       Plot scattergrams of est vs actual and est vs error.
C     
        DO 340 J = 1,I
          IF(J.EQ.1)THEN
            RMAX2 = ACT(1)
            RMIN2 = ACT(1)
            RMAX3 = PRE(1)
            RMIN3 = PRE(1)
          ELSE
            IF(ACT(J).GT.RMAX2) RMAX2 = ACT(J)
            IF(ACT(J).LT.RMIN2) RMIN2 = ACT(J)
            IF(PRE(J).GT.RMAX3) RMAX3 = PRE(J)
            IF(PRE(J).LT.RMIN3) RMIN3 = PRE(J)
          ENDIF
 340    CONTINUE
        IF(RMAX2.GE.RMAX3)THEN
          AMAX = RMAX2
        ELSE
          AMAX = RMAX3
        ENDIF
        IF(RMIN2.LT.RMIN3)THEN
          AMIN = RMIN2
        ELSE
          AMIN = RMIN3
        ENDIF
        WRITE(IOUT,350) NAME(IS)
 350    FORMAT('1',/,' Scattergram of estimate vs actual for ',
     1                    A15)
        CALL SCATTR(ACT,AMIN,AMAX,PRE,AMIN,AMAX,I,IOUT)
        WRITE(IOUT,360) NAME(IS)
 360    FORMAT('1',/,' Scattergram of estimate vs error for ',
     1                    A15)
        CALL SCATTR(EAP,RMIN1,RMAX1,PRE,RMIN3,RMAX3,I,IOUT)
C     
 400  CONTINUE
C     
C     Summary statistics of validation.
C     
      TSUM2V = TSUM2V/FLOAT(NG)
      TSUMD  = TSUMD/FLOAT(NG)
      TSUM2  = TSUM2/FLOAT(NG)
      TSUMV  = TSUMV/FLOAT(NG)
C     
      WRITE(IOUT,410) NG,TSUMD,TSUM2,TSUMV,TSUM2V
 410  FORMAT('1',//,' Summary validation statistics ',//,
     1 ' 1) Number of validation points =================> ',I15,/,
     2 ' 2) Weighted mean error =========================> ',E15.7,/,
     3 ' 3) Weighted mean square errors =================> ',E15.7,/,
     4 ' 4) Weighted mean kriging variances =============> ',E15.7,/,
     4 ' 5) Weighted square errors/kriging variances ====> ',E15.7)
C     
      WRITE(IOUT,420)
 420  FORMAT(//,' Done writting summary statistics!')
C     
C*****Echo summary statistics on screen for each variable.
C     
ccc      CALL CLEARSCREEN
      WRITE(IOUT,430) 
 430  FORMAT(/////,
     1 ' ECHO OF SUMMARY CROSS-VALIDATION STATISTICS ',//,
     2 ' Name               Mean         Mean   Normalized  Correlation',
     3 '  Correlation',/,
     4 '                   Error    Sq. Error     Mean Sq.      Z vs Z*',
     5 '  Z* vs Error',/,
     6 '                                             Error',/)
      DO 450 I = 1,MVAR
        WRITE(IOUT,440) NAME(I),WSUMD(I),WSUMD2(I),WSUMDV(I),
     1               COREA(I),CORED(I)
 440    FORMAT(1X,A10,5E13.5)
 450  CONTINUE
      WRITE(IOUT,460)
 460  FORMAT(//,' HIT RETURN TO CONTINUE ',$)
ccc      READ(*,470,ERR=480) INTT
      call erase(20,2,77)
      call beep
      call flash(20,2,'All done! Press any key...')
ccc
 470  FORMAT(BN,I10)
C     
C     Close files and quit.
C     
 480  CLOSE(IOUT)
      CLOSE(INPUT)
      CLOSE(IP)
ccc      CLOSE(ICTL)
      CLOSE(IPCH)
C          
      RETURN
      END
