clarge 
C Readdata.for - file input routines for STATS 
C 
C---------------------------------------------------------------------- 
C ***  Read Header Data - get data from input file 
 
        SUBROUTINE Read Header Data  (File Name,Error) 
        IMPLICIT INTEGER*4 (A-Z) 
 
       include'cokrig.inc' 
 
        LOGICAL         Error 
        CHARACTER       Blanks*10, Scratch*5, File Name*(*) 
        CHARACTER       Dummy*10 
 
 
        DATA Blanks /'          '/ 
 
C Open File for input 
        CALL PutStr ('Reading Header Data ',20, 20, 2, 2) 
        Error   = .FALSE. 
        OPEN(UNIT = 10, FILE = File Name, ERR = 999) 
 
C Read header string into header character variable 
        READ (10, '(A)', ERR = 999, END = 999) Dummy 
 
C Get number of variables in file 
        READ(10, *, ERR = 999, END = 999) Nva 
 
        IF (Nva .LT. 3) THEN 
           CALL Flash (20, 2, 
     +              'Too few variables in file  (press any key)') 
           GOTO 999 
C        ELSEIF (Nva .GT. MAXV) THEN 
C           CALL Flash (20, 2, 
C     +              'Too many variables in file  (press any key)') 
C           GOTO 999 
        ENDIF 
 
C Get variable names for each variable in file 
        DO 20 I = 1,  Nva 
          READ (10,'(2A10)', ERR = 999, END = 999) 
     +                                Name (i), Units (i) 
 20     CONTINUE 
        Nva = Nva + 1

C Load variable names into toggle fields for screen processing 
        IF (Dimen.EQ.1) THEN 
           CALL Load Toggle Values  ('GR XVAR    ',10, Nva, Name, 0) 
           CALL Set Toggle Position ('GR XVAR    ', ICX-1)
           I = 0 
        ELSEIF (Dimen.EQ.2) THEN 
           CALL Load Toggle Values  ('GR XVAR    ',10, Nva, Name, 0) 
           CALL Set Toggle Position ('GR XVAR    ', ICX-1) 
           CALL Load Toggle Values  ('GR YVAR    ',10, Nva, Name, 1) 
           CALL Set Toggle Position ('GR YVAR    ', ICY-1) 
           I = 1 
        ELSEIF (Dimen.EQ.3) THEN 
           CALL Load Toggle Values  ('GR XVAR    ',10, Nva, Name, 0) 
           CALL Set Toggle Position ('GR XVAR    ', ICX-1) 
           CALL Load Toggle Values  ('GR YVAR    ',10, Nva, Name, 1) 
           CALL Set Toggle Position ('GR YVAR    ', ICY-1) 
           CALL Load Toggle Values  ('GR ZVAR    ',10, Nva, Name, 2) 
           CALL Set Toggle Position ('GR ZVAR    ', ICZ-1) 
           I = 2 
        ELSE 
           CALL Flash (20, 2, 
     +         'Choice of dimension is wrong (press any key)') 
           GOTO 999 
        ENDIF 
c       DO 25 J = I + 1, I + Mvar 
           J = I + Mvar 
           CALL Load Toggle Values  ('VRM VARIA  ',10, Nva, Name, J) 
           CALL Set Toggle Position ('VRM VARIA  ', ICV(J-I)-1) 
           CALL Load Toggle Values  ('DF VAR     ',10, Nva, Name, J) 
           CALL Set Toggle Position ('DF VAR     ', ICV(J-I)-1) 
c25      CONTINUE 
        CLOSE (10) 
        RETURN 
 
C error has been found in data of file 
 
 999    Error = .TRUE. 
        CLOSE (10) 
        CALL Beep 
        CALL Erase Field ('GR XVAR    ') 
        CALL Erase Field ('GR YVAR    ') 
        CALL Erase Field ('GR ZVAR   ') 
 
        CALL Flash (20, 2, ' Press any key to exit ') 
        Ndata = 0 
        Nva  = 0 
C        Mvar = 0 
        RETURN 
        END 
 
C---------------------------------------------------------------------- 
C Read Coordinate Values - read coordinates into memory 
 
      SUBROUTINE Read Coordinate Values (Error) 
      IMPLICIT INTEGER*4 (A-Z) 
 
       include'cokrig.inc' 
 
      CHARACTER      Dummy*75, Scratch*5 , File Name*65
      LOGICAL        Error, Fexist
      REAL*4         Dx, Dy, Dz, Dt, DistMax
c      REAL*4         TxMax, Txmin, Tymax, Tymin, Txtinc, Tytinc 
c      REAL*4         TzMax, Tzmin, Tztinc 
c      INTEGER*4      Ndata 

C Initialize Variables 
 
      CALL PutStr ('Reading Coordinates ...  ', 25, 20, 2, 2) 
 
      CALL Get File Name (File Name, File Prefix, Data File, Fexist) 
 
      IF (.NOT. Fexist) THEN 
        Error = .TRUE. 
        GOTO 999 
      ENDIF 
 
C Open File for input 
      Error     = .FALSE. 
      OPEN(UNIT = 10, FILE = File Name, ERR = 999)

C Read header string 
      READ(10, '(A)', ERR = 999, END = 999) Dummy 

C Get number of variables in file 
      READ(10, *, ERR = 999, END = 999) Nva
      IF (Nva .LT. 1 ) GOTO 999 

C Get variable names for each variable in file 
      DO 20 I = 1,  Nva 
       READ (10,'(2A10)', ERR = 999, END = 999) Dummy,Dummy
 20   CONTINUE 

      Ndata          = 0 
      Xmin      = 1.E30 
      Xmax      = -1.E30 
      Ymin      = Xmin 
      Ymax      = Xmax 
      Zmin      = Xmin 
      Zmax      = Xmax 
          
      If (Dimen .EQ. 2) Then 
       DO 30 Nrec = 1, MAXNUM 
        READ (10, *, ERR = 999, END = 900) (DataRec (i), i = 1, Nva)

        IF (DataRec (ICX) .LT. Missing .AND. 
     +        DataRec (ICY) .LT. Missing) THEN 
           Ndata         = Ndata + 1 
           X (Ndata) = DataRec (ICX) 
           Y (Ndata) = DataRec (ICY)
           Z (Ndata) = 0.0 
C           Yvalues (Ndata)    = Y (Ndata) 
C           YvalPtr (Ndata)    = Ndata 
           Xmax = AMAX1 (X (Ndata), Xmax) 
           Ymax = AMAX1 (Y (Ndata), Ymax) 
           Xmin = AMIN1 (X (Ndata), Xmin) 
           Ymin = AMIN1 (Y (Ndata), Ymin) 
        ENDIF 
 30    CONTINUE 

C check if more than MAXDATA records 
       READ (10, *, END = 900, ERR = 999) (DataRec(i), i=1, Nva) 
       CALL Flash (20, 2, 'MAXDATA samples used (Press a Key)') 
 
 900   IF (Ndata .LE. 1) GOTO 999 
       CLOSE (10) 
 
C Sort YData values 
c       CALL PutStr ('Sorting Y Coordinates... ', 25, 20, 2, 2) 
c       CALL Qsort  (Yvalues, YvalPtr, Ndata) 
 
C Calculate a default grid 
       IF (XLBL .EQ. 0 .OR. YLBL .EQ. 0) THEN 
        XEAST   = Xmin 
        YNORTH  = Ymin 
        ZELEV   = 0.0 
        XLBL    = (Xmax-Xmin)/9.0 
        YLBL    = (Ymax-Ymin)/9.0 
        ZLBL    = 0.0 
        NSE     = 1
        NSN     = 1
        NSB     = 1
        NFE     = 9
        NFN     = 9
        NFB     = 1
C       NxCells      = 10 
C       NyCells      = 10 
        CALL Set 4 Floating Point Value ('GR XORG    ', XEAST, 3) 
        CALL Set 4 Floating Point Value ('GR YORG    ', YNORTH, 3) 
        CALL Set 4 Floating Point Value ('GR ZORG    ', ZELEV, 3) 
        CALL Set 4 Floating Point Value ('GR XCSIZE  ', XLBL, 3) 
        CALL Set 4 Floating Point Value ('GR YCSIZE  ', YLBL, 3) 
        CALL Set 4 Floating Point Value ('GR ZCSIZE   ', ZLBL, 3) 
        CALL Set Integer Value          ('GR NSE    ', NSE)
        CALL Set Integer Value          ('GR NSN    ', NSN)
        CALL Set Integer Value          ('GR NSB    ', NSB)
        CALL Set Integer Value          ('GR NFE    ', NFE)
        CALL Set Integer Value          ('GR NFN    ', NFN)
        CALL Set Integer Value          ('GR NFB    ', NFB)
        
C       CALL Set Integer Value          ('GR XNCELL ', NxCells) 
C       CALL Set Integer Value          ('GR YNCELL ', NyCells) 
       ENDIF 
 
C Calculate Defaults for the Variogram model and search parameters 
       IF (RADIIA .EQ. 0.0 .OR. RADIIB .EQ. 0.0) THEN 
        Dx = ABS (Xmax - Xmin) 
        Dy = ABS (Ymax - Ymin) 
        RADIIA = AMAX1 (Dx, Dy) * .25 
        RADIIB = RADIIA 
        RADIIC = 0.0 
        DIP    = 0.0 
        AZMUTH = 0.0
        MAXHOL  = INT(NTS/MAXV)
        MINHOL  = 1 
        CALL Set 4Floating Point Value ('SE RADIIA  ', RADIIA, 3) 
        CALL Set 4Floating Point Value ('SE RADIIB  ', RADIIB, 3) 
        CALL Set 4 Floating Point Value ('SE RADIIC  ', RADIIC, 3) 
        CALL Set 4Floating Point Value ('SE DIP     ', DIP, 3) 
        CALL Set 4 Floating Point Value ('SE AZMUTH  ', AZMUTH, 3)
        CALL Set Integer Value          ('SE MINHOL ', MINHOL) 
        CALL Set Integer Value          ('SE MAXHOL ', MAXHOL)
      ENDIF 
       CALL Erase (20, 2, 75) 
       RETURN 

      ELSEIF (Dimen .EQ. 3) Then 
       DO 40 Nrec = 1, MAXNUM 
        READ (10, *, END = 901, ERR = 999) (DataRec (i), i=1, Nva) 
        IF (DataRec(ICX) .LT. Missing .AND. 
     +      DataRec(ICY) .LT. Missing .AND. 
     +      DataRec(ICZ) .LT. Missing )  THEN 
           Ndata         = Ndata + 1 
           X (Ndata) = DataRec(ICX) 
           Y (Ndata) = DataRec(ICY) 
           Z (Ndata) = DataRec(ICZ) 
c           Zvalues (Ndata)    = Z (Ndata) 
c           ZvalPtr (Ndata)    = Ndata 
           Xmax = AMAX1 (X (Ndata), Xmax) 
           Ymax = AMAX1 (Y (Ndata), Ymax) 
           Zmax = AMAX1 (Z (Ndata), Zmax) 
           Xmin = AMIN1 (X (Ndata), Xmin) 
           Ymin = AMIN1 (Y (Ndata), Ymin) 
           Zmin = AMIN1 (Z (Ndata), Zmin) 
        ENDIF 
 40    CONTINUE 

C check if more than MAXDATA records 
       READ (10, *, END = 901, ERR = 999) (DataRec(i), i=1, Nva) 
       CALL Flash (20, 2, 'MAXDATA samples used (Press a Key)') 
 
 901   IF (Ndata .LE. 1) GOTO 999 
       CLOSE (10) 
 
C Sort ZData values 
C       CALL PutStr ('Sorting Z Coordinates... ', 25, 20, 2, 2) 
c       CALL Qsort  (Zvalues, ZvalPtr, Ndata) 
 
C Calculate a default grid 
       IF (XLBL .EQ. 0 .OR. YLBL .EQ. 0 .OR. ZLBL .EQ. 0) THEN 
        XEAST   = Xmin 
        YNORTH  = Ymin 
        ZELEV   = Zmin 
        XLBL    = (Xmax-Xmin)/9.0 
        YLBL    = (Ymax-Ymin)/9.0 
        ZLBL    = (Zmax-Zmin)/9.0 
        NSE     = 1
        NSN     = 1
        NSB     = 1
        NFE     = 9
        NFN     = 9
        NFB     = 9
C       NxCells      = 10 
C       NyCells      = 10 
        CALL Set 4 Floating Point Value ('GR XORG    ', XEAST, 3) 
        CALL Set 4 Floating Point Value ('GR YORG    ', YNORTH, 3) 
        CALL Set 4 Floating Point Value ('GR ZORG    ', ZELEV, 3) 
        CALL Set 4 Floating Point Value ('GR XCSIZE  ', XLBL, 3) 
        CALL Set 4 Floating Point Value ('GR YCSIZE  ', YLBL, 3) 
        CALL Set 4 Floating Point Value ('GR ZCSIZE  ', ZLBL, 3) 
        CALL Set Integer Value          ('GR NSE    ', NSE)
        CALL Set Integer Value          ('GR NSN    ', NSN)
        CALL Set Integer Value          ('GR NSB    ', NSB)
        CALL Set Integer Value          ('GR NFE    ', NFE)
        CALL Set Integer Value          ('GR NFN    ', NFN)
        CALL Set Integer Value          ('GR NFB    ', NFB)
C       CALL Set Integer Value          ('GR XNCELL ', NxCells) 
C       CALL Set Integer Value          ('GR YNCELL ', NyCells) 
       ENDIF 
 
C Calculate Defaults for the Variogram model and search parameters 
       IF (RADIIA .EQ. 0.0 .OR. RADIIB .EQ. 0.0 
     +                     .OR. RADIIC .EQ. 0.0) THEN 
        Dx = ABS (Xmax - Xmin) 
        Dy = ABS (Ymax - Ymin) 
        Dz = ABS (Zmax - Zmin) 
        Dt = AMAX1 (Dx,Dy) 
        RADIIA = AMAX1 (Dz, Dt) * .25 
        RADIIB = RADIIA 
        RADIIC = RADIIB 
        DIP    = 0.0 
        AZMUTH = 0.0 
        MAXHOL = INT(NTS/MAXV)
        MINHOL = 1

        CALL Set 4Floating Point Value ('SE RADIIA  ', RADIIA, 3) 
        CALL Set 4Floating Point Value ('SE RADIIB  ', RADIIB, 3) 
        CALL Set 4 Floating Point Value ('SE RADIIC  ', RADIIC, 3) 
        CALL Set 4Floating Point Value ('SE DIP     ', DIP, 3) 
        CALL Set 4 Floating Point Value ('SE AZMUTH  ', AZMUTH, 3) 
        CALL SET INTEGER VALUE ('SE MINHOL  ', MINHOL)
        CALL SET INTEGER VALUE ('SE MAXHOL  ', MAXHOL)
       ENDIF
       ENDIF
       CALL Erase (20, 2, 75)
       RETURN 
C error has been found in data 
 999  if (ndata .le. 1) goto 1000
      Error          = .TRUE. 
      CLOSE (10) 
cclong replacing the ndata, nva lines below
cc    with
      CALL putstr (
     &     'Error in data file! Type "c" to continue anyway:',50,20,2,0)
      call getthekey(i)
      if (char(i) .eq. 'c' .or. char(i) .eq. 'C') then
         error = .false.
         CALL Erase (20, 2, 75)
cclong         goto 900
         close(10)
         return
cclong 94/3/15
      end if
 1000 CALL Erase Field ('GR XVAR   ') 
      CALL Erase Field ('GR YVAR   ')
      CALL Erase Field ('GR ZVAR   ') 
      Ndata = 0
      Nva  = 0
C     NXcells = 0 
C     NyCells = 0 
      RETURN 
      END 
 
C---------------------------------------------------------------------- 
C Read Data - read data into memory 
 
      SUBROUTINE Read Data (Error) 
      IMPLICIT INTEGER*4 (A-Z) 
      
       include'cokrig.inc' 
 
      CHARACTER      Dummy*75, Scratch*5, File Name*65, Ifmt*4 
      LOGICAL        Error, Fexist
      REAL*4         Dx, Dy, DistMax 
      INTEGER*4      I

C Initialize Variables 
      DATA Ifmt /'(I5)'/ 
 
      CALL PutStr ('Reading Data Values ...  ', 25, 20, 2, 2) 
 
C Build File name 
      CALL Get File Name (File Name, File Prefix, Data File, Fexist) 
 
C Open File for input 
      Error     = .FALSE. 
      OPEN(UNIT = 10, FILE = File Name, ERR = 999) 
 
C Read header string 
      READ(10, '(A)', ERR = 999, END = 999) Dummy 
 
C Get number of variables in file 
      READ(10, *, ERR = 999, END = 999) Nva 
 
      IF (Nva .LT. 1 ) GOTO 999 
 
C Get variable names for each variable in file 
      DO 20 I = 1,  Nva 
         READ (10,'(2A10)', ERR = 999, END = 999) Dummy, Dummy 
 20   CONTINUE 
      numhol = 0
      ncount = 0
 280  READ(10,*,END=900,ERR = 999) (GG(J),J=1,Nva)
      numhol = numhol+1
      IF(numhol .EQ.MAXNUM+1) then
         numhol = numhol - 1
C check if more than MAXDATA records 
         READ (10, *, END = 900, ERR = 900) (DataRec (i), i=1, Nva) 
         CALL Beep 
         CALL Flash (20, 2, '# data exceeds limits, only MAXDATA used') 
         GO TO 900
      end if
      X(Numhol) = GG(ICX)
      Y(Numhol) = GG(ICY)
      IF(ICZ.NE.0)THEN
        Z(Numhol) = GG(ICZ)
      ELSE
        Z(Numhol) = 0.0
      ENDIF
      DO 285 J = 1,Mvar
        G(J) = GG(ICV(J))
 285  CONTINUE
      ITEST = 0
      DO 290 J = 1,Mvar
        IF(G(J).ne.TEST(J)) ITEST = 1
 290  CONTINUE
      IF(ITEST.EQ.0)THEN
         numhol = numhol-1
         GO TO 280
      ELSE
         DO 295 J = 1,Mvar
            NCOUNT = NCOUNT + 1
            GRADE(NCOUNT) = G(J)
 295     CONTINUE
      ENDIF
      GO TO 280

 900  IF (NUMHOL .LE. 1) GOTO 999 
      CLOSE (10) 
      CALL Erase (20, 2, 75) 
      RETURN 
 
C error has been found in data 
 999  if (numhol .le. 1) goto 1000
      Error          = .TRUE. 
      CLOSE (10) 
cclong replacing the ndata, nva lines below
cc    with
      CALL putstr (
     &     'Error in data file! Type "c" to continue anyway:',50,20,2,0)
      call getthekey(i)
      if (char(i) .eq. 'c' .or. char(i) .eq. 'C') then
         error = .false.
         goto 900
      end if
 1000 CALL Erase Field ('GR XVAR   ') 
      CALL Erase Field ('GR YVAR   ')
      CALL Erase Field ('GR ZVAR   ') 
      Ndata = 0
      Nva  = 0
C     NxCells = 0 
C     NyCells = 0 
      CALL Erase (20, 2, 75) 
      RETURN 
      END 

