clarge
C
C Process.for
C----------------------------------------------------------------------
C Perform Process - perform application-specific functions for KRIGE
C
        SUBROUTINE Perform Process (Field Name, Error, Repaint)
        IMPLICIT INTEGER*4 (A-Z)
        PARAMETER (Alpha Field     = 0)
        PARAMETER (Integer Field   = 1)
        PARAMETER (Real Field      = 2)
        PARAMETER (Toggle Field    = 5)

       include'cokrig.inc'
       include'../common/screen.str'

        COMMON          /GRVAR/ OldXvar, OldYvar

        CHARACTER       Message*75, Blanks*14, OldFile*14, FileName*65
        CHARACTER*10    Field Name, Dummy, Return Field
        CHARACTER*13    Scratch, Num*1
        INTEGER*4       Fld Index, Index of Field, Field Type
        INTEGER*4       LENSTR, Position, J, OldXvar, OldYvar
        INTEGER*4       Pos
        LOGICAL         Error,  Repaint, PutMessage
        LOGICAL         Started, Fexist,Drap
        LOGICAL       GetYesNo, OverWrite
        REAL*4          Temp

ccc        DATA MainMenu   /'MAINMENU  '/
        DATA Started    /.FALSE./

C initialize
        Error           = .FALSE.
        Repaint         = .FALSE.
        PutMessage      = .FALSE.
        OverWrite       = .TRUE.
        FExist          = .FALSE.
        Drap            = .FALSE.
        Index of Field  = Fld Index (Field Name)
        Return Field    = SC Field Name (Next Field)
        Field Type      = SC Field Type (Index of Field)
        Pos             = 0
        Message         = ' '

C Get a real value, or toggle position
        IF (Field Type .EQ. Real Field) THEN
           CALL Get 4 Floating Point Value (Field Name, Temp)
        ELSE IF (Field Type .EQ. Toggle Field) THEN
           CALL Get Toggle Value (Field Name, Position, Dummy)
        ELSE IF (Field Type .EQ. Alpha Field) THEN
           CALL Get Character Value (Field Name, Message)
           CALL Left Justify (Message)
           CALL Set Character Value (Field Name, Message)
        ENDIF

c----------------------------------------------------------------------
c get file prefix
        IF     (Field Name .EQ. 'FILEPREFIX') THEN
          CALL Get Character Value (Field Name, File Prefix)

C----------------------------------------------------------------------
C get parameter file name, write parameters
        ELSEIF (Field Name .EQ. 'OPARFILE  ') THEN
          CALL Get Character Value (Field Name, OParFile)
          CALL Get File Name (File Name, File Prefix, OParFile, Fexist)
          IF (Fexist) OverWrite =
     +       GetYesNo (20, 2,'OverWrite existing file? <Y/N> ')
          IF (OverWrite) THEN
             CALL Save Parameters (File Name, Error)
             IF (Error) THEN
                CALL Blank File (Field Name, OparFile)
                Message = 'Parameters NOT saved... (press any key)'
             ELSE
                CALL Flash (20, 2, 'Parameters saved... (press a key)')
             ENDIF
          ELSE
             CALL Blank File (Field Name, OparFile)
          ENDIF

c----------------------------------------------------------------------
C get parameter file name, read parameters
        ELSEIF (Field Name .EQ. 'IPARFILE  ') THEN
          CALL Get Character Value (Field Name, IParFile)
          CALL Get File Name (File Name, File Prefix, IParFile, Fexist)
          IF (Fexist .and. lenstr(iparfile) .ne. 0) THEN
            CALL Read Parameters (File Name, Error)
            IF (Error) THEN
               CALL ReInitialize
               CALL Display Fields
               Message = 'ERROR in parameter file... (press any key)'
            ELSE
               CALL Set Character Value ('FILEPREFIX', File Prefix)
               CALL Display One Field   ('FILEPREFIX')
               CALL Get File Name (File Name, File Prefix,
     +                   Data File, Fexist)
               IF (.NOT. Fexist) THEN
                  Error = .TRUE.
                  Message =
     +           'ERROR - Data file '//Data File//' not found'
                  CALL Blank File (Field Name, Data File)
                  CALL Reinitialize
               ELSE
                  CALL Read Header Data (File Name,  Error)
                  IF (Error) THEN
                    Message =
     +             'ERROR reading header data in '//Data File
                   CALL Blank File (Field Name, Data File)
                   CALL ReInitialize
                  ELSE
                  CALL Read Coordinate Values (Error)
                  IF (Error) THEN
                    Message =
     +             'ERROR reading coordinate data in '//Data File
                    CALL Blank File (Field Name, Data File)
                    CALL Reinitialize
                  ELSE
                      CALL Assign Screen Fields
                   CALL Flash (20,2,'Parameters loaded (press any key)')
                  ENDIF
                  ENDIF
               ENDIF
            ENDIF
          ELSE
            CALL Flash (20, 2,
     +      'Parameter file not found... (press a key)')
            CALL Blank File (Field Name, IparFile)
          ENDIF
C NABIL
c Get the dimension of the spatial coordinates and number of
c variables to be cokgriged...
         ELSEIF (Field Name .EQ. 'DIMEN     ') THEN
           CALL Get Integer Value (Field Name, K)
           IF (K .LT. 1 .OR. K .GT. 3) THEN
              Error = .TRUE.
              Message = 'Dimension between 1 and 3 (Press a key)'
              Return Field = Field Name
           ELSE
              Dimen = K
              call Set Integer Value (Field Name, K)
           ENDIF

        ELSEIF (Field Name .EQ. 'VARK      ') THEN
           CALL Get Integer Value (Field Name, K)
           IF (K .LT. 1 .OR. K .GT. 4) THEN
              Error = .TRUE.
              Message = 'MAX. VARIABLES TO BE COKRIGED BETWEEN
     + 1 AND 4 (PRESS A KEY))'
              Return Field = Field Name
           ELSE
              MVAR  = K
              call Set Integer Value (Field Name, K)
           ENDIF

C----------------------------------------------------------------------
C get data file name, read header data
        ELSEIF (Field Name .EQ. 'DATAFILE  ') THEN

          IF (Started) Old File = Data File
          CALL Get Character Value (Field Name, Data File)
          CALL Get FileName (File Name, File Prefix, Data File, Fexist)
          IF (Old File .EQ. Data File .AND.
     +           Data File (1:1) .EQ. ' ') THEN
                Return Field = 'OPTIONS   '
                GOTO 80
          ENDIF
          IF (.NOT. Fexist) THEN
             Error = .TRUE.
             Message = 'ERROR - '//Data file//' not found'
             Return Field = 'OPTIONS   '
             CALL Blank File (Field Name, Data File)
             CALL Reinitialize
             CALL Display Fields
          ELSE
          CALL Read Header Data (File Name,Error)
            IF (Error) THEN
              CALL Flash (20, 2,
     +          'ERROR reading header data in '//Data File)
              Error = .FALSE.
              CALL Blank File (Field Name, Data File)
              CALL ReInitialize
              CALL Display Fields
              Return Field = 'OPTIONS   '
            ELSE

C Set up defaults for the run
              Started = .TRUE.
              CALL Display One Field  ('GR XVAR   ')
              CALL Display One Field  ('GR YVAR   ')
              CALL Display One Field  ('GR ZVAR   ')
              K = Index (Data File, '.')
              IF (K .NE. 0) THEN
                 K = AMIN0 (K, 9)
              ELSE
                 L = LENSTR (Data File)
                 K = AMIN0 (L, 9)
              ENDIF
              OutFile = Data File (1:K-1)//'.out'
              CALL Set Character Value ('OUTFILE   ', OutFile)
              IparFile = Data File (1:K-1)//'.cpf'
              OparFile = IparFile
              CALL Set Character Value ('IPARFILE  ', IparFile)
              CALL Set Character Value ('OPARFILE  ', OparFile)
              PchFile = Data File (1:K-1)//'.grd'
              CALL Set Character Value ('PCHFILE   ', PchFile)
              CALL Display One Field ('OUTFILE   ')
              CALL Display One Field ('PCHFILE   ')
              Title = OutFile//' - cross-validation of data from '
     +           //Data File
              CALL Set Character Value ('OUTTITLE  ', Title)
              CALL Display One Field   ('OUTTITLE  ')
            ENDIF
          ENDIF
c RENDUO

          Else if (Field Name .EQ. 'SW IDBUG  ') Then
            Call Get Integer Value (Field Name, K)
            IDBUG = K
            Call Set Integer Value (Field Name, K)
          Else if (Field Name .EQ. 'SW ILIST  ') Then
            Call Get Integer Value (Field Name, K)
            ILIST = K
            Call Set Integer Value (Field Name, K)
         ELSEIF (Field Name .EQ. 'TY KRIGE  ') THEN
            Call Get Integer Value (Field Name, K)
            IDUAL = K
            Call Set Integer Value (Field Name, K)
         ELSEIF (Field Name .EQ. 'TY PTBLOCK') THEN
            Call Get Integer Value (Field Name, K)
            IPKRIG = K
            Call Set Integer Value (Field Name, K)
          Else if (Field Name .EQ. 'TY NPX    ') Then
            Call Get Integer Value (Field Name, K)
            NPX = K
            IF (K .EQ. 0) NPX = 1
            Call Set Integer Value (Field Name, NPX)
         ELSEIF (Field Name .EQ. 'TY NPY    ') THEN
            Call Get Integer Value (Field Name, K)
            NPY = K
            IF (K .EQ. 0) NPY = 1
            Call Set Integer Value (Field Name, NPY)
         ELSEIF (Field Name .EQ. 'TY NPZ    ') THEN
            Call Get Integer Value (Field Name, K)
            NPZ = K
            IF (K .EQ. 0) NPZ = 1
            Call Set Integer Value (Field Name, NPZ)
C
C----------------------------------------------------------------------
C get the polygon file name
C        ELSEIF (Field Name .EQ. 'POLYFILE  ') THEN
C          CALL Get Character Value (Field Name, PolyFile)
C          CALL Get File Name (File Name, File Prefix, PolyFile, Fexist)
C          IF (.NOT. Fexist .OR. PolyFile (1:1) .EQ. ' ') THEN
C             CALL Flash (20, 2, 'File not found... (press a key)')
C             CALL Blank File (Field Name, Poly File)
C          ENDIF
C
CC----------------------------------------------------------------------
C*******Get the estimates file name.
        ELSEIF (Field Name .EQ. 'OUTFILE   ') THEN
          CALL Get Character Value (Field Name, OutFile)
          CALL Left Justify (OutFile)
          CALL Get File Name (File Name, File Prefix, OutFile, Fexist)
          IF (Fexist) OverWrite =
     +       GetYesNo (20, 2,'OverWrite existing file? <Y/N> ')
          IF (.NOT. OverWrite .OR. OutFile (1:1) .EQ. ' ') THEN
             CALL Flash (20, 2, 'Press any key to try again')
             Return Field = Field Name
          ENDIF
C*******Get the punch file name.
        ELSEIF (Field Name .eq. 'PCHFILE   ') then
          CALL Get Character Value (Field Name, Pchfile)
          CALL Left Justify (Pchfile)
          CALL Get File Name (File Name, File Prefix, Pchfile, Fexist)
          IF (Fexist) OverWrite =
     +       GetYesNo (20, 2,'OverWrite existing file? <Y/N> ')
          IF (.NOT. OverWrite .OR. OutFile (1:1) .EQ. ' ') THEN
            CALL Flash (20, 2, 'Press any key to try again')
            Return Field = Field Name
          ENDIF
C-NAB----------------------------------------------------------

        ElseIf (Field Name (1:2) .EQ. 'SE') Then
          If (Field Name .EQ. 'SE RADIIA  ') Then
            If (Temp .LE. 0.0) Then
               Error = .TRUE.
               Message = 'Axis length must be > 0 - (press any key)'
               Temp = RADIIA
               Return Field = Field Name
            Else
              RADIIA = Temp
              If (character .EQ. 13) Then
                 Dummy = 'SE RADIIB  '
                 Call Get Character Value (Dummy , Scratch)
                 If (Scratch .EQ. '             ' .OR. RADIIB .GT.
     +               RADIIA) Then
                   RADIIB =RADIIA
                   Call set  4Floating Point Value (Dummy, RADIIB, 3)
                 End if
              End if
              If (Character .EQ. 13) Then
                 Dummy = 'SE RADIIC  '
                 Call Get Character Value (Dummy, Scratch)
                 If (Scratch .EQ. '              ' .OR.
     +           RADIIC .GT. RADIIB) Then
                   RADIIC = RADIIB
                   Call Set 4Floating Point Value (Dummy, RADIIC, 3)
                 End if
              End if
            End if
          Else if (Field Name .EQ. 'SE RADIIB  ') Then
            If (Temp .LE. 0.0) Then
              Error = .TRUE.
              Message = 'Axis length must be > 0 - (press any key)'
              Temp = RADIIB
              Return Field = Field Name
            Else if (Temp .GT. RADIIA) Then
              Error = .TRUE.
              Message = 'Minor axis may not be greater than major -
     +        (press any key)'
              Temp = RADIIB
              Return Field = Field Name
            Else
              RADIIB = Temp
              If (Character .EQ. 13) Then
                Dummy = 'SE RADIIC  '
                Call Get Character Value (Dummy, Scratch)
                If (Scratch .EQ. '              ' .OR.
     +          RADIIC .GT. RADIIB) Then
                  RADIIC = RADIIB
                  Call set 4Floating Point Value (Dummy, RADIIC, 3)
                End if
              End if
            End if
          Else if (Field Name .EQ. 'SE RADIIC  ') Then
            If (Temp .LT. 0.0) Then
              Error = .TRUE.
              Message = 'Axis length must be .GE. 0 - (press any key)'
              Temp = RADIIC
              Return Field = Field Name
            Else if (Temp .GT. RADIIB) Then
              Error = .TRUE.
              Message = 'Minor c may not be greater than minor b -
     +        (press any key)'
              Temp = RADIIC
              Return Field = Field Name
            Else
c   define AFF1, AFF2.
              RADIIC = Temp
              IF (DIMEN .LT. 3) RADIIC = 0.0
              IF (RADIIB .GT. 0.0) THEN
                AFF1 = RADIIA/RADIIB
              ELSE
                AFF1 = 0.0
              END IF
              IF (RADIIC .GT. 0.0) THEN
                AFF2 = RADIIA/RADIIC
              ELSE
                AFF2 = 0.0
              ENDIF
            End if
          Else if (Field Name .EQ. 'SE DIP     ') Then
            If (Temp .LT. 0.0 .OR. Temp .GE. 180.0) Then
              Error = .TRUE.
              Message = 'Angle must be .GE. 0 and .LT. 180 -
     +        (press any key)'
              Temp = 0.0
              DIP  = 0.0
              Return Field = Field Name
            Else
c   define Cos and Sin
              DIP = Temp
              SDIP = SIN(DIP * RADCON)
              CDIP = COS(DIP * RADCON)
            End if
          Else if (Field Name .EQ. 'SE AZMUTH  ') Then
            If (Temp .LT. 0.0 .OR. Temp .GE. 180.0) Then
              Error = .TRUE.
              Message = 'Angle must be .GE. 0 and .LT. 180 -
     +        (press any key)'
              Temp = 0.0
              Return Field = Field Name
            Else
C DEFINE SIN & COS
              AZMUTH = Temp
              SAZM = SIN(AZMUTH * RADCON)
              CAZM = COS(AZMUTH * RADCON)
            End if
          Else if (Field Name .EQ. 'SE MINHOL  ') Then
            Call Get Integer Value (Field Name, K)
            If (K .GE. 0 .AND. K .LE. INT(NTS/Nva)) Then
              MINHOL = K
              Call set Integer Value (Field Name, MINHOL)
            Else
              Error = .TRUE.
              Message = 'Minimum number of holes must be .GE. 0 and
     +.LE. Maximun numb. (press any key)'
              K = MINHOL
              Return Field = Field Name
            End if
          Else if (Field Name .EQ. 'SE MAXHOL  ') Then
            Call Get Integer Value (Field Name, K)
            If (K .GE. 0) Then
              If (K .LT. MINHOL) Then
               Error = .TRUE.
               Message = 'Max. holes must be .GE. Min holes - (press
     + any key )'
               K = MAXHOL
               Return Field = Field Name
              Else
               MAXHOL = K
               INTEST = NTS/NVA
               IF (MAXHOL .GT. INTEST) MAXHOL = INTEST
               Call Set Integer Value (Field Name, MAXHOL)
              End If
            Else
              Error = .TRUE.
              Message = 'Max number of holes must be .GE. 0 -
     +        (press any key)'
              K = MAXHOL
              Return Field = Field Name
            End if
          End if

C----------------------------------------------------------------------
C get the grid options
        ELSEIF (Field Name (1:2) .EQ. 'GR') THEN
           IF (Field Name .EQ. 'GR XVAR    ') THEN
              OldXvar = ICX
              ICX = Position + 1
           ELSE IF (Field Name .EQ. 'GR YVAR    ') THEN
              OldYvar = ICY
              ICY = Position + 1
              IF (ICX .EQ. ICY) THEN
                 Error   = .TRUE.
                 Message = 'ERROR - X and Y must be different  '
                 Return Field = 'GR XVAR   '
            End if
C-NAB------------------------------------------------------------------
c NAB  get the grid options
          Else if (Field Name .EQ. 'GR ZVAR    ')Then
            If (Dimen .EQ. 3) Then
              OldZvar = ICZ
              ICZ = Position + 1
            End if
            If (ICX .EQ. ICZ .OR. ICY .EQ. ICZ) Then
              Error =.TRUE.
              Message = 'Error - X and Y and Z must be
     +        different variables'
              Return Field = 'GR XVAR    '
            Else if (OldXvar .NE. ICX .AND. OldYvar .NE. ICY .AND.
     +               OldZvar .NE. ICZ .OR. Ndata .EQ. 0) Then
              OldXvar = ICX
              OldYvar = ICY
              OldZvar = ICZ
             Call Read Coordinate Values(Error)
             If (Error) Then
               Call Beep
               Message =
     +           'Error reading coordinate values from  ' // Data File
               Call Blank File (Field Name, Data File)
               Call ReInitialize
               Call Display Fields
               Return Field = 'OPTIONS'
             Else
               Call Display Fields
             End if
            End if
          Else if (Field Name .EQ. 'GR XORG    ') Then
            XEAST = Temp
          Else if (Field Name .EQ. 'GR YORG    ') Then
            YNORTH = Temp
          Else if (Field Name .EQ. 'GR ZORG    ') Then
            ZELEV = Temp
          Else if (Field Name .EQ. 'GR XCSIZE  ') Then
            If (Temp .GT. 0.0) Then
              XLBL = Temp
            Else
              Error = .TRUE.
              Message = 'X cell size must be > 0 (Press a key)'
              Temp = XLBL
              Return Field = Field Name
            End if
          Else if (Field Name .EQ. 'GR YCSIZE  ') Then
            If (Temp .GT. 0.0) Then
              YLBL = Temp
            Else
              Error = .TRUE.
              Message = 'Y cell size must be > 0 (press a key)'
              Temp = YLBL
              Return Field = Field Name
            End if
          Else if (Field Name .EQ. 'GR ZCSIZE  '.AND.
     +             Dimen .GT. 2) Then
            If (Temp .GE. 0.0) Then
              ZLBL = Temp
            Else
              Error = .TRUE.
              Message = 'Z cell size must be .GE. 0 (press a key)'
              Temp = ZLBL
              Return Field = Field Name
            End if
          Else if (Field Name .EQ. 'GR NSE     ') Then
            Call Get Integer Value (Field Name, K)
            IF (K .GT. 0) Then
              NSE = K
              Call Set Integer Value (Field Name, K)
            Else
              Error = .TRUE.
              Message = 'Number between 1 and 9 (press a key)'
              K = NSE
              Return Field = Field Name
            End if
          Else if (Field Name .EQ. 'GR NSN     ') Then
            Call Get Integer Value (Field Name, K)
            If (K .GT. 0)Then
              NSN = K
              Call Set Integer Value (Field Name, K)
            Else
              Error = .TRUE.
              Message = 'Number between 1 and 9 (press a key)'
              K = NSN
              Return Field = Field Name
            End if

          Else if (Field Name .EQ. 'GR NSB     ') Then
            Call Get Integer Value (Field Name, K)
            If (K .GT. 0)Then
              NSB = K
              Call Set Integer Value (Field Name, K)
            Else
              Error = .TRUE.
              Message = 'Number between 1 and 9 (press a key)'
              K = NSB
              Return Field = Field Name
            End if

          Else if (Field Name .EQ. 'GR NFE     ') Then
            Call Get Integer Value (Field Name, K)
            If (K .LT.  NSE) Then
              Error = .TRUE.
              Message = 'Finishing block must be .GE. starting one -
     +        (press a key)'
              Return Field = Field Name
            Else
              NFE = K
              Call Set Integer Value (Field Name, K)
            End if
          Else if (Field Name .EQ. 'GR NFN     ') Then
            Call Get Integer Value (Field Name, K)
            If (K .LT. NSN) Then
              Error = .TRUE.
              Message = 'Finishing block must be .GE. Starting one -
     +        (press a key)'
              Return Field = Field Name
            Else
              NFN = K
              Call Set Integer Value (Field Name, K)
          End if
          Else if (Field Name .EQ. 'GR NFB     ') Then
            Call Get Integer Value (Field Name, K)
            If (K .LT. NSB) Then
              Error = .TRUE.
              Message = 'Finishing block must be .GE. starting one -
     +        (press a key)'
              Return Field = Field Name
            Else
              NFB = K
              Call Set Integer Value (Field Name, K)
            End if
            If (Dimen .LT. 3) Then
              NFB = 1
              NSB = 1
            End if
          End if

C----------------------------------------------------------------------
C NAB
C get the variograms parameters
        Else if (Field Name .EQ. 'VRM ENTRY   ') Then
           Call Get Integer Value (Field Name, K)
           If (K .LT. 1) Then
              Error = .TRUE.
              Message ='Matrix entries are Gt zero. (Press a key)'
              Return Field = Field Name
           Else
              ITH = K
              Call Set Integer Value (Field Name, ITH)
           End if
        Else If (Field Name .EQ. 'VRM CROSS  ') Then
           Call Get Integer Value (Field Name, K)
              Do 19 j = 1, (MVAR + 1)
                 If (ITH .EQ. NDG(J)) Then
                    Drap = .TRUE.
                 End if
 19           Continue
           If ((K .GT. 0) .AND. (Drap .EQV. .TRUE.)) Then
              Error =.TRUE.
              Message = 'Matrix entry is not for crossvariogram.(Press
     + a key)'
              Return Field = Field Name
           Else if ((K .EQ. 0) .AND. (Drap .EQV. .FALSE.)) Then
              Error = .TRUE.
              Message = 'A crossvariogram is relevant . (Press a key)'
              Return Field = Field Name
           Else
              NTYPCS (ITH) = K
              Call Set Integer Value (Field Name, K)
           End if
           Drap = .FALSE.
        Else if (Field Name .EQ. 'VRM NEST   ') Then
           Call Get Integer Value (Field Name, K)
           If (K .LT. 1 .OR. K .GT. MAXN) Then
              Error = .TRUE.
              Message = 'Number Nested Models Between 1 and MAXN. (Pres
     +s a key)'
              Return field = Field Name
           Else
              NEST(ITH) = K
              Call Set Integer Value(Field Name, K)
ccc              NESTP(ITH) = (ITH - 1)*5
              NESTP(ITH) = (ITH - 1)*maxn
           End if
        Else if (Field Name .EQ. 'VRM SILL   ') Then
              Do 91 j = 1, (MVAR + 1)
                 If (ITH .EQ. NDG(J)) Then
                    Drap = .TRUE.
                 End if
 91           Continue
           If (Temp .LT. 0 .AND. (DRAP .EQV. .TRUE.)) Then
              Error = .TRUE.
              Message = 'For variograms sill is positive. (Press a key)'
              Return Field = Field Name
           Else
              SILL(ITH) = Temp
           End if
           DRAP = .FALSE.
        Else if (Field Name .EQ. 'VRM NUM    ') Then
           Call Get Integer Value (Field Name, K)
           If (K .LE. 0 .OR. K .GT. NEST(ITH)) Then
              Error = .TRUE.
              Message = 'Model number is out of range. (Press a key)'
              Return Field = Field Name
           Else
              NP = NESTP(ITH) + K
              Call Set Integer Value(Field Name, K)
              count = count + 1
           End if
        Else if (Field Name .EQ. 'VRM TYPE   ') Then
           Call Get Integer Value (Field Name, K)
           If (K .LT. 1 .OR. K .GT. 17) Then
              Error = .TRUE.
              Message = 'Type out of range 1-17. (Press a key)'
              Return Field = field Name
           Else
              NVTYPE(NP) = K
              Call Set Integer Value (Field Name, K)
           End if
        Else if (Field Name .EQ. 'VRM SIGN   ') Then
           If (NTYPCS(ITH) .EQ. 3) Then
              If (Position .EQ. 0) Then
                 NSIGN(NP)= 1
              Else
                 NSIGN(NP) = -1
              End if
           End if

        Else if (Field Name .EQ. 'VRM CILL   ') Then
              Do 11 j = 1, (MVAR + 1)
                 If (ITH .EQ. NDG(J)) Then
                    Drap = .TRUE.
                 End if
 11           Continue
           If (Temp .LT. 0 .AND. (DRAP .EQV. .TRUE.)) Then
              Error = .TRUE.
              Message = 'For variograms sill is positive. (Press a key)'
              Return Field = Field Name
           Else
              C(NP) = Temp
           End if
           DRAP = .FALSE.
        ElseIf (Field Name .EQ. 'VRM RANGEA ') Then
           If(NVTYPE(NP) .EQ. 1) THEN
            RANGEA=0.0
            RANGEB=0.0
            RANGEC=0.0
           ELSE
            If (Temp .LE. 0.0) Then
               Error = .TRUE.
               Message = 'Axis length must be > 0 - (press any key)'
               Temp = AAXIS(NP)
               Return Field = Field Name
            Else
              AAXIS(NP) = Temp
              If (character .EQ. 13) Then
                 Dummy = 'VRM RANGEB '
                 Call Get Character Value (Dummy , Scratch)
                 If (Scratch .EQ. '             ' .OR. BAXIS(NP).GT.
     +               AAXIS(NP)) Then
                   BAXIS(NP) =AAXIS(NP)
                   Call set  4Floating Point Value (Dummy, BAXIS(NP), 3)
                 End if
              End if
              If (Character .EQ. 13) Then
                 Dummy = 'VRM RANGEC '
                 Call Get Character Value (Dummy, Scratch)
                 If (Scratch .EQ. '              ' .OR.
     +           CAXIS(NP) .GT. BAXIS(NP)) Then
                   CAXIS(NP) = BAXIS(NP)
                   Call Set 4Floating Point Value (Dummy, CAXIS(NP), 3)
                 End if
              End if
            End if
           ENDIF
        Else if (Field Name .EQ. 'VRM RANGEB ') Then
           If(NVTYPE(NP) .EQ. 1) THEN
            RANGEA=0.0
            RANGEB=0.0
            RANGEC=0.0
           ELSE
            If (Temp .LE. 0.0) Then
              Error = .TRUE.
              Message = 'Axis length must be > 0 - (press any key)'
              Temp = BAXIS(NP)
              Return Field = Field Name
            Else if (Temp .GT. AAXIS(NP)) Then
              Error = .TRUE.
              Message = 'Minor axis may not be greater than major -
     +        (press any key)'
              Temp = BAXIS(NP)
              Return Field = Field Name
            Else
              BAXIS(NP) = Temp
              If (Character .EQ. 13) Then
                Dummy = 'VRM RANGEC '
                Call Get Character Value (Dummy, Scratch)
                If (Scratch .EQ. '              ' .OR.
     +          CAXIS(NP) .GT. BAXIS(NP)) Then
                  CAXIS(NP) = BAXIS(NP)
                  Call set 4Floating Point Value (Dummy, CAXIS(NP), 3)
                End if
              End if
            End if
           ENDIF
        Else if (Field Name .EQ. 'VRM RANGEC ') Then
           If(NVTYPE(NP) .EQ. 1) THEN
            RANGEA=0.0
            RANGEB=0.0
            RANGEC=0.0
           ELSE
            If (Temp .LT. 0.0) Then
              Error = .TRUE.
              Message = 'Axis length must be .GE. 0 - (press any key)'
              Temp = CAXIS(NP)
              Return Field = Field Name
            Else if (Temp .GT. BAXIS(NP)) Then
              Error = .TRUE.
              Message = 'Minor c may not be greater than minor b -
     +        (press any key)'
              Temp = CAXIS(NP)
              Return Field = Field Name
            Else
c   define AFF1, AFF2.
              CAXIS(NP) = Temp
              IF (DIMEN .LT. 3) CAXIS(NP) = 0.0
              IF (BAXIS(NP) .GT. 0.0) THEN
                AFAOB(NP) = AAXIS(NP)/BAXIS(NP)
              ELSE
                AFAOB(NP) = 0.0
              END IF
              IF (CAXIS(NP) .GT. 0.0) THEN
                AFAOC(NP) = AAXIS(NP)/CAXIS(NP)
              ELSE
                AFAOC(NP) = 0.0
              ENDIF
            End if
           ENDIF
        Else if (Field Name .EQ. 'VRM DIP    ') Then
            If (Temp .LT. 0.0 .OR. Temp .GE. 180.0) Then
              Error = .TRUE.
              Message = 'Angle must be .GE. 0 and .LT. 180 -
     +        (press any key)'
              Temp = 0.0
              BETA(NP) = 0.0
              Return Field = Field Name
            Else
c   define Cos and Sin
              BETA(NP) = Temp
              SBETA(NP) = SIN(BETA(NP) * RADCON)
              CBETA(NP) = COS(BETA(NP) * RADCON)
C              If ( Count .LT. NEST(ITH)) Then
C                 Return Field = 'VRM NUM    '
C              End if
            End if
        Else if (Field Name .EQ. 'VRM AZMUTH ') Then
            If (Temp .LT. 0.0 .OR. Temp .GE. 180.0) Then
              Error = .TRUE.
              Message = 'Angle must be .GE. 0 and .LT. 180 -
     +        (press any key)'
              Temp = 0.0
              Return Field = Field Name
            Else
C DEFINE SIN & COS
              THETA(NP) = Temp
              STHETA(NP) = SIN(THETA(NP) * RADCON)
              CTHETA(NP) = COS(THETA(NP) * RADCON)
            End if

        Else if (Field Name .EQ. 'VRM VARIA  ') Then
            If (ITH .EQ. 1 ) THEN
              LOCAL = 1
              ICV(Local) = Position + 1
            ELSEIF(ITH .EQ. 3) THEN
              LOCAL = 2
              ICV(LOCAL) = POSITION + 1
            ELSEIF(ITH .EQ. 6) THEN
              LOCAL = 3
              ICV(LOCAL) = POSITION + 1
            ELSEIF(ITH .EQ. 10) THEN
              LOCAL = 4
              ICV(LOCAL) = POSITION + 1
            ELSE
              CALL FLASH(20,2,' NO SELECTION .PRESS ANY KEY')
            ENDIF

C----------------------------------------------------------------------
C get the Drift Parameters
C JERRY
        ELSEIF (Field Name(1:2) .EQ. 'DF') THEN
           IF (Field Name.EQ.'DF VAR    ') THEN
             Position = Position + 1
           ELSEIF (Field Name .EQ. 'DF NUM     ')THEN
             CALL GET INTEGER VALUE(FIELD NAME,K)
             IF(K.LT.1)THEN
               ERROR = .TRUE.
               MESSAGE = 'Variable Numbers are gt zero. (Press a key)'
               RETURN FIELD = FIELD NAME
             ELSE
               ITH = K
               if(ith.eq.1)then
                 ntermp(ith) = 0
                 nxcol = 0
               endif
               CALL SET INTEGER VALUE (FIELD NAME,ITH)
             ENDIF
           ELSEIF (FIELD NAME .EQ. 'DF TERM    ')THEN
             CALL GET INTEGER VALUE(FIELD NAME,K)
             IF(K.LT.1)THEN
               ERROR = .TRUE.
               MESSAGE = 'Number drift terms gt zero. (Press a key)'
               RETURN FIELD = FIELD NAME
             ELSE
               NTERM(ITH) = K
               nxcol = nxcol + k
               ntermp(ith+1) = ntermp(ith) + k
               CALL SET INTEGER VALUE (FIELD NAME,K)
             ENDIF
           ELSEIF (FIELD NAME .EQ. 'DF TERMI   ')THEN
             CALL GET INTEGER VALUE(FIELD NAME,K)
             IF(K.LT.1)THEN
               ERROR = .TRUE.
               MESSAGE = 'Drift term must be gt zero. (Press a key)'
               RETURN FIELD = FIELD NAME
             ELSE
               NP = NTERMP(ITH) + K
               CALL SET INTEGER VALUE(FIELD NAME,K)
             ENDIF
           ELSEIF (FIELD NAME .EQ. 'DF XEXPI   ')THEN
             IF(TEMP. LT. 0.0)THEN
               ERROR = .TRUE.
               MESSAGE = 'Exponent must be ge zero. (Press a key)'
               RETURN FIELD = FIELD NAME
             ELSE
               EX(NP) = TEMP
             ENDIF
           ELSEIF (FIELD NAME .EQ. 'DF YEXPI   ')THEN
             IF(TEMP .LT. 0.0)THEN
               ERROR = .TRUE.
               MESSAGE = 'Exponent must be ge zero. (Press a key)'
               RETURN FIELD = FIELD NAME
             ELSE
               EY(NP) = TEMP
             ENDIF
           ELSEIF (FIELD NAME .EQ. 'DF ZEXPI   ')THEN
             IF(TEMP .LT. 0.0)THEN
               ERROR = .TRUE.
               MESSAGE = 'Exponent must be ge zero. (Press a key)'
               RETURN FIELD = FIELD NAME
             ELSE
               EZ(NP) = TEMP
             ENDIF
           ENDIF
        ENDIF

C Set the real value at 3 decimal places
 80     IF (Field Type .EQ. Real Field) THEN
C           IF (Pos .NE. 0 .AND.
C     +           Mtype (Pos, Current Var) .EQ. 0) THEN
C              CALL Set Character Value (Field Name, '             ')
           IF (Field Name (1:8) .EQ. 'VM ANGLE') THEN
             CALL Set 4 Floating Point Value (Field Name, Temp, 2)
           ELSE
             CALL Set 4 Floating Point Value (Field Name, Temp, 3)
           ENDIF
        ENDIF

C write out field, in case an error caused it to be blanked out
        CALL Display One Field (Field Name)

C if an error occurred, put out the message
 90     IF (Error) CALL Flash (20, 2, Message)

C Set up Next Field to be processed
        Next Field = Fld Index (Return Field)
        RETURN
        END
