C Added.for
C**********************************************************************
C
C These routines were added to the SAM Screen subroutines for use by 
C   the GEOSTAT programs.
C
C**********************************************************************

	FUNCTION Lenstr (String)

	CHARACTER*(*) String
	
	n = LEN (String)
	DO 10 i = n, 1, -1
	   IF (String (i:i) .ne. ' ') THEN
	      Lenstr = i
	      RETURN
	   ENDIF
  10	CONTINUE
	Lenstr = 0
	END

C----------------------------------------------------------------------
C   Erase - erase N characters from Row, Column
C----------------------------------------------------------------------
	SUBROUTINE Erase (Row, Column, N)

	INTEGER*4       Row, Column, N
	CHARACTER*80	Blanks

	DATA Blanks(1:40) /'                                        '/
	DATA Blanks(41:80)/'                                        '/

	CALL Locate Cursor (Row, Column)
	CALL Put Characters (Blanks (1:N), N, 0)

	RETURN
	END

C----------------------------------------------------------------------
C   Flash - flash string Message at Row, Column, wait for keystroke
C----------------------------------------------------------------------
        SUBROUTINE Flash (Row, Column, Message)

        IMPLICIT INTEGER*4 (A-Z)

        CHARACTER*(*) Message

        CALL Locate Cursor (Row, Column)
        CALL Put Characters (Message, LEN(Message), 2)
 10     CALL getthekey (Key)
        if (key .eq. 666) then
           call graphics_message ()
           goto 10
        end if
        CALL Erase (Row, Column, LEN(Message))

        RETURN
        END

C----------------------------------------------------------------------
C   Flash - flash string Message at Row, Column, wait for keystroke
C----------------------------------------------------------------------
        SUBROUTINE Flashreal (Row, Column, x)

        IMPLICIT INTEGER*4 (A-Z)
        real x
        CHARACTER*50 message

        CALL Locate Cursor (Row, Column)
        write(message,*) x
        CALL Put Characters (Message, LEN(Message), 2)
 10     CALL getthekey (Key)
        if (key .eq. 666) then
           call graphics_message ()
           goto 10
        end if
        CALL Erase (Row, Column, LEN(Message))

        RETURN
        END

C----------------------------------------------------------------------
C   Get Menu Choice - returns string containing chosen item
C----------------------------------------------------------------------
	SUBROUTINE Get Menu Choice (Menu Name, Menu Choice)

	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'screen.str'        

	CHARACTER*(*)  Menu Name, Menu Choice

 	First Field = Fld Index (Menu Name)
 	Nitems = SC Members (First Field)
 	Last Field = First Field + Nitems
	Next Field = First Field
        
 10	IF (Next Field .GE. First Field .AND.
     +	    Next Field .LE. Last Field)  THEN
            CALL Get Field
        ELSE
            CALL Get Menu Value (Menu Name, Position, Menu Choice)
            RETURN   
        ENDIF
        GO TO 10
        END 

C----------------------------------------------------------------------
C   Put Menu - put out menu fields
C----------------------------------------------------------------------
        SUBROUTINE Put Menu (Menu Name)

	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'screen.str'

        CHARACTER*(*) Menu Name

        CALL Erase (22, 1, 78)
        CALL Erase (23, 1, 78)

        First Field = Fld Index (Menu Name)
        Last Field = First Field + SC Members (First Field)

        DO 10 Field = First Field+1, Last Field
            CALL Write Field (Field, SC Attribute(Field))
 10     CONTINUE

        RETURN
        END
    
C----------------------------------------------------------------------
C   Left Justify - Left Justify String
C----------------------------------------------------------------------
        SUBROUTINE Left Justify (String)
c blows up if already left justified.

        CHARACTER String*(*)

        N = LEN (String) 

	if (n .le. 1) return ! no sense trying to left justify that!
	IF (String (1:1) .ne. ' ') return ! already left justified!

        I = 1
 10     IF (String (I:I) .EQ. ' ') THEN
          I = I + 1
          GO TO 10
        ENDIF

        DO 20 J = 1, N-I+1
           K = J + I - 1
           String (J:J) = String (K:K)
 20     CONTINUE

        DO 30 K = J, N
           String (K:K) = ' '
 30	CONTINUE

        RETURN
        END 

C---------------------------------------------------------------------
C   Get Yes No - get a yes or no answer at Row, Column
C---------------------------------------------------------------------
        LOGICAL FUNCTION Get Yes No (Row, Column, Prompt)

        IMPLICIT INTEGER*4 (A-Z)

        CHARACTER*(*) Prompt
        
        CALL Locate Cursor (Row, Column)
        CALL Put Characters (Prompt, LEN(Prompt), 0)
 10     CALL getthekey (Key)
        if (key .eq. 666) then
           call graphics_message ()
           goto 10
        end if
        IF (Key .EQ. ICHAR('Y') .OR. Key .EQ. ICHAR('y')) THEN
           Get Yes No = .TRUE.
        ELSE
           Get Yes No = .FALSE.
        END IF
        CALL Erase (Row, Column, LEN(Prompt))

        RETURN
        END

C---------------------------------------------------------------------
C   Toggle - gets toggle value and returns toggle position
C---------------------------------------------------------------------
	INTEGER*4 FUNCTION Toggle (Field Name)

	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'screen.str'

	CHARACTER Field Name*(*), Dummy*70 

	Next Field = Fld Index (Field Name)
	CALL Get Field
	CALL Get Toggle Value (Field Name, Position, Dummy)                
	Toggle = Position

	RETURN
	END

C---------------------------------------------------------------------
C   Load Toggle Values - loads toggle members into a toggle field
C
C   Name:             name of toggle field
C   Length:           maximum length of a member
C   Member Total:     maximum number of toggle members permitted
C   Variable List:    list of toggle members
C   Toggle Position:  0 is the first position
C---------------------------------------------------------------------
	SUBROUTINE Load Toggle Values (Name, Length, Member Total,
     +	                             Variable List, Toggle Position)

	IMPLICIT INTEGER*4 (A-Z)
	
	INCLUDE'screen.str'

	CHARACTER*(*)  Variable List (1), Name
	CHARACTER*10   Value

 	Field = FLD Index(Name)
 	IF (Field .EQ. 0) RETURN

	SC Members (Field) = Member Total
	DO 10 Position = 0, Member Total - 1
	   Value = Variable List (Position + 1)
	   CALL Set Toggle Value(Name, Position, Value)
  10	CONTINUE
	SC Position (Field) = Toggle Position

	RETURN
	END

C---------------------------------------------------------------------
C   Put Str - places a character string at Row, Col
C
C   Ch:   character string to be placed
C   Len:  length of character string
C   Row:  row position
C   Col:  column position
C   Att:  attribute (normal, blinking, bold, etc.)
C---------------------------------------------------------------------
       SUBROUTINE Put Str (Ch, Len, Row, Col, Att)

       CHARACTER*(*)  Ch
       INTEGER*4      Len, Row, Col, Att

       CALL Locate Cursor (Row, Col)
       CALL Put Characters (Ch, Len, Att)

       RETURN
       END

C---------------------------------------------------------------------
C   SCnumber - returns the screen number for a given field index
C---------------------------------------------------------------------
	INTEGER*4 FUNCTION SCnumber (Field)

	INTEGER*4 Field, i

	INCLUDE 'screen.str'

	SCnumber = 0
	DO 10 i = 1, Total Number of Screens
	   IF (Field .GE. Begin Screen (i) .AND. 
     +         Field .LE. End Screen (i)) THEN
               SCnumber = i
               RETURN
	   ENDIF
 10	CONTINUE

	RETURN
	END

C----------------------------------------------------------------------
C   Set Toggle Position - sets the position of the toggle field
C----------------------------------------------------------------------
	SUBROUTINE Set Toggle Position (Name, Position)

	IMPLICIT INTEGER*4   (A-Z)

	INCLUDE 'screen.str'

 	CHARACTER*(*) Name 

	Field = Fld Index (Name)
	IF (Field .LE. 0 .OR.
     +      Field .GT. End Screen (Total Number of Screens)) RETURN
	IF (Position .LT. 0 .OR.
     +      Position .Ge. SC Members (Field)) RETURN
        SC Position (Field) = Position
	
	RETURN
	END    
   

C----------------------------------------------------------------------
C  Erase Field - Erase a field, given the name
C----------------------------------------------------------------------
	SUBROUTINE Erase Field (Name)

	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'screen.str'

	CHARACTER 	Name*(*)
	INTEGER*4	Fld Index, Field

	Field = Fld Index (Name)
	IF (Current Screen .LE. 0 .OR. Field .LE. 0) RETURN

	IF (Field .GE. Begin Screen (Current Screen) .AND.
     +      Field .LE. End Screen   (Current Screen)) THEN                              Number of Screens)) RETURN
            CALL Erase (SC Row (Field), SC Column (Field), 
     +                                  SC Length (Field))
	ENDIF
	RETURN
	END

C----------------------------------------------------------------------
C Set Menu Position - set the position of a Menu field
C----------------------------------------------------------------------
	SUBROUTINE Set Menu Position (Name, Position)

	INCLUDE 'screen.str'

	CHARACTER 	Name*(*)
	INTEGER*4	Position, Field, Fld Index

	Field = Fld Index (Name)
	IF (Field .LE. 0 .OR. 
     +      Field .GT. End Screen (Total Number of Screens)) RETURN

	IF (Position .LT. 0 .OR. 
     +      Position .GE. SC Members (Field)) RETURN

	IF (SC Field Type (Field) .NE. 3) RETURN

	SC Position (Field) = Position
	RETURN
	END

C------------------------------------------------------------------------
C Build File Name
C----------------------------------------------------------------------
	SUBROUTINE Build File Name (Name1, File Name, Extension)
	CHARACTER	Name1*(*), File Name*(*), Extension*4
	INTEGER*4	LENSTR, K

	K = Index (Name1, '.')
	IF (K .NE. 0) THEN
	   K = AMIN0 (K, 9)
	ELSE
	   L = LENSTR (Name1)+1
	   K = AMIN0 (L, 10)
	ENDIF
	File Name = Name1 (1:K-1)//Extension
	RETURN
	END

C----------------------------------------------------------------------
C Get File Name, builds a file name
C----------------------------------------------------------------------

	SUBROUTINE Get File Name (File Name, File Prefix,
     +			          File, Fexist)

	CHARACTER 	File Name *(*), File Prefix*(*), File*(*)
	LOGICAL 	Fexist
	INTEGER*4	N, LENSTR

	CALL Left Justify (File)
	N = LENSTR (File Prefix)
	IF (N .GT. 0) THEN 
	   File Name = File Prefix (1:N) // File
	ELSE
	   File Name = File
	ENDIF
cclong
cc the inquire function doesn't seem to work, especially with .* files
cc	INQUIRE (FILE = FileName, EXIST = Fexist)  
cc      RETURN
cc	END
        fexist = .false.
	open(71, FILE = FileName,status='old', Err = 666)  
        fexist = .true.
 666    close(71)
        RETURN
	END

C----------------------------------------------------------------------
C Blank File - blanks a file name and field
C----------------------------------------------------------------------
	SUBROUTINE Blank File (Field Name, File Name)
	CHARACTER 	Field Name*10, File Name*(*)

	File Name = ' '
        CALL Set Character Value (Field Name, File Name)   
	RETURN
	END	


