#include <stdio.h>

#define DEFAULT_FONT "-adobe-courier-bold-r-normal--12*"
#define DEFAULT_TITLE "Xgeo-Ease"
#define DEFAULT_DISPLAY "unix:0.0"
#define DEFAULT_GEOMETRY "550x450+0+0"

/* -adobe-courier-bold-o-normal--10-100-75-75-m-60-iso8859-1 */

extern int	  theFontNameOverride;
extern int	  theGeometryOverride;

int iconicState;
getArguments(argc, argv, theDisplayName, theGeometry, theFontName, theTitle)

int argc;
char *argv[];
char theDisplayName[];
char theGeometry[];
char theFontName[];
char theTitle[];

{
  int argCounter;
  
  /*
    set up defaults
    */
  
  strcpy(theDisplayName,DEFAULT_DISPLAY);
  strcpy(theGeometry,DEFAULT_GEOMETRY);
  strcpy(theFontName, DEFAULT_FONT);
  strcpy(theTitle, DEFAULT_TITLE);
  iconicState=0;
  
  /*
   *check if user wants a different display
   */
  for(argCounter=0;argCounter<argc;argCounter++)
    { 
      if(strncmp(argv[argCounter],"-display", 8)==0)
	{
	  argCounter++;
	  if(argCounter<argc)
	    strcpy(theDisplayName,argv[argCounter]);
	  else
	    fprintf(stderr, "ERROR: the -display option should be %s\n",
		    "followed by a display name.");
	}
      
      if(strncmp(argv[argCounter],"-geome",5)==0)
	{
	  argCounter++;
	  if(argCounter<argc)
	    {
	      strcpy(theGeometry,argv[argCounter]);
	      theGeometryOverride=1;
	    } 
	  else 
	    {
	      fprintf(stderr,
		      "ERROR: the -geometry option should be %s\n",
		      "e.g, 600x600+200+200 for");
	      fprintf(stderr,"size 600x600, %s\n","position (200,200).");
	    }
	}
      
      if(strncmp(argv[argCounter],"-title",5)==0)
	{
	  argCounter++;
	  if(argCounter<argc)
	    strcpy(theTitle,argv[argCounter]);
	  else 
	    fprintf(stderr,
		    "ERROR: the -title option should %s\n",
		    "be followed by a window title.");
	}
      
      
      if(strncmp(argv[argCounter],"-font",4)==0)
	{
	  theFontNameOverride=1;
	  argCounter++;
	  if(argCounter<argc)
	      strcpy(theFontName,argv[argCounter]);
	  else 
	    fprintf(stderr,
		    "ERROR: the -font option should be %s\n",
		    "be followed by an X font.");
	}
      
      
      if(strncmp(argv[argCounter],"-iconic",5)==0)
	iconicState=1;
      
      if(strlen(theDisplayName)<1)
	theDisplayName=NULL;
      
      if(strlen(theGeometry)<1)
	theGeometry=NULL;
      
    }
  return(iconicState);
}

printHelpMessage()
{
  fprintf(stderr, "The allowable command line options are:\n");
  fprintf(stderr, "\t-display displayname \n");
  fprintf(stderr, "\tUse a different display for output\n");
  fprintf(stderr, "\t-geometry geometryspec");
  fprintf(stderr, "\tSpecify window location and size\n");
  fprintf(stderr, "\t-font fontname");
  fprintf(stderr, "\tUse the given font name for text\n");
  fprintf(stderr, "\t-title window title\n");
  fprintf(stderr, "\tUse the given name for the window title\n");
  fprintf(stderr, "\t-iconic\n");
  fprintf(stderr, "\tStart with window in the iconic state\n");
}


