#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/keysymdef.h>

processKeyPress(theEvent,keynum)
XKeyEvent *theEvent;
int      *keynum;
{
  int      Length;
  int      theKeyBufferMaxLen = 64;
  char     theKeyBuffer[65];
  KeySym   theKeySym;
  XComposeStatus   theComposeStatus;

  Length = XLookupString( theEvent,
			theKeyBuffer,
			theKeyBufferMaxLen,
			&theKeySym,
			&theComposeStatus);
/*
According to X Window Applications Programming, XComposeStatus is not included in 
all revisions of X 11, so is better left alone. (p. 128)
  Length = XLookupString( theEvent,
			theKeyBuffer,
			theKeyBufferMaxLen,
			&theKeySym);
*/


  if ( theEvent->state & Mod1Mask ) 
    {
      *keynum = (int) theKeyBuffer[ 0 ];
/*      printf("Meta 1 is on: %d\n",*keynum); */
      return(0);
/*
      switch( theKeyBuffer[ 0 ] )
	{
	case 'Q':
	case 'q':  printf("META-Q 1 hit\n");
	  return(0);
	  break;
	}
      printf("META [%s]\n", theKeyBuffer);
      return(1);
*/
    }
  if ( theEvent->state & Mod2Mask ) 
    {
      *keynum = (int) theKeyBuffer[ 0 ];
/*      printf("Meta 2 is on: %d\n",*keynum); */
      return(0);
    }
  else if (theEvent->state & ShiftMask ) 
    {
      *keynum = (int) theKeyBuffer[ 0 ];
/*      printf("Shift is on: %d\n",*keynum); */
      return(0);
    }
  else if (theEvent->state & ControlMask ) 
    {
      *keynum = (int) theKeyBuffer[ 0 ];
/*      printf("Control is on: %d\n",*keynum);  */
      *keynum = *keynum + 4000;
      return(0);
    }
  else if (theEvent->state & LockMask ) 
    {
      *keynum = (int) theKeyBuffer[ 0 ];
/*      printf("Lock is on: %d\n",*keynum); */
      return(0);
    }
/*
  else if (theEvent->state & Button1Mask ) 
    {
      *keynum = (int) theKeyBuffer[ 0 ];
      printf("Left mouse is on: %d\n",*keynum); 
      return(0);
    }
  else if (theEvent->state & Button2Mask ) 
    {
      *keynum = (int) theKeyBuffer[ 0 ];
      printf("Middle mouse is on: %d\n",*keynum); 
      return(0);
    }
  else if (theEvent->state & Button2Mask ) 
    {
      *keynum = (int) theKeyBuffer[ 0 ];
      printf("Right mouse is on: %d\n",*keynum);
      return(0);
    }
*/

  if((theKeySym >= ' ') &&
     (theKeySym <= '~')  &&
     (Length > 0))
    {
      *keynum = theKeySym;
      return(0);
    }
  else
    {
      *keynum = 0;
      switch( theKeySym)
	{
	case XK_Return       : 	  *keynum = 10;	  break;
	case XK_BackSpace    :	  *keynum = 16;	  break;
	case XK_Escape       :	  *keynum = 27;	  break;
	case XK_Delete       : 	  *keynum = 16;   break;
	case XK_Up           : 	  *keynum = 1210;  break;
	case XK_Down         :    *keynum = 890;  break;
	case XK_Right        : 	  *keynum = 1200;  break;
	case XK_Left         : 	  *keynum = 880;  break;

	case XK_R1           : 	  *keynum = 2001;  break;
	case XK_R2           : 	  *keynum = 2002;  break;
	case XK_R3           : 	  *keynum = 2003;  break;
	case XK_R4           : 	  *keynum = 2004;  break;
	case XK_R5           : 	  *keynum = 2005;  break;
	case XK_R6           : 	  *keynum = 2006;  break;
	case XK_R7           : 	  *keynum = 2007;  break;
	case XK_R9           : 	  *keynum = 2009;  break;
	case XK_R11          : 	  *keynum = 2011;  break;
	case XK_R13          : 	  *keynum = 2013;  break;
	case XK_R15          : 	  *keynum = 2015;  break;

	case XK_F1           : 	  *keynum = 3001;  break;
	case XK_F2           : 	  *keynum = 3002;  break;
	case XK_F3           : 	  *keynum = 3003;  break;
	case XK_F4           : 	  *keynum = 3004;  break;
	case XK_F5           : 	  *keynum = 3005;  break;
	case XK_F6           : 	  *keynum = 3006;  break;
	case XK_F7           : 	  *keynum = 3007;  break;
	case XK_F8           : 	  *keynum = 3008;  break;
	case XK_F9           : 	  *keynum = 3009;  break;
	case XK_F10          : 	  *keynum = 3010;  break;
	case XK_F11          : 	  *keynum = 3011;  break;
	case XK_F12          : 	  *keynum = 3012;  break;
	case XK_F13          : 	  *keynum = 3013;  break;
	case XK_F14          : 	  *keynum = 3014;  break;
	case XK_F15          : 	  *keynum = 3015;  break;

	}
      return(0);
    }
}
