#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include "theIcon"

extern Display *theDisplay;
extern int theScreen;
extern int theDepth;
extern unsigned long theBlackPixel;
extern unsigned long theWhitePixel;
extern Cursor theCursor;
extern int argc;
extern char *argv[10];

#define BORDER_WIDTH 2
#define RES_NAME "Xgeoeas"
#define RES_CLASS "Xgeoeas"

Window openWindow(x, y, width, height, flag,  theTitle, iconicState, theFontName, theNewGC)
     int x, y;			/* where the window should go */
     int width, height;		/* size of the window */
     int flag;			/* if > 0 the the window is a pop-up */
     char theTitle[];           /* Title for Window          */
     char theFontName[];        /* Font for Window          */
     int iconicState;		/* ==1 if start as icon, ==0 if not */
     GC *theNewGC;		/* Returned Graphics Context */
{
  XSetWindowAttributes theWindowAttributes;
  XSizeHints theSizeHints;
  unsigned long theWindowMask;
  Window theNewWindow;
  Pixmap theIconPixmap;
  XWMHints theWMHints;
  XClassHint theClassHint;

  theWindowAttributes.border_pixel=
    theBlackPixel;
  theWindowAttributes.background_pixel=
    theWhitePixel;
  theWindowAttributes.cursor= theCursor;
  theWindowAttributes.override_redirect=False; 

  theWindowMask=CWBackPixel | CWBorderPixel | CWCursor | CWOverrideRedirect;

  theNewWindow=
    XCreateWindow(theDisplay,
		  RootWindow(theDisplay, theScreen),
		  x, y,
		  width, height,
		  BORDER_WIDTH, 
		  theDepth,
		  InputOutput,
		  CopyFromParent,
		  theWindowMask,
		  &theWindowAttributes);

  theIconPixmap=
    XCreateBitmapFromData(theDisplay,
			  theNewWindow,
			  theIcon_bits,
			  theIcon_width,
			  theIcon_height);

  if ( iconicState == 0)
    {
      theWMHints.initial_state=NormalState;
    }
  else
    {
      theWMHints.initial_state=IconicState;
    }

  theWMHints.icon_pixmap=theIconPixmap;
  theWMHints.flags=IconPixmapHint | StateHint;
  
  XSetWMHints(theDisplay, theNewWindow, &theWMHints);

  XStoreName(theDisplay, theNewWindow, theTitle);
  XSetIconName(theDisplay, theNewWindow, RES_NAME);

  theClassHint.res_name = RES_NAME;
  theClassHint.res_class = RES_CLASS;
  XSetClassHint(theDisplay, theNewWindow, &theClassHint);

  theSizeHints.flags=USPosition | USSize | PMinSize | PMaxSize;
  theSizeHints.x=x;
  theSizeHints.y=y;
  theSizeHints.width=width;
  theSizeHints.height=height;
  theSizeHints.min_width=330;
  theSizeHints.max_width=1100;
  theSizeHints.min_height=270;
  theSizeHints.max_height=900;

  XSetNormalHints(theDisplay,  theNewWindow, &theSizeHints);

/* 6/26/93 */

  XSetStandardProperties (theDisplay,  theNewWindow, theTitle, theTitle, None, argv, argc, &theSizeHints);

/* 6/26/93 */

  /* 
   * Create a graphics context for the window. 
   */

  if(createGC(theNewWindow, theNewGC)==0){
    XDestroyWindow(theDisplay, theNewWindow);
    return((Window) 0);
  }

  /* 
   * Ask X to place the window visibly on the screen. Up to now,
   * the window has been created but has not appeared on the
   * screen.  Mapping the window places it visibly on the screen.
   */
   
  XMapWindow(theDisplay, theNewWindow);

  /*
   * Flush out all the queued up X requests to the X server.
   */

  XFlush(theDisplay);

  /*
   * Return the window ID, which is needed to specify which 
   * window to draw to.
   */

  return(theNewWindow);
}

	
createGC(theNewWindow, theNewGC)
     Window theNewWindow;
     GC *theNewGC;
{
  XGCValues theGCValues;

  *theNewGC=XCreateGC(theDisplay,
		    theNewWindow,
		    (unsigned long) 0,
		    &theGCValues);
  if(*theNewGC==0)		/* Unable to create a GC */
    return(0);
  else {
    XSetForeground(theDisplay,
		   *theNewGC,
		   theBlackPixel);
    XSetBackground(theDisplay,
		   *theNewGC,
		   theWhitePixel);
    return(1);
  }
}

