C Graph.for - Generic Graphics routines
C----------------------------------------------------------------------
C
      SUBROUTINE ZSETUP(INT,Ierr)
      
      character*60 arguments*512
      integer nargc, arglen(0:10)
      logical graphics_on

      if (.not. graphics_on) then
         call warn_getthekey()
         call get_arguments(nargc,arguments,arglen,10)
         call init(nargc,arglen,arguments)
         graphics_on = .true.
         call zclear()
      else
         call zclear()
      end if

      END    
C----------------------------------------------------------------------
C ***	AXES - draw and label axes for plot
	
	SUBROUTINE AXES (Title1, xlabel, ylabel, Title2,
     +    xmin, xmax, ymin, ymax, xtinc, ytinc, DevCode)
        IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (OTHER = 0, HERC = 1, CGA = 2, EGA = 3)

	character	title1*(*), title2*(*), xlabel*(*), ylabel*(*)
	
	real*4		xmin, xmax, ymin, ymax, xtinc, ytinc
        real*4          xxx, yyy
	real*4		minx, maxx, miny, maxy
	INTEGER*4	DevCode

C ***	local variables
	real*4		xc, yc, dx, dy
	REAL*4		x, y, bx, by, Xticl, Yticl
	character	xfmt*8, yfmt*8, xtlab*9, ytlab*9
	character	Blanks*9, Tlabel*60
	integer*4	xwidth, ywidth, L, LENSTR

        INTEGER*4       Red, White, Yellow, Blue, Green

        DATA 	Blanks /'         '/
	DATA	Xwidth	/9/, Ywidth /9/

cc to define the color values listed above:
        include 'color.dec'

C *** Set up tick length, Get world coordinate limits
        
	CALL GetWor (Minx, Maxx, Miny, Maxy)
        call zcolor(white)

C ***	Calculate x and y label formats
	CALL SetFmt (Xtinc, Xfmt, Xwidth)
	CALL SetFmt (Ytinc, Yfmt, Ywidth)

C *** calculate ticlengths, label sizes and offsets
	Dx 	= ABS (XMax - XMin)
	Dy 	= ABS (YMax - YMin)
	Xc 	= Xmin + ((Xmax-Xmin) / 2.0)
	Yc 	= Ymin + ((Ymax-Ymin) / 2.0)
	Bx 	= Dx * .01 
	By 	= Dy * .01
	Xticl 	= Dx * .01 
	Yticl 	= Dy * .02
 
C ***	draw box around data window
	CALL ZxLine (Xmin, Xmax, Ymin)
	CALL ZxLine (Xmin, Xmax, Ymax)
	CALL ZyLine (Ymin, Ymax, Xmin)
	CALL ZyLine (Ymin, Ymax, Xmax)
cc        call system("xmessage -message graphit 5")

C ***	Draw ticmarks, and labels for x axis
cc	CALL Zlborg (INT2 (6))
cc        call system("xmessage -message graphit 6")
	DO 10 X = Xmin, Xmax, Xtinc
	  CALL 	Zmove (X, Ymin)
          yyy = ymin - yticl
	  CALL 	Zplot (X, yyy)
          Xtlab = Blanks
	  WRITE (Xtlab, Xfmt) X
	  CALL 	Left Justify (XtLab)
	  L = 	LENSTR (Xtlab)
          yyy = ymin - 4*yticl - by
          CALL 	Zmove (X - .5*L*xticl, yyy)
          call zlabel(xtlab)
 10	CONTINUE
cc        call system("xmessage -message graphit 7")

C ***	Draw ticmarks, and labels for y axis
cc	CALL Zlborg (INT2 (8))
	DO 20 Y = Ymin, Ymax, Ytinc
           CALL 	Zmove (Xmin, Y)
           xxx = xmin -xticl
           CALL 	Zplot (xxx, Y)
           Ytlab = Blanks
           WRITE (Ytlab, Yfmt) Y
           CALL 	Left Justify (YtLab)
           L = 	LENSTR (Ytlab)
           xxx = xmin - 3*L*xticl - bx
           CALL 	Zmove (xxx , Y- yticl)
           call zlabel(ytlab)
 20	CONTINUE

c ***	Plot First Title
        call left justify(title1)
        L = LENSTR (Title1)
	IF (L .GT. 0) THEN
cc           CALL Zlborg 	(INT2 (4))
           yyy = (3*ymax + maxy)/4.0
           xxx = Xmin + (xmax-xmin)/2.-.5*L*xticl
           CALL Zmove  	(xxx, yyy)
           Tlabel 	= Title1 (1:L)
           CALL Zlabel 	(Tlabel)
	ENDIF

c ***	Plot Second Title
        call left justify(title2)
        L = LENSTR (title2)
	IF (L .GT. 0) THEN
cc           CALL Zlborg 	(INT2 (4))
           xxx = Xmin + (xmax-xmin)/2.-.5*L*xticl
           yyy = (ymax + 3*maxy)/4.0
           CALL Zmove  	(xxx, yyy)
           Tlabel 	= Title2 (1:L)
           CALL Zlabel 	(Tlabel)
	ENDIF
	
C ***	Label X axis
	L = LENSTR (Xlabel)
	IF (L .GT. 0) THEN
cc           CALL Zlborg 	(INT2 (6))
           yyy = (ymin + 3*miny)/4.0
           CALL Zmove 	(Xmin+(xmax-xmin)/2.-.5*L*xticl, yyy)
           Tlabel 	= Xlabel (1:L)
           call left justify (tlabel)
           CALL Zlabel 	(Tlabel)
	ENDIF

C ***	Label Y axis
	L = LENSTR (Ylabel)
	IF (L .GT. 0) THEN
           CALL Zlbdir 	(-90.0)
cc           CALL Zlborg 	(INT2 (6))
           xxx = (xmin + 3*minx)/4.0
           CALL Zmove 	(xxx, ymin+(ymax-ymin)/2.+1.1*L*yticl)
           Tlabel 	= Ylabel (1:L)
           call left justify (Tlabel)
           CALL Zlabel 	(Tlabel)
           CALL Zlbdir 	(0.0)
	ENDIF

	RETURN
	END

C**********************************************************************
C SUBROUTINE PLUS (X, Y, MX, MY, COLOR1, COLOR2)
C
C Formal Arguments:
C  X,Y     - Coordinates at which to plot the symbol.
C  MX, MY  - Determines the size of the symbol.
C  COLOR1  - Color to plot the symbol.
C  COLOR2  - Initial color.
C
C This routine draws a plus at the specified location, in the
C specified color using the Zmove and Zplot routine from the
C graphics library.
C
        SUBROUTINE Plus (X, Y, Mx, My, Color1, Color2)
 
        REAL*4          X, Y, Mx, My
        INTEGER*4       Color1, Color2
 
        CALL Zcolor (Color1)
        CALL Zmove  (X-Mx, Y)
        CALL Zplot  (X+Mx, Y)
        CALL Zmove  (X, Y+My)
        CALL Zplot  (X, Y-My)
        CALL Zcolor (Color2)
 
        RETURN
        END
 
C----------------------------------------------------------------------
        SUBROUTINE justPlus (X, Y, Mx, My)
 
        REAL*4          X, Y, Mx, My

        CALL Zmove  (X-Mx, Y)
        CALL Zplot  (X+Mx, Y)
        CALL Zmove  (X, Y+My)
        CALL Zplot  (X, Y-My)

        RETURN
        END
 
C----------------------------------------------------------------------
	SUBROUTINE Minus (X, Y, Mx, Color1, Color2)
	REAL*4		X, Y, Mx
	INTEGER*4	Color1, Color2

	CALL Zcolor (color1)
        CALL Zmove  (X-Mx, Y)
        CALL Zplot  (X+Mx, Y)
	CALL Zcolor (color2)
	RETURN
	END 

C----------------------------------------------------------------------
	SUBROUTINE justMinus (X, Y, Mx)
	REAL*4		X, Y, Mx

        CALL Zmove  (X-Mx, Y)
        CALL Zplot  (X+Mx, Y)

	RETURN
	END 

C----------------------------------------------------------------------
	SUBROUTINE Cross (X, Y, Mx, My, Color1, Color2)
	REAL*4		X, Y, Mx, My
	INTEGER*4	Color1, Color2

	CALL Zcolor (color1)
        CALL Zmove  (X-Mx, Y-My)
        CALL Zplot  (X+Mx, Y+My)
        CALL Zmove  (X-Mx, Y+My)
        CALL Zplot  (X+Mx, Y-My)
	CALL Zcolor (color2)
	RETURN
	END 

C----------------------------------------------------------------------
	SUBROUTINE justCross (X, Y, Mx, My)
	REAL*4		X, Y, Mx, My

        CALL Zmove  (X-Mx, Y-My)
        CALL Zplot  (X+Mx, Y+My)
        CALL Zmove  (X-Mx, Y+My)
        CALL Zplot  (X+Mx, Y-My)

	RETURN
	END 

C----------------------------------------------------------------------
C Hbox - draw a box

	SUBROUTINE Hbox (X1, X2, Y1, Y2)
	REAL*4	X1, Y1, X2, Y2
     	CALL Zmove  (X1,Y1)
     	CALL Zplot  (X1,Y2)
     	CALL Zplot  (X2,Y2)
     	CALL Zplot  (X2,Y1)
     	CALL Zplot  (X1,Y1)
	RETURN
	END

C----------------------------------------------------------------------
	SUBROUTINE Box (X, Y, Mx, My, Color1, Color2)
	REAL*4		X, Y, Mx, My
	INTEGER*4	Color1, Color2

	CALL Zcolor (Color1)
        CALL Zmove  (X-Mx, Y-My)
        CALL Zplot  (X-Mx, Y+My)
        CALL Zplot  (X+Mx, Y+My)
        CALL Zplot  (X+Mx, Y-My)
        CALL Zplot  (X-Mx, Y-My)
	CALL Zcolor (Color2)
	RETURN
	END

C**********************************************************************
C SUBROUTINE SETFMT (MAX, FMT, WIDTH)
C
C Formal Arguments:
C  MAX    -  Stores the number of characters to plot.
C  FMT    -  Stores the format description.
C  WIDTH  -  The number of characters in the label.
C
C This routine returns the format and width for the axes labels.
C

	SUBROUTINE Setfmt (Max, Fmt, Width)
	REAL*4		Max, Dx
	CHARACTER 	Fmt *(*), Scratch*15
	INTEGER*4  	Width, Ndig, MaxDig
	
	Ndig = 1
        MaxDig  = Width - 3
	Dx 	= Max + 0.05 / (10 ** MaxDig)

	WRITE (Fmt, 100) 15, MaxDig
	WRITE (Scratch, Fmt) Dx - INT (Dx)

	K = 15
	J = Index (Scratch, '.')
  10	IF (Scratch (K:K) .EQ. '0' .AND. K .GT. J) THEN
	  K = K - 1
	  GOTO 10
	ENDIF
	Ndig = K - J
	WRITE (Fmt, 100) Width, Ndig
	WRITE (Scratch, Fmt, ERR = 999) Max

  20	IF (Scratch (1:1) .EQ. '*') THEN
 999	  IF (Width .GE. 5) THEN
  	    WRITE (Fmt, 200) Width, Width-5
          ELSE
  	    WRITE (Fmt, 200) Width, 0
          ENDIF
	ENDIF 
	
 100	FORMAT ('(F',I2,'.',I2,')')
 200	FORMAT ('(E',I2,'.',I2,')')

	RETURN
	END

C**********************************************************************
C SUBROUTINE NEATAX (MIN, MAX, TINC, NTIC)
C
C Formal Arguments:
C  MIN   - Minimum coordinate value for the axis.
C  MAX   - Maximum coordinate value for the axis.
C  TINC  - Spacing for the tick marks.
C  NTIC  - The number of tick marks.
C
C This routine calculates the spacing of the tick marks for the axes
C and adjusts the minimum and maximum coordinates to the nearest
C tick mark so that the tick marks are evenly space.
C

	SUBROUTINE Neatax (Min, Max, Tinc, Ntic)
	REAL*4          T, Min, Max, Amin, Amax
        REAL*4          Tinc, Range, Tmin, Tmax, Tic
	INTEGER*4       Ntic
        
        Amin = Min
        Amax = Max

        IF (Amin .GT. Amax) THEN
            T   = AMax
            AMax = AMin
            AMin = T
        ENDIF  
            
	IF (Amax .EQ. 0.0 .AND. Amin .EQ. 0) THEN
           Amin = 0.0
           Amax = 1.0
	   Tinc = 1.0
	   Ntic = 1
	   RETURN
	ENDIF

        IF (Amin .EQ. Amax) Amax = Amin + 1.0
            
C calculate tic mark spacing
        Range = (Amax - Amin)
	Tinc = Tic (Amin, Amax)	 
        IF (Tinc .EQ. 0.0) THEN
           Tinc = 1.0 
        ENDIF  
	Ntic = INT (Range / Tinc)

C adjust minimum value to nearest tic mark

  5     Tmin = 0.0
        IF (Amin .GE. 0.0) THEN
 10        IF (Tmin + Tinc .LT. Amin) THEN
               Tmin = Tmin + Tinc       
               GOTO 10
           END IF
        ELSE
 20        IF (Tmin .GT. Amin) THEN
               Tmin = Tmin - Tinc
               GOTO  20
           ENDIF
        ENDIF
        Amin = Tmin

C adjust maximum value to nearest ticmark
        Tmax = 0.0
        IF (Amax .GE. 0.0) THEN
 30        IF (Tmax .LT. Amax) THEN
               Tmax = Tmax + Tinc       
               GOTO 30
           END IF
        ELSE
 40        IF (Tmax - Tinc .GT. Amax) THEN
               Tmax = Tmax - Tinc
               GOTO  40
           ENDIF
        ENDIF
        Amax = Tmax

        Range = Amax - Amin
        Ntic = INT (Range / Tinc + 0.5) + 1 

        IF (Ntic .GT. 7) THEN
          Amax = Max
          Amin = Min
          Tinc = Tinc * 2.0
          GOTO 5 
        ELSE
          Max = Amax
          Min = Amin
        ENDIF  
	RETURN
	END

C**********************************************************************
C REAL*4 FUNCTION TIC (MIN, MAX)
C
C Formal Arguments:
C  MIN,MAX    - Minimum and Maximum coordinate values for the axis.
C
C This routine calculates the tick mark spacing.
C
	
      	REAL*4 FUNCTION Tic (Min, Max)
	IMPLICIT REAL*4 (A-Z)
	REAL*4	Min, Max
        real*8 differ
	
        DATA LOG2 /.39794/
	DATA LOG5 /.69897/
	DATA LOG7 /.87506/

        differ = max - min
	tlog = dlog10 (differ)

	Frac = tlog - ifix(tlog)
	IF (tlog .lt. 0.0) THEN
	  IF (Frac .ne. 0.0) Frac = Frac + 1.0
	  tlog = ifix(tlog)
	  IF (tlog .eq. 0.0) tlog = -1.0
	ENDIF 

	IF (Frac .le. LOG2) THEN
	  f = 1.0
	ELSEIF (Frac .gt. LOG2 .AND. Frac .lt. LOG5) THEN
	  f = 2.5
	ELSEIF (Frac .ge. LOG5 .AND. Frac .le. LOG7) THEN
	  f = 5.0
	ELSEIF (Frac .gt. LOG7) THEN
	  f = 7.5
	ENDIF 

        differ = ifix(tlog) - 1.0
	ttic = 10.0 ** (differ) * f

	IF (ttic .eq. 0.0) THEN
	  write(6,*) 'error in tic (tic=0) tlog, Frac, f=',tlog,Frac,f
          ticc = (max-min)/10
cc	  stop
	ENDIF 
	tic = ttic 
	return
	END	

C----------------------------------------------------------------------
C Box Plot - plots a boxplot in a horizontal, or vertical position
C
C       Min             - Minimum value  
C       Q1              - 1st Quartile
C       Median          - Median Value
C       Mean            - Average Value
C       Q3              - 3rd Quartile
C       Max             - Maximum Value
C       Horizontal      - Orientation flag
C       Position        - X, or Y coordinate (depends on Horizontal)
C       Width           - Width of Box
C       Dx              - Width of Mean plotting symbol

        SUBROUTINE Box Plot (TMin, TQ1, TMedian, Tmean, TQ3, TMax,
     +                       Horizontal, Position, Width, DeltaX)

        IMPLICIT INTEGER*4 (A-Z)

        REAL*4          TMin, TQ1, TMedian, Tmean, TQ3, TMax, Width
        REAL*4          Delta1, Delta2, Position, DeltaX
        LOGICAL         Horizontal

        include 'color.dec'

        Delta1          = Width * 0.5
        Delta2          = Delta1 * 0.5

        IF (Horizontal) THEN
	   CALL Zcolor (Red)
           CALL Zmove  (TMin, Position-Delta2)
           CALL Zplot  (TMin, Position+Delta2) 
           CALL Zmove  (TMin, Position)
           CALL Zplot  (TQ1, Position)
           CALL Zmove  (TQ3, Position)
           CALL Zplot  (TMax, Position)
           CALL Zmove  (TMax, Position-Delta2)
           CALL Zplot  (TMax, Position+Delta2)

	   CALL Zcolor (Green)
           CALL Zmove  (TQ1, Position-Delta1)
           CALL Zplot  (TQ1, Position+Delta1)
           CALL Zplot  (TQ3, Position+Delta1)
           CALL Zplot  (TQ3, Position-Delta1)
           CALL Zplot  (TQ1, Position-Delta1)   

	   CALL Zcolor (Yellow)
           CALL Zmove  (TMedian, Position-Delta1)
           CALL Zplot  (TMedian, Position+Delta1)

	   CALL Zcolor (White)
           CALL Zmove  (Tmean-DeltaX, Position+Delta2)
           CALL Zplot  (Tmean+DeltaX, Position-Delta2)
           CALL Zmove  (Tmean-DeltaX, Position-Delta2)
           CALL Zplot  (Tmean+DeltaX, Position+Delta2)
        ELSE
	   CALL Zcolor (Red)
           CALL Zmove  (Position-Delta2, TMin)
           CALL Zplot  (Position+Delta2, TMin) 
           CALL Zmove  (Position, TMin)
           CALL Zplot  (Position, TQ1)
           CALL Zmove  (Position, TQ3)
           CALL Zplot  (Position, TMax)
           CALL Zmove  (Position-Delta2, TMax)
           CALL Zplot  (Position+Delta2, TMax)

	   CALL Zcolor (Green)
           CALL Zmove  (Position-Delta1, TQ1)
           CALL Zplot  (Position+Delta1, TQ1)
           CALL Zplot  (Position+Delta1, TQ3)
           CALL Zplot  (Position-Delta1, TQ3)
           CALL Zplot  (Position-Delta1, TQ1)   

	   CALL Zcolor (Yellow)
           CALL Zmove  (Position-Delta1, TMedian)
           CALL Zplot  (Position+Delta1, TMedian)

	   CALL Zcolor (White)
           CALL Zmove  (Position+Delta2, Tmean-DeltaX)
           CALL Zplot  (Position-Delta2, Tmean+DeltaX)
           CALL Zmove  (Position-Delta2, Tmean-DeltaX)
           CALL Zplot  (Position+Delta2, Tmean+DeltaX)
        ENDIF
        RETURN
        END  

c-----------------------------------------------------------------------------

      
      subroutine graphics_in
      
      integer white, yellow, blue
      include 'color.dec'

      call zsetup(0,0)
      call graphics_message ()

      return
      end

c-----------------------------------------------------------------------------

      
      subroutine graphics_message ()
      
      integer white, yellow, blue
      include 'color.dec'

      call zscale(0.0,1.0,0.0,1.0)
      call zclear()
      call zlinewidth(1)
      CALL Grframe (0,0, Blue) 

      call zcolor(white)

      call zmove(.5,.85)
      call zcenterlabel('This is UNIX/X version 1.3 of geo-EAS.')
      call zmove(.5,.70)
      call zcenterlabel
     &('The conversion was made by Andy Long in the summer of 1993')
      call zmove(.5,.65)
      call zcenterlabel('in cooperation with Dr. Donald E. Myers') 
      call zmove(.5,.60)
      call zcenterlabel('of the Department of Mathematics,')
      call zmove(.5,.55)
      call zcenterlabel('University of Arizona.')
      call zmove(.5,.45)
      call zcenterlabel('All of the source code is available.')

      call zcolor(yellow)

      call zmove(.5,.3)
      call zcenterlabel('Use this Xwindow for all keyboard input.')
      call zmove(.5,.2)
      call zcenterlabel('That means "Keep your mouse here!"')

      call reset()
      return
      end

c-----------------------------------------------------------------------------

      SUBROUTINE DRAW(x1,y1,x2,y2,color)
cc       Draws a line on a color monitor.
      integer*4 color
      real*4 x1,x2,y1,y2
      call colornumber(color)
      call zline(x1,x2,x3,x4)
      END

      real*4 function HDRAW(N1,N2,N3,N4,PAGE)
      integer*4 color
      INTEGER*4 N1,N2,N3,N4,PAGE
      real*4 x1,x2,y1,y2
      x1=n1
      y1=n2
      x2=n3
      y2=n4
      call colornumber(color)
      call zline(x1,x2,x3,x4)
      call colornumber(color)
      call zline(n1,n2,n3,n4)
      END

      SUBROUTINE GETWOR (XMIN, XMAX, YMIN, YMAX)
cc       Returns global world coordinates extents a set by the routine ZSCALE.
      REAL*4 XMIN, XMAX, YMIN, YMAX
      call zgetworld(XMIN, XMAX, YMIN, YMAX)
      END

      SUBROUTINE ZCOLOR (COLCOD)
cc        Selects a user specified color.
cc    COLCOD - Color to be used for drawing lines or plotting labels
cc
      INTEGER*4 COLCOD
      call colornumber(colcod)
      END

C----------------------------------------------------------------------
C ***   grframe - draw a double lined box around graph
 
        subroutine grframe (Xmaxd, Ymaxd, color)
        integer*4       Xmaxd, Ymaxd, color
        real*4  x1, y1, x2, y2, x12, x22, y12, y22
 
        call getwor(x1, x2, y1, y2)
        xdiffer=(x2-x1)*.005
        ydiffer=(y2-y1)*.005
        x1   = x1 + xdiffer
        x2   = x2 - xdiffer
        y1   = y1 + ydiffer
        y2   = y2 - ydiffer
        x12   = x1 + xdiffer
        x22   = x2 - xdiffer
        y12   = y1 + ydiffer
        y22   = y2 - ydiffer
 
        call colornumber(color)
        call zbox(x1, y1, x2, y2)
        call zbox(x12, y12, x22, y22)
 
        RETURN
        END
c-----------------------------------------------------------------------------
