C Lowlevel.for - lower-level machine dependant screen mgt. routines
C**********************************************************************
C
C   Screen Access Management (SAM) Utilities miscellaneous routines.
C
C**********************************************************************

	SUBROUTINE Display Frame

	IMPLICIT INTEGER*4 (A-Z)
        logical status, SMG_DRAW_RECTANGLE, SMG_DRAW_LINE

	PARAMETER (BOX  = 0)
	PARAMETER (LINE = 1)

	INCLUDE 'screen.str'

	COMMON /Screen/ Page, PBID, KBID

	DO 60 i = Begin Frame (Current Screen),
     +	         End Frame (Current Screen)

	  IF (FR Command (i) .EQ. BOX) THEN
	    r1 = FR Row1    (i)
	    c1 = FR Column1 (i)
	    r2 = FR Row2    (i)
	    c2 = FR Column2 (i)
	    Status = SMG_DRAW_RECTANGLE (Page, r1, c1, r2, c2)
c	    IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))
	  ELSE
	    r1 = FR Row1    (i)
	    c1 = FR Column1 (i)
	    r2 = FR Row2    (i)
	    c2 = FR Column2 (i)
	    Status = SMG_DRAW_LINE (Page, r1, c1, r2, c2)
c	    IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))
	  ENDIF
  60	CONTINUE

	RETURN
	END


C------------------------------------------------------------------------
C  Clear Screen - Clears the Screen.
C------------------------------------------------------------------------
	SUBROUTINE Clear Screen
	IMPLICIT INTEGER*4 (A-Z)
        logical status, SMG_ERASE_DISPLAY

	COMMON /Screen/ Page, PBID, KBID

	Status = SMG_ERASE_DISPLAY (Page)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

	RETURN
	END


C------------------------------------------------------------------------
C  Locate Cursor - Put Cursor at the specified Row and Column 

	SUBROUTINE Locate Cursor (Row, Column)
	IMPLICIT INTEGER*4 (A-Z)
	INTEGER*4 Row, Column
        logical status, SMG_SET_CURSOR_ABS

	COMMON /Screen/ Page, PBID, KBID

	R = Row 
	C = Column
	Status = SMG_SET_CURSOR_ABS (Page, R, C)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

	RETURN
	END

C------------------------------------------------------------------------
C  Put characters on the screen with the specified attribute.
C  Attributes can be :
C	NORMAL    = 0
C	BOLD      = 1
C	REVERSE   = 2
C	BLINK     = 4
C	UNDERLINE = 8

      SUBROUTINE Put Characters (Characters, Length, Attribute)
      IMPLICIT INTEGER*4 (A-Z)
      CHARACTER*(*) Characters, hold*80
      logical status, SMG_PUT_CHARS
      
      COMMON /Screen/ Page, PBID, KBID
      
cc this caused sparc to muck up      if (attribute .eq. 2) then
      if (attribute .eq. 22) then
         do i = 1, length
            j = ichar(characters(i:i)) + 128
            if (j .gt. 255) then
	       call system ("xmessage -message consider_dg_version")
               call putstr('Problems with lowlevel.f:'
     &              //' Consider using .dg version',70,20,2,2)
               return
            end if
            hold(i:i) = char(j)
         enddo
         Status = SMG_PUT_CHARS (Page, hold, length,i,i,Attribute)
      else
         Status = SMG_PUT_CHARS (Page, Characters ,length,i,i,Attribute)
      end if
      RETURN
      END


C------------------------------------------------------------------------
C  Send a BEEP to the screen.

	SUBROUTINE Beep
	INTEGER*4 Beep_Attribute
	Beep_Attribute=0
	CALL Put Characters (CHAR(7), 1, Beep_Attribute)
	RETURN
	END


C------------------------------------------------------------------------
C   Set Up Screen - Initialize VAX screen, create pasteboard, virtual 
C   display and virtual keyboard.  Paste virtual display to pasteboard.
C
C   Page = Virtual Display ID
C   PBID = Pasteboard ID
C   KBID = Virtual Keyboard ID

	SUBROUTINE Set Up Screen
	IMPLICIT INTEGER*4 (A-Z)
	COMMON /Screen/ Page, PBID, KBID
        logical status, SMG_CREATE_VIRTUAL_KEYBOARD
     &       , SMG_CREATE_PASTEBOARD, SMG_CREATE_VIRTUAL_DISPLAY
     &       , SMG_PASTE_VIRTUAL_DISPLAY

C------------------------------------------------------------------------
C   Create Virtual Keyboard
C------------------------------------------------------------------------
	Status = SMG_CREATE_VIRTUAL_KEYBOARD (KBID)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

C------------------------------------------------------------------------
C   Set up SYS$OUTPUT for screen management and get the number of rows
C   and columns on the screen.
C------------------------------------------------------------------------
	Status = SMG_CREATE_PASTEBOARD (PBID,'SYS$OUTPUT',Rows,Columns)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

C------------------------------------------------------------------------
C   Create Virtual Display to paste to the full screen.
C------------------------------------------------------------------------
	Rows = 24
	Columns = 80
	Status = SMG_CREATE_VIRTUAL_DISPLAY (Rows, Columns, Page,i,i)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

C------------------------------------------------------------------------
C   Paste Virtual Display to Pasteboard.
C------------------------------------------------------------------------
	Status = SMG_PASTE_VIRTUAL_DISPLAY (Page, PBID, 1, 1)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

	RETURN
	END


C------------------------------------------------------------------------
C   Reset Screen - Returns VAX keyboard to its initial state by 
C   deleting the pasteboard, virtual display, and virtual keyboard
C
C   Page = Virtual Display ID
C   PBID = Pasteboard ID
C   KBID = Virtual Keyboard ID

	SUBROUTINE Reset Screen
	IMPLICIT INTEGER*4 (A-Z)
        logical status, SMG_DELETE_PASTEBOARD
     &       , SMG_DELETE_VIRTUAL_DISPLAY, SMG_DELETE_VIRTUAL_KEYBOARD
	COMMON /Screen/ Page, PBID, KBID

C------------------------------------------------------------------------
C   Delete Pasteboard
C------------------------------------------------------------------------
	Status = SMG_DELETE_PASTEBOARD (PBID)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

C------------------------------------------------------------------------
C   Delete Virtual Display
C------------------------------------------------------------------------
	Status = SMG_DELETE_VIRTUAL_DISPLAY (Page)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

C------------------------------------------------------------------------
C   Delete Virtual Keyboard
C------------------------------------------------------------------------
	Status = SMG_DELETE_VIRTUAL_KEYBOARD (KBID)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

	RETURN
	END


