C*********************************************************************
C*** File Name: \GEOEAS\CORRES\CALFACT.FOR 
C*** Source code for the program CORRES
C*********************************************************************
C SUBROUTINE  Calc Factors 
C
C This routine computes the factors and the coordinates for the 
C variables and samples.
C 
        SUBROUTINE  Calc Factors 

        IMPLICIT INTEGER*4   (A-Z)

		INCLUDE 'corres.inc'
 
        INTEGER*4   KFac, JDIM

        JDIM = NVar - 1

C ***  Compute the Variable factors
        CALL Put Str (' Computing Variables Factors ',30,20,2,2)
        DO 10 KFac = 1, JDIM
              DO 10 j = 1, NVar
 10        FACJ (j,KFac) = (Vecpr (j, KFac+1) / dSQRT (PJ (J)))
cclong
cc	print *, ((vecpr(j,k),k=2,nvar), j=1,nvar)
cc it turns out that the eigenvector is null for vecpr(nvar,.),
cc so that means that facj(nvar,.) is null, which means that 
cc coorj(nvar,.) is null, which makes anerr blow up.  Bad 
cc news, since I don't know what it all means.
cc
        CALL Ers Line (20,2,75)

C *** Compute the Sample factors
        CALL Put Str (' Computing Sample Factors ',27,20,2,2)
        DO 20 I = 1, NSamples
           DO 20 KFac = 1, JDIM
              FACI (I, KFac) = 0.0
              DO 20 J = 1, NVar
                 FACI (I, KFac) = FACI (I, KFac) + (PIJ (I,J) /  
     +              PI (I)) * FACJ (J, KFac) / dSQRT (Valpr (KFac+1))
 20     CONTINUE 
        CALL Ers Line (20,2,75)

C *** Compute the Coordinates of the Factors
        CALL Put Str (' Computing Coordinates of the Factors ',
     +                38,20,2,2)
        DO 30 I = 1, NVar
           DO 30 J = 1, JDIM
 30        COORJ (I,J) = FACJ (I,J) * dSQRT (Valpr (J+1))
           DO 40 I = 1, NSamples
              DO 40 J = 1, JDIM
 40        COORI (I,J) = FACI (I,J) * dSQRT (Valpr (J+1))

        CALL Ers Line (20, 2, 75)
        RETURN
        END                     
