C*********************************************************************
C*** File Name: \GEOEAS\CORRES\EXECSCR.FOR 
C*** Source code for the program CORRES
C*********************************************************************
cclong
cc        INTERFACE TO INTEGER*4 FUNCTION SYSTEM [C,ALIAS:' system']
cc     1  (COMMAND)
cc        INTEGER*4 COMMAND
cc        END

C*********************************************************************
C SUBROUTINE Execute Menu
C   
C Local Variables:
C  ExecMenu    - Name of the execute menu in the screen definition file.
C  ExecScreen  - Number of the execute screen in the screen definition
C                file.
C  FExist      - Logical variable set to .TRUE. if the file exists.
C  Error       - Logical variable set to .TRUE. if an error occurs.
C  OverWrite   - Logical variable set to .TRUE. if the file can be  
C                overwritten.
C 
C This routine displays the execute screen, accesses the menu option
C selected by the user then calls the routine to process the menu
C option. 
C
	SUBROUTINE Execute Menu

        IMPLICIT INTEGER*4 (A-Z)

		INCLUDE 'corres.inc'
		INCLUDE 'screen.str'
        
        CHARACTER*10  ExecMenu, Dummy, Field Name
        CHARACTER*10  Program
        INTEGER*4     SYSTEM, ReturnCode, SPAWN
        INTEGER*4     ExecScreen, Position, Fld Index, Address
        LOGICAL       Error, FExist, OverWrite, Get Yes No, Exists

        DATA ExecMenu    /'EXE MENU  '/
        DATA ExecScreen  /4/

        OverWrite = .TRUE.
        FExist = .FALSE.
        RFlag  = .FALSE.

        CALL Get New Screen (ExecScreen)

        CALL Setup Corres Matrix (Error)
        IF (Error) RETURN
        CALL Calc Factors
        CALL Ers Line (20, 2, 75)

        call build file name ('ca_recon', reconfile, '.dat')
        call build file name ('ca_resid', residfile, '.dat')
        call build file name ('ca_vars', varfile, '.dat')
        call build file name ('ca_sample', sampfile, '.dat')
        call set character value ('SAMPFILE  ',sampfile)
        call set character value ('VARFILE  ',varfile)
        call set character value ('RECONFILE  ','not computed')
        call set character value ('RESIDFILE  ','not computed')

 5      CALL Put Str (FilePrefix, 50, 2, 10, 0)

        CALL Display Flds
        CALL Ers Line (20, 2, 75)
  
        CALL Dsp Execute Screen

        CALL Put Menu (ExecMenu)

 10     CALL Get Menu Choice (ExecMenu,MenuChoice)

C *** QUIT
        IF (MenuChoice .EQ. 'Quit          ') THEN
           RETURN
   
C *** FILE NAMES
        ELSEIF (MenuChoice .EQ. 'File Names   ') THEN
 20        CALL Get Field
           Field Name = SC Field Name (Current Field)
           IF (Field Name .EQ. 'SAMPFILE ') THEN
              CALL Get Character Value (Field Name, SampFile)
              IF (SampFile(1:14) .EQ. '              ') THEN
                 CALL Beep
                 Message = 'ERROR - Samples file not specified'
                 CALL Flash (20,2,Message)
                 CALL Set Character Value ('SAMPFILE  ','ca_sample.dat')
                 Next Field = Fld Index (Field Name)
                 GOTO 20
              ENDIF
              CALL Get F Name (FileName, FilePrefix, SampFile, FExist)

              IF (FExist .AND. SampFile .NE. 'ca_sample.dat ') THEN
                 Message = 'Samples file already exists: '//
     +                'overwrite (Y/N)?'
                 OverWrite = Get Yes No (20, 2, Message)
              ENDIF
              IF (.NOT. OverWrite ) THEN
                 Next Field = Fld Index (Field Name)
                 OverWrite = .TRUE.
                 GOTO 20
              ELSE
                 Next Field = Fld Index ('VARFILE   ') 
                 GOTO 20
              ENDIF       
           ELSEIF (Field Name .EQ. 'VARFILE  ') THEN
              CALL Get Character Value (Field Name, VarFile)
              IF (VarFile .EQ. '              ') THEN
                 CALL Beep
                 Message = 'ERROR - Variables file not specified'
                 CALL Flash (20,2,Message)
                 CALL Set Character Value ('VARFILE  ','ca_vars.dat')
                 Next Field = Fld Index (Field Name)
                 GOTO 20
              ENDIF
              CALL Get F Name (FileName, FilePrefix, VarFile, FExist)
              IF (FExist .AND. VarFile .NE. 'ca_vars.dat  ') THEN
                 Message = 'Variables file already exists:'//
     +                ' overwrite (Y/N)?'
                 OverWrite = Get Yes No (20, 2, Message)
              ENDIF
              IF (.NOT. OverWrite ) THEN
                 Next Field = Fld Index (Field Name)
                 OverWrite = .TRUE.
                 GOTO 20
              ELSE
                 Next Field = Fld Index ('RFLAG       ') 
                 GOTO 20
              ENDIF       
       
           ELSEIF (Field Name .EQ. 'RFLAG      ') THEN
              CALL Get Toggle Value (Field Name, Position, Dummy)
              IF (Position .EQ. 0) THEN
                 RFlag = .TRUE.  
                 CALL Set Character Value ('RECONFILE  ',ReconFile)
                 CALL Set Character Value ('RESIDFILE  ',ResidFile)
                 Next Field = Fld INdex ('RESIDFILE  ')
                 GOTO 20
              ELSE
                 CALL Set Character Value ('RECONFILE  ','Not Computed')
                 CALL Set Character Value ('RESIDFILE  ','Not Computed')
                 CALL Display One Field ('RECONFILE  ')
                 CALL Display One Field ('RESIDFILE  ')
                 CALL Ers Line (20, 2, 75)
                 GOTO 10
              ENDIF      

           ELSEIF (Field Name .EQ. 'RESIDFILE  ') THEN
              CALL Get Character Value (Field Name, ResidFile)
              IF (ResidFile .EQ. '              ') THEN
                 CALL Beep
                 Message = 'ERROR - Residuals file not specified'
                 CALL Flash (20,2,Message)
                 CALL Set Character Value ('RESIDFILE  ','ca_resid.dat')
                 Next Field = Fld Index (Field Name)
                 GOTO 20
              ENDIF
              CALL Get F Name (FileName, FilePrefix, ResidFile, FExist)
              IF (FExist .AND. ResidFile .NE. 'ca_resid.dat  ') THEN
                 Message = 'Residuals file already exists:'//
     +                ' overwrite (Y/N)?'
                 OverWrite = Get Yes No (20, 2, Message)
              ENDIF
              IF (.NOT. OverWrite ) THEN
                 Next Field = Fld Index (Field Name)
                 OverWrite = .TRUE.
                 GOTO 20
              ELSE
                 Next Field = Fld Index ('RECONFILE   ') 
                 GOTO 20
              ENDIF       

           ELSEIF (Field Name .EQ. 'RECONFILE  ') THEN
              CALL Get Character Value (Field Name, ReconFile)
              IF (ReconFile .EQ. '              ') THEN
                 CALL Beep
                 Message = 'ERROR - Reconstructed data file not '//
     +                      'specified'
                 CALL Flash (20,2,Message)
                 CALL Set Character Value ('RECONFILE  ','ca_recon.dat')
                 Next Field = Fld Index (Field Name)
                 GOTO 20
              ENDIF
              CALL Get F Name (FileName, FilePrefix, ReconFile, FExist)
              IF (FExist .AND. ReconFile .NE. 'ca_recon.dat  ') THEN
                 Message = 'Reconstructed data file already '//
     +                 ' exists: overwrite (Y/N)?'
                 OverWrite = Get Yes No (20, 2, Message)
              ENDIF
              IF (.NOT. OverWrite ) THEN
                 Next Field = Fld Index (Field Name)
                 OverWrite = .TRUE.
                 GOTO 20
              ENDIF       
            ENDIF
            GOTO 10

C *** EXECUTE
        ELSEIF (MenuChoice .EQ. 'Execute      ') THEN
           CALL Get Field 
           CALL Get Toggle Value ('NFACT     ',Position, Dummy)
           CALL Ers Line (20, 2, 75)
           NFactors = Position + 1
cclong           CALL Anerr (NFactors, NVar, NVar-1, NSamples)  
           CALL Anerr (NFactors, NVar, NVar-1, NSamples,valpr,pi,pj
     &          , maxvar,maxsamples,maxsuppvar)
cc           CALL Anerr (NFactors, NVar, NVar-1, NSamples)
cc     &			,VALPR)
cc      SUBROUTINE ANERR(NFAC,JMAX,JDIM,IMAX,VALPR,
cc     &			maxvar,maxsamples,maxsuppvar)
cclong
           IF (NSuppVar .NE. 0 ) THEN
              CALL Calc SuppVar
           ENDIF
           CALL Create Files
           CALL Results Menu
           IF (.NOT. RFlag) THEN
              CALL Set Character Value ('RECONFILE  ','Not Computed')
              CALL Set Character Value ('RESIDFILE  ','Not Computed')
           ENDIF
           CALL Get New Screen (ExecScreen)
           GOTO 5

C *** BROWSE
        ELSEIF (MenuChoice .EQ. 'Browse       ') THEN
           IF (NVar - 1 .LT. 10) GOTO 10
           INQUIRE (FILE = 'browse.exe', EXIST = Exists)
      	   IF (.NOT. Exists) THEN
	      CALL FLASH (20, 2, ' BROWSE.EXE not found. ')
              GOTO 10
           ENDIF
           
           CALL Get F Name (FileName, FilePrefix, 'ca_eigen.dat',
     +                      FExist)
           OPEN (UNIT = 12, FILE = FileName,status='unknown')
           WRITE (12, '(A60)')  ' '
           WRITE (12, '(I2)') 3
           WRITE (12, '(A10, 10X, A10)') 'EIGENVALUE', 'G20.7     ' 
           WRITE (12, '(A10, 10X, A10)') '% OF VAR  ', 'F16.2      ' 
           WRITE (12, '(A10, 10X, A10)') 'CUMM VAR  ', 'F17.2      ' 
           DO 30 j = 1, NVar-1
              WRITE (12, '(G20.7, 1X, F21.2, 1X, F27.2)')
     +             Valpr (j+1), Pourc (j), Cumm (j+1)
 30        CONTINUE
           CLOSE (12)
  	   CALL Write System Defaults (FilePrefix,'ca_eigen.dat  ')
           Program = 'BROWSE' // CHAR (0)
           ReturnCode = 0
cc           ReturnCode = SYSTEM (LOC (Program))
           IF (ReturnCode .NE. 0) THEN
              CALL Ers Line (20, 2, 75)
              CALL Flash (20, 2, 'ERROR loading BROWSE')
              GOTO 10
           ENDIF
           CALL Get New Screen (ExecScreen)
           GOTO 5
        ENDIF
                                  
        END     


C*********************************************************************
C SUBROUTINE Dsp Execute Screen
C
C This routine displays the eigenvalues, the percent of variation
C and the cumulative variation on the options/execute screen.
C 
       SUBROUTINE Dsp Execute Screen

       IMPLICIT INTEGER*4 (A-Z)

		INCLUDE 'corres.inc'

        CHARACTER CValpr*14, CPourc*6, CCumm*6
        INTEGER*4 Row

        Row = 9
        DO 5 i = 1, NVar-1
          IF (Row .LE. 18) THEN
              WRITE (CValpr, '(E14.7)' ) Valpr (I+1)
              CALL Put Str (CValpr,14,row,6,0)
              WRITE (CPourc, '(F6.2)' ) Pourc (I)
              CALL Put Str (Cpourc,6,row,35,0)
              WRITE (CCumm, '(F6.2)' ) Cumm (I+1)
              CALL Put Str (CCumm,6,row,62,0)
              Row = Row + 1
          ENDIF
 5      CONTINUE
       
        RETURN 
        END
