C*********************************************************************
C*** File Name: \GEOEAS\CORRES\SETUP.FOR 
C*** Source code for the program CORRES
C*********************************************************************
C SUBROUTINE Setup Corres Matrix (Error) 
C
C Formal Arguments:
C  Error  - Logical set to .TRUE. if an error occurs.
C
C This routine calls the routines that sets up the matrix to be 
C diagonalized and compute the eigenvalues and eigenvectors then  
C computes the percent of variation and the cummulative variation of 
C the factors.
C
        SUBROUTINE Setup Corres Matrix (Error) 

        IMPLICIT INTEGER*4  (A-Z)
        INCLUDE 'corres.inc'

        INTEGER*4  KFac, KFac1, JDIM
        LOGICAL    Error
        REAL*8     Sum
cclong
	integer*4 indexdummy(maxvar)
        REAL*8  dummye (MaxVar), dummyd(MaxVar)
cclong
	
	CALL Put Str (' Starting the Analysis ', 23, 20, 2, 2)
        Error = .FALSE.

cclong
cc        CALL CORMAT (NSamples, NVar, Error)
        CALL CORMAT (pij,NSamples,NVar,sjj,pi,pj,maxsamples,
     &       maxvar, Error, somij)
cclong
        IF (Error) THEN
           Message = ' A row or column sum is zero ... Analysis '//
     +          ' cannot be performed. '
           CALL Flash (20,2, Message)
           RETURN
        ENDIF   
         
	CALL Put Str (' Computing Eigenvalues and Eigenvectors ',
     +                 40, 20, 2, 2)

cclong        CALL HOW (NVar, MAXVAR)
        CALL HOW (NVar, MAXVAR, sjj, valpr, 
     &		vecpr, dummye, dummyd,indexdummy)
cc
       CALL Put Str (' Computing Percent of Variation and the 
     +                 Cummulative Variation of the factors ', 
     +                77, 20, 2, 2)
   
        JDIM = NVar - 1
        Sum = 0.0
        DO 10 j = 1, JDIM
10      Sum = Sum + Valpr (J+1)
        Cumm (1) = 0.0
        DO 20 KFac = 1, JDIM
           KFac1 = KFac + 1
           Pourc (KFac) = Valpr (KFac+1) * 100. / Sum
20      Cumm (KFac1) = Cumm (KFac) + Pourc (KFac)

        CALL Ers Line (20, 2, 77)

 15     format(5(g12.5,1x))
        RETURN
        END
