C*********************************************************************
C SUBROUTINE Data Menu
C
C Local Variables:
C  Datarmenu    - Name of the data menu in the screen definition file.
C  DataScreen  - Number of the data screen in the screen definition
C                file.
C  FExist      - Logical variable set to .TRUE. if the data file 
C                exists.
C 
C This routine displays the data screen, accesses the menu option
C selected by the user then calls the routine to process the menu
C option. 
C
C*********************************************************************
	SUBROUTINE Data Menu

        IMPLICIT INTEGER*4 (A-Z)

		INCLUDE '../common/screen.str'
		INCLUDE 'generic.inc'
        
        CHARACTER*10  Datarmenu, Varcod
        INTEGER*4     DataScreen, Fld Index, CR, Down
        LOGICAL       FExist, Error
        LOGICAL     Get Yes No, Rank Data

        DATA Datarmenu    /'VAR MENU  '/
        DATA DataScreen  /3/

        Nsamples = 0
       
C *** Set up the screen
        CALL Get New Screen (DataScreen)
        CALL Put Str (FilePrefix, 50, 2, 10, 0)
        CALL Display One Field ('DATAFILE  ')

 10     Error = .FALSE.
        CALL Put Menu (Datarmenu)
        CALL Get Menu Choice (Datarmenu,MenuChoice)

C *** QUIT
        IF (MenuChoice .EQ. 'Quit        ') THEN
          RETURN

C *** FILE
        ELSEIF (MenuChoice .EQ. 'File         ') THEN
           CALL Get Field
           CALL Get Character Value ('DATAFILE  ', DataFile)
           CALL Get File Name (FileName, FilePrefix,
     +          DataFile, Fexist)
           IF (.NOT. Fexist) THEN
              CALL Blank File ('DATAFILE  ', DataFile)
              Message = 'ERROR - data file not found'
              CALL Flash (20, 2, Message)
              GOTO 10
           ELSE
              CALL Read Header Data (Error)
              NVar = filenvar
              IF (Error) THEN
                 Error = .FALSE.
                 GOTO 10
              ENDIF
              CALL Dsp Var Names (DataScreen, FileVarNam) 
              error = .true.
              CALL ReadData (Error) 
              IF (Error) GOTO 10
           ENDIF

C *** Select variable to be used
        ELSEIF (MenuChoice .EQ. 'Variables   ') THEN
           IF (NVar .EQ. 0) THEN
             CALL Beep
             Message = 'No variables available - press any key'
             CALL Flash (20,2,Message)
             GOTO 10
           ELSE
              Next Field = Fld Index ('VAR  1    ')
              CALL Dsp Var Names (DataScreen, FileVarNam) 
              DO 16 j = 1, MaxVar
                 IF (j .GT. FileNVar) THEN
                    WRITE (Varcod, '(A4,I2)') 'VAR ', j
                    CALL Set Toggle Position (Varcod, 0)
                 ELSE
                    WRITE (Varcod, '(A4,I2)') 'VAR ', j
                    CALL Set Toggle Position (Varcod, 1)
                 ENDIF
                 IF (j .EQ. FileNVar) THEN
                    WRITE (Varcod, '(A4,I2)') 'VAR ', j
                    f = Fld Index (Varcod)
                    m = Fld Index ('VAR MENU  ')
                    CR = SC Carriage Return (f)
                    Down = SC Down (f)
                    SC Carriage Return (f) = m - f
                    SC Down (f) = m - f
                 ENDIF
 16           CONTINUE
              CALL Display Flds
              Next Field = Fld Index ('VAR  1    ')
              CALL Get FGroup
              Error = .FALSE.
              NVar = 0
              CALL ReadData (Error)
              IF (Error) GOTO 10
           ENDIF

C *** OPTIONS/EXECUTE
        ELSEIF (MenuChoice .EQ. 'Yours') THEN
           IF (NVar .EQ. 0) THEN
             CALL Beep
             Message = 'ERROR - Data file not specified'
             CALL Flash (20,2,Message)
             GOTO 10
           ELSE
              SC Carriage Return (f) = CR
              SC Down (f) = Down
              CALL Execute Menu
              CALL Get New Screen (DataScreen)
              CALL Put Str (FilePrefix, 50, 2, 10, 0)
              CALL Dsp Var Names (DataScreen, FileVarNam) 
              CALL Display Flds
           ENDIF
        ENDIF
        
        CALL erase (20, 2, 75)
        GOTO 10
        END     


C*********************************************************************
C SUBROUTINE Read Header Data  (Error)
C
C Formal Arguments:
C   Error  - Logical variable set to .TRUE. if an error occurs.
C
C This routine reads in the header information from the data file. 
C If an error occurs will reading the file an error message is
C displayed.
C  
	SUBROUTINE Read Header Data (Error)  
 
	IMPLICIT INTEGER*4 (A-Z)
 	
		INCLUDE 'generic.inc'

        CHARACTER*75  Dummy
        LOGICAL       Error

	CALL Put Str ('Reading Header Data ',20, 20, 2, 2)
        
        FileNVar = 0
	OPEN (UNIT=10,FILE = FileName,status='unknown',ERR = 999)

C Read header string into header character variable
	READ (10, '(A)', ERR = 999, END = 999) Header

C Get number of variables in file
	READ(10, *, ERR = 999, END = 999) FileNVar

        IF (FileNVar .GT. MaxFileVar) THEN
	   CALL Flash (20, 2, 
     +              'Too many variables in file  (press any key)') 
	   GOTO 999
	ENDIF
        IF (FileNVar .LT. 2) THEN
	   CALL Flash (20, 2, 
     +              'Too few variables in file  (press any key)') 
	   GOTO 999
	ENDIF

C Get variable names for each variable in file
        DO 10 i = 1, FileNVar
           READ (10,'(2A10)') FileVarNam(i)
 10     CONTINUE

        CLOSE (10)

	RETURN

C ***  Error has been found in data of file
 999    Error = .TRUE.
	NSamples = 0
	CALL Flash (20, 2, 'ERROR reading header data ')
	CLOSE (10)

	RETURN
	END

C*********************************************************************
C SUBROUTINE Dsp Var Names (Screen Number, Name)
C
C Formal Arguments:
C  Screen Number  - Number of the screen to display variables name.
C                   Screen Number = 3 for Data screen and 
C                   Screen Number = 6 for Write screen.
C  Name           - Array of variable names to display.
C
C This routine displays the variable names from a file on the specified
C screen.
C 
        SUBROUTINE Dsp Var Names  (Screen Number, Name)
         
        IMPLICIT INTEGER*4 (A-Z)

		INCLUDE 'generic.inc'

        CHARACTER*10  Name (MaxFileVar)
        INTEGER*4     Screen Number, Row, Col, ColIndex, NumRows

        Col = 2
     
        IF (Screen Number .EQ. 3) THEN
           DO 5 j = FileNVar+1, MaxVar
              FileVarNam (j) = '          '
5          CONTINUE
           Row = 7
           ColIndex = 18
           NumRows = 12
        ELSE
           Row = 9
           ColIndex = 17
           NumRows = 10
        ENDIF
   
C *** Display variable names
        DO 15 i = 1, NumRows
           CALL Put Str (Name(i),10,Row,Col,0)
           CALL Put Str (Name(i+NumRows),10,Row,Col+ColIndex,0)
           CALL Put Str (Name(i+NumRows*2),10,Row,Col+ColIndex*2,0)
           IF (Screen Number .EQ. 3)
     +      CALL Put Str (Name(i+NumRows*3),10,Row,Col+ColIndex*3,0)
           Row = Row + 1
 15     CONTINUE
        
        RETURN
        END

C*********************************************************************
C SUBROUTINE ReadData (Error)
C
C Formal Arguments:
C   Error  - Logical variable set to .TRUE. if an error occurs.
C
C This routine determines the variables selected, then reads in the
C sample values for these variables.  If an error occurs an error
C message will be displayed. 
C 
        SUBROUTINE ReadData (Error) 

        IMPLICIT INTEGER*4 (A-Z)

		INCLUDE 'generic.inc'
		INCLUDE '../common/screen.str'

        CHARACTER     Blanks*50, Dummy*75, CNum*3
        CHARACTER*10  Units*10, Varcod*10, Formats*10
        INTEGER*4     VarPos (MaxFileVar), SVarPos (MaxFileVar) 
        INTEGER*4     Fld Index
	REAL*8        TempData (MaxFileVar), Missing
        LOGICAL       Error

        CALL Put Str ('Reading Data Values ...  ',25,20,2,2)

C *** Determine variables selected
        if (.not. error) then
           NSuppVar = 0
           DO 20 i = 1, FileNVar
              WRITE (Varcod, '(A4,I2)') 'VAR ', i
              CALL Get Toggle Value (Varcod,Position,Dummy)
              IF (Position .EQ. 1) THEN
                 NVar = NVar + 1
                 VarNam (NVar) = FileVarNam (i)
                 VarPos (NVar) = i
              ELSEIF (Position .EQ. 2) THEN
                 NSuppVar = NSuppVar + 1
                 SVarNam (NSuppVar) = FileVarNam (i)
                 SVarPos (NSuppVar) = i
              ENDIF
 20        CONTINUE
        else
           nvar = filenvar
           DO 21 i = 1, NVar
              WRITE (Varcod, '(A4,I2)') 'VAR ', i
              VarNam (i) = FileVarNam (i)
              VarPos (i) = i
 21        CONTINUE
           error = .false.
        end if

C *** Perform error checking
        IF (NVar .EQ. 0) THEN
           Message = 'ERROR - no variables chosen. (press any key)'
           CALL Flash (20, 2,Message)
           Error = .TRUE.
           RETURN
        ENDIF

        IF (NVar .EQ. 0 .AND. NSuppVar .NE. 0) THEN
           Message = 'ERROR - all supplementary variables chosen. '//
     +           ' (press any key)'
           CALL Flash (20, 2,Message)
           Error = .TRUE.
           RETURN
        ENDIF

        IF (NVar .GT. MaxVar) THEN
           Message = 'Too many variables chosen. (press any key)'
           CALL Flash (20, 2,Message)
           Error = .TRUE.
           RETURN
        ENDIF

        IF (NSuppVar .GT. MaxSuppVar) THEN
           Message = 'Too many supplementary variables chosen.'//
     +              '  (press any key)'
           CALL Flash (20, 2,Message)
           Error = .TRUE.
           NSuppVar = 0
           RETURN
        ENDIF

C *** Read header data
        OPEN (UNIT=10,FILE=FileName,status='unknown',ERR = 999)
	READ (10, '(A)', ERR = 999, END = 999) Dummy
   	READ (10, *, ERR= 999, END = 999) FileNVar

C *** Get units for variables selected
        DO 40 k = 1, FileNVar
           READ (10,'(3A10)',ERR= 999,END=999) Dummy, Units, Formats 
           DO 50 l = 1, NVar
              IF (VarPos(l) .EQ. k) THEN
                 FileUnits (l) = Units
                 FileFormats (l) = Formats
              ENDIF
  50       CONTINUE 
 40     CONTINUE

C *** Read sample values
        NSamples = 0
	Missing   = 1.E31
	DO 60 i = 1, MaxSamples
           READ (10,*,ERR=999,END = 900) (TempData (k), k=1,FileNVar)
           NSamples = Nsamples + 1
           DO 65 j = 1, NVar
              PIJ (NSamples,j) = TempData (VarPos(j))
  65       CONTINUE
           DO 70 k = 1, NSuppVar
              PSIJ (Nsamples, k) = TempData (SVarPos (k))
  70       CONTINUE
 60     CONTINUE
        
C *** Check if more then MaxSamples records
        READ (10, *, ERR = 999, END = 900) (TempData(k), k=1,FileNVar)
	CALL Beep
        Message = ' Program limits exceeded, only the maximum ' //
     +            'allowed will be used '
	CALL Flash (20, 2, Message)
 900    CLOSE (10)


C *** Load number of variables selected into toggle field
C *** for the number of factors
        IF (NVar .LE. maxfactors) THEN
           f = Fld Index ('NFACT     ')
           SC Members (f) = NVar - 1
        ELSE
           f = Fld Index ('NFACT     ')
           SC Members (f) = maxfactors
        ENDIF
        RETURN

 999    call flash(20,2,'An error has been found in your data...')
        CALL putstr ('Type "c" to continue anyway:     ',33,20, 2,0)
        call getthekey(i)
        if (char(i) .eq. 'c' .or. char(i) .eq. 'C') then
           error = .false.
           CALL Erase (20, 2, 75)
           goto 900
        end if
 
        CLOSE (10)
        NVar = 0
        NSuppVar = 0
        Error = .TRUE.
        CALL Beep
	CALL Flash (20, 2, 'ERROR reading data file.')
        CALL erase (20,2,75)
        RETURN
        END



