C*******************************************************************
C  File generic.inc - generic declarations for use with most geoeas 
C                     files
C
C  Description for common blocks and parameter values
C  MaxVar      - Maximum number of variables used in program
C  MaxFileVar  - Maximum number of variables in the data file
C  MaxSamples  - Maximum number of data records in the data file
C  MaxSuppVar  - Maximum number of supplementary variables 
C  MaxFactors  - Maximum number of factors used in program


cclong These are also given in anerr.for, so if they are to be 
cc changed then they must be changed there too!
        PARAMETER (MaxVar = 38)
        PARAMETER (MaxSuppVar = 10)
        PARAMETER (MaxFileVar = 48)
        PARAMETER (MaxSamples = 10000)

C********************************************************************
C /FILES/     -  Common block for file names
C 
C FilePrefix     - File prefix for file names
C DataFile       - Data file name
c Outfile        - output file name

        COMMON /FILES/ DataFile, FilePrefix, outFile, FileName

	CHARACTER*14  DataFile, FilePrefix*80, outfile
	CHARACTER*64  FileName
 
C*********************************************************************
C /DATFIL/     - Common block for the data 
C
C Header           - Title from the data file
C FileNVar         - Number of variables in the data file
C FileVarNam       - Array of variable names in data file
C FileUnits        - Array of measurement units for each variable
C FileFormats      - Array of format specifications for each variable
C NVar             - Number of variables selected
C VarNam           - Array of variable names selected
C PIJ              - Array of variable values
C NSuppVar         - Number of supplementary variables
C SVarNam          - Array of supplementary variable names selected
C PSIJ             - Array of supplementary variables values
C NSamples         - Number of samples

        COMMON /DATFIL/ Header, FileNVar, FileVarNam, FileUnits,
     +                  FileFormats, NVar, VarNam, PIJ, NSuppVar,
     +                  SVarNam, PSIJ, NSamples 

        CHARACTER*10  FileVarNam (MaxFileVar)*20, FileUnits (MaxVar), 
     +                FileFormats (MaxFileVar), 
     +                VarNam (MaxVar), SVarNam (MaxSuppVar)
        CHARACTER  Header*80, MenuChoice*12, Message*75

        INTEGER*4     NVar, FileNVar, NSamples, NSuppVar
        REAL*8        PIJ (MaxSamples,MaxVar), 
     +                PSIJ (MaxSamples,MaxSuppVar)

        LOGICAL       Intro
        COMMON /MISC/  Intro, menuchoice, message
