C Parmfile.for - parameter file read and write routines
C----------------------------------------------------------------------
C Read Parameters - Reads parameter file for program KRIGE
C
        SUBROUTINE Read Parameters (File Name, Error) 
	IMPLICIT INTEGER*4 (A-Z)

        INCLUDE 'krige.dec'

        LOGICAL  	Error
	CHARACTER	File Name*(*), Signature*13, filenam*60
        INTEGER*4  	IntVal, Struc, Jvar, LUN
	DATA 		LUN /10/

        Error = .FALSE.

C Open File
        OPEN (FILE = File Name, UNIT = 10,
     +       STATUS = 'old', ERR = 200)
        
C Check if valid
	READ  (LUN,15, ERR = 200) Signature
	IF (Signature(5:9) .NE. 'KRIGE') GOTO 200
        
C File Names Record
        READ (LUN,15, ERR = 200) Data File
        READ (LUN,15, ERR = 200) OutFile
        READ (LUN,15, ERR = 200) PolyFile        

C Title Record
        READ (LUN,15, ERR = 200) Title

C Grid Parameters Records
        READ (LUN,*, ERR = 200)
     +                    Xvar, Xorigin, XcellSize, Nxcells,
     +                    Yvar, Yorigin, YcellSize, Nycells 

C Search Parameters Records
        READ (LUN,*, ERR = 200) SrMajor, SrMinor, SrAngle,
     +                       IntVal, Nsector, Minp, Maxps, Maxempty
        Euclidean = (IntVal .EQ. 0)

C Kriging Type Record
        READ (LUN,*, ERR = 200) Ktype, IntVal
        Point = (IntVal .EQ. 0)
       	Ndiscr = IntVal + 1

C Number of Variables Record, Variables and Variogram Structure Records
        READ (LUN,*, ERR = 200) NkVar
        DO JVar = 1, NkVar
           READ (LUN,*, ERR = 200) 
     +            KrigVar (JVar), Nugget (Jvar),
     +		  Mglobal (Jvar), Ndigits (Jvar)
           DO Struc = 1, 4
              READ (LUN,*, ERR = 200) 
     +             Mtype   (Struc, Jvar),
     +             Sill    (Struc, Jvar),
     +             VrMajor (Struc, Jvar),
     +             VrMinor (Struc, Jvar),
     +             VrAngle (Struc, Jvar)
           enddo
        enddo
	Current Var = 1
        CLOSE (LUN)
        RETURN

C Error Encountered Reading ascii Parameter File: try binary...
 200    CLOSE (LUN)
        filenam=file name
        call flash(20,2,'error reading '//filenam)
        OPEN (FILE = File Name, UNIT = 10, FORM = 'UNFORMATTED', 
     +		STATUS = 'unknown', ERR = 100)

C Check if valid
	READ  (LUN, ERR = 100) Signature
	IF (Signature(5:9) .NE. 'KRIGE') GOTO 100
        
C File Names Record
        READ (LUN, ERR = 100) 	    
     +          Data File, OutFile, PolyFile

C Title Record
        READ (LUN, ERR = 100) Title

C Grid Parameters Records
        READ (LUN, ERR = 100)
     +                    Xvar, Xorigin, XcellSize, Nxcells,
     +                    Yvar, Yorigin, YcellSize, Nycells 

C Search Parameters Records
        READ (LUN, ERR = 100) SrMajor, SrMinor, SrAngle,
     +                       IntVal, Nsector, Minp, Maxps, Maxempty
        Euclidean = (IntVal .EQ. 0)

C Kriging Type Record
        READ (LUN, ERR = 100) Ktype, IntVal
        Point = (IntVal .EQ. 0)
       	Ndiscr = IntVal + 1

C Number of Variables Record, Variables and Variogram Structure Records
        READ (LUN, ERR = 100) NkVar
        DO 10 JVar = 1, NkVar
           READ (LUN, ERR = 100) 
     +            KrigVar (JVar), Nugget (Jvar),
     +		  Mglobal (Jvar), Ndigits (Jvar)
           DO 20 Struc = 1, 4
                 READ (LUN, ERR = 100) 
     +                 Mtype   (Struc, Jvar),
     +                 Sill    (Struc, Jvar),
     +                 VrMajor (Struc, Jvar),
     +                 VrMinor (Struc, Jvar),
     +                 VrAngle (Struc, Jvar)
 20        CONTINUE          
 10     CONTINUE
	Current Var = 1
        CLOSE (LUN)
        RETURN

 100    close(LUN)
        Error = .TRUE.
 15     format(a)
        RETURN
        END

C----------------------------------------------------------------------
C Save Parameters - Writes parameter file for program KRIGE
C
        SUBROUTINE Save Parameters (File Name, Error) 
	IMPLICIT INTEGER*4 (A-Z)

        INCLUDE 'krige.dec'

        LOGICAL  	Error
        INTEGER*4  	IntVal, Struc, Jvar
	CHARACTER	File Name*(*), Signature*13
	DATA 		LUN /10/
	DATA 		Signature /'    KRIGE    '/

        Error = .FALSE.

 15     format(a)
C Open File
        OPEN (FILE = File Name, UNIT = LUN, 
     +	     STATUS = 'unknown', ERR = 100)

	WRITE  (LUN,15, ERR = 100) Signature
        Error = .FALSE.

C File Names Record
        WRITE (LUN,15, ERR = 100) Data File
        WRITE (LUN,15, ERR = 100) OutFile
        WRITE (LUN,15, ERR = 100) PolyFile

C Title Record
        WRITE (LUN,15, ERR = 100) Title

C Grid Parameters Records
        WRITE (LUN,*, ERR = 100)
     +                    Xvar, Xorigin, XcellSize, Nxcells,
     +                    Yvar, Yorigin, YcellSize, Nycells 

C Search Parameters Records
	IntVal = 1
	IF (Euclidean) IntVal = 0
        WRITE (LUN,*, ERR = 100) SrMajor, SrMinor, SrAngle,
     +                       IntVal, Nsector, Minp, Maxps, Maxempty

C Kriging Type Record
        WRITE (LUN,*, ERR = 100) Ktype, Ndiscr-1 

C Number of Variables Record, Variables and Variogram Structure Records
        WRITE (LUN,*, ERR = 100) NkVar
        DO 10 JVar = 1, NkVar
           WRITE (LUN,*, ERR = 100) 
     +            KrigVar (JVar), Nugget (Jvar),
     +		  Mglobal (Jvar), Ndigits (Jvar)
           DO 20 Struc = 1, 4
                 WRITE (LUN,*, ERR = 100) 
     +                 Mtype   (Struc, Jvar),
     +                 Sill    (Struc, Jvar),
     +                 VrMajor (Struc, Jvar),
     +                 VrMinor (Struc, Jvar),
     +                 VrAngle (Struc, Jvar)
 20        CONTINUE          
 10     CONTINUE
        CLOSE (LUN)
        RETURN

C Error Encountered Writing Parameter File
 100    Error = .TRUE.
	CALL Flash (20, 2, 'WRITE error during parameter save')
        CLOSE (LUN)
        RETURN
        END

C----------------------------------------------------------------------
C Save Parameters - Writes parameter file for program KRIGE
C
        SUBROUTINE Save unformatted Parameters (File Name, Error) 
	IMPLICIT INTEGER*4 (A-Z)

        INCLUDE 'krige.dec'

        LOGICAL  	Error
        INTEGER*4  	IntVal, Struc, Jvar
	CHARACTER*65	File Name, Signature*13
	DATA 		LUN /10/
	DATA 		Signature /'    KRIGE    '/

        Error = .FALSE.

C Open File
        OPEN (FILE = File Name, UNIT = LUN, FORM = 'UNFORMATTED', 
     +	     STATUS = 'unknown', ERR = 100)

	WRITE  (LUN, ERR = 100) Signature
        Error = .FALSE.

C Open File
        OPEN (FILE = File Name, UNIT = LUN, FORM = 'UNFORMATTED',
     +	     STATUS ='unknown',	ERR = 100)
        
C File Names Record
        WRITE (LUN, ERR = 100) 
     +          Data File, OutFile, PolyFile

C Title Record
        WRITE (LUN, ERR = 100) Title

C Grid Parameters Records
        WRITE (LUN, ERR = 100)
     +                    Xvar, Xorigin, XcellSize, Nxcells,
     +                    Yvar, Yorigin, YcellSize, Nycells 

C Search Parameters Records
	IntVal = 1
	IF (Euclidean) IntVal = 0
        WRITE (LUN, ERR = 100) SrMajor, SrMinor, SrAngle,
     +                       IntVal, Nsector, Minp, Maxps, Maxempty

C Kriging Type Record
        WRITE (LUN, ERR = 100) Ktype, Ndiscr-1 

C Number of Variables Record, Variables and Variogram Structure Records
        WRITE (LUN, ERR = 100) NkVar
        DO 10 JVar = 1, NkVar
           WRITE (LUN, ERR = 100) 
     +            KrigVar (JVar), Nugget (Jvar),
     +		  Mglobal (Jvar), Ndigits (Jvar)
           DO 20 Struc = 1, 4
                 WRITE (LUN, ERR = 100) 
     +                 Mtype   (Struc, Jvar),
     +                 Sill    (Struc, Jvar),
     +                 VrMajor (Struc, Jvar),
     +                 VrMinor (Struc, Jvar),
     +                 VrAngle (Struc, Jvar)
 20        CONTINUE          
 10     CONTINUE
        CLOSE (LUN)
        RETURN

C Error Encountered Writing Parameter File
 100    Error = .TRUE.
	CALL Flash (20, 2, 'WRITE error during parameter save')
        CLOSE (LUN)
        RETURN
        END

C----------------------------------------------------------------------
C Assign Screen Fields - set up screen fields for new parameters (KRIGE)

        SUBROUTINE Assign Screen Fields
	IMPLICIT INTEGER*4 (A-Z)

        INCLUDE 'krige.dec'
        INCLUDE '../common/screen.str'

	INTEGER*4 Field1, Field2, Field3, Fld Index
	CHARACTER Num*1, Scratch*13
	DATA Scratch /'             '/

    	CALL Set Character Value('FILEPREFIX', File Prefix)
    	CALL Set Character Value('DATAFILE  ', Data File)
    	CALL Set Character Value('POLYFILE  ', Poly File)
    	CALL Set Character Value('OUTFILE   ', Out File )
    	CALL Set Character Value('OUTTITLE  ', Title    )

	CALL Set 4FloatingPoint Value ('GR XORG   ', Xorigin, 3)
	CALL Set 4FloatingPoint Value ('GR YORG   ', Yorigin, 3)
	CALL Set 4FloatingPoint Value ('GR XCSIZE ', XcellSize, 3)
	CALL Set 4FloatingPoint Value ('GR YCSIZE ', YcellSize, 3)
	CALL Set Integer   Value ('GR XNCELL ', NxCells)
	CALL Set Integer   Value ('GR YNCELL ', NyCells)

	CALL Set Toggle Position      ('TY KRIGE  ', Ktype)
	CALL Set Toggle Position      ('TY PTBLOCK', Ndiscr-1)

	Field1 = Fld Index ('SE MAXPO  ')
        Field2 = Fld Index ('SE MINPT  ')
        Field3 = Fld Index ('SE MAXEMPT')

        SC Position (Field1) = MaxPs - 1
        SC Position (Field2) = MinP  - 1
        SC Position (Field3) = MaxEmpty
        IF (Nsector .EQ. 1) THEN
           SC Members  (Field1) = 24
           SC Members  (Field3) = 1
        ELSEIF (Nsector .EQ. 4) THEN
           SC Members  (Field1) = 16
           SC Members  (Field2) = 16
           SC Members  (Field3) = 4
        ELSEIF (Nsector .EQ. 8) THEN                
           SC Members  (Field1) = 8
           SC Members  (Field2) = 8
           SC Members  (Field3) = 8
        ENDIF
	Pos = 1
        IF (Euclidean) Pos = 0
        CALL Set Toggle Position  ('SE DTYPE  ', Pos)
	CALL Set Toggle Position  ('SE MAXPO  ', MaxPs-1)
	CALL Set Toggle Position  ('SE MINPT  ', MinP-1)
	CALL Set Toggle Position  ('SE ETYPE  ', Nsector/4)
	CALL Set Toggle Position  ('SE MAXEMPT', MaxEmpty)
	CALL Set 4FloatingPoint Value ('SE RMAJOR ', SrMajor, 3)
	CALL Set 4FloatingPoint Value ('SE RMINOR ', SrMinor, 3)
	CALL Set 4FloatingPoint Value ('SE ANGLE  ', SrAngle, 3)

	J = Current Var
	CALL Set 4Floating Point Value ('VM NUGGET ', Nugget (J), 3)
	CALL Set Toggle Position ('VM NDIGITS', Ndigits (J))
	IF (Ktype .EQ. ORDINARY)  THEN 
     	  CALL Set Character Value ('VM MGLOBAL', Scratch)
	ELSE
	  CALL Set 4Floating Point Value ('VM MGLOBAL', Mglobal (J), 3)
	ENDIF

	DO 10 I = 1, 4
	  WRITE (Num, '(I1)') I
	  CALL Set Toggle Position ('VM TYPE  '//Num, Mtype (I, J))
	  IF (Mtype (I, J) .GT. 0) THEN
	    CALL Set 4Floating Point Value ('VM SILL  '//Num,
     +		Sill (I, J), 3) 
	    CALL Set 4Floating Point Value ('VM RMAJOR'//Num, 
     +		VrMajor (I, J), 3) 
	    CALL Set 4Floating Point Value ('VM RMINOR'//Num, 
     +		VrMinor (I, J), 3) 
	    CALL Set 4Floating Point Value ('VM ANGLE '//Num, 
     +		VrAngle (I, J), 3) 
	  ELSE
	     CALL Set Character Value ('VM SILL  '//Num, Scratch)
	     CALL Set Character Value ('VM RMAJOR'//Num, Scratch)
	     CALL Set Character Value ('VM RMINOR'//Num, Scratch)
	     CALL Set Character Value ('VM ANGLE '//Num, Scratch)
	  ENDIF
 10	CONTINUE

	RETURN
	END

 




