cc$LARGE
C 
C Varmodel.for - routines for variables/models selection - program KRIGE
C----------------------------------------------------------------------
C Load VarModel - loads model parameters into screen fields,  displays them
C
        SUBROUTINE Load VarModel
	IMPLICIT INTEGER*4 (A-Z)

        INCLUDE 'krige.dec'

	CHARACTER*10    Typ, Sil, Range1, Range2, Angle
	CHARACTER*10	Nuget, Global, Kvar
	CHARACTER*13	Scratch, Num*1

	DATA		Scratch/'             '/
        DATA            Typ    /'VM TYPE   '/
        DATA            Sil    /'VM SILL   '/
        DATA            Range1 /'VM RMAJOR '/
        DATA            Range2 /'VM RMINOR '/
        DATA            Angle  /'VM ANGLE  '/
        DATA            Global /'VM MGLOBAL'/
	DATA		Kvar   /'KRIGEVAR  '/
	DATA		Nuget  /'VM NUGGET '/
        
	IF (Current Var .LT. 1) THEN
	   CALL Clear Fields
	   CALL Set Toggle Position (Kvar, 0)
	   CALL Display Fields
	ENDIF

C Load Values into screen fields
	CALL Set Toggle Position (Kvar,	KrigVar (Current Var) - 1)
	CALL Display One Field (Kvar)

	IF (Ktype .EQ. SIMPLE) THEN
          CALL Set 4 Floating Point Value 
     +		(Global, Mglobal (Current Var), 3)
	ELSE
	  CALL Set Character Value (Global, Scratch)       
	ENDIF
	CALL Display One Field (Global)
	
	CALL Set 4Floating Point Value (Nuget, Nugget (Current Var), 3)
	CALL Display One Field (Nuget)

        DO 10 I = 1, 4
	   Write (Num, '(I1)') I
	   Typ    (10:10) = Num
	   Sil    (10:10) = Num
	   Range1 (10:10) = Num
	   Range2 (10:10) = Num
	   Angle  (10:10) = Num
	   CALL Set Toggle Position (Typ, Mtype (I, Current Var))

C Put out info for structure, unless none (then blank out fields)
	   IF (Mtype (I, Current Var) .NE. 0) THEN
             CALL Set 4FloatingPoint Value 
     +		(Sil,    Sill    (I, Current Var), 3)
             CALL Set 4FloatingPoint Value 
     +		(Range1, VrMajor (I, Current Var), 3)
             CALL Set 4FloatingPoint Value 
     +		(Range2, VrMinor (I, Current Var), 3)
             CALL Set 4FloatingPoint Value 
     +		(Angle,  VrAngle (I, Current Var), 3)
	   ELSE
	     CALL Set Character Value (Sil,    Scratch)
	     CALL Set Character Value (Range1, Scratch)
	     CALL Set Character Value (Range2, Scratch)
	     CALL Set Character Value (Angle , Scratch)
	   ENDIF
	   CALL Display One Field (Typ)
	   CALL Display One Field (Sil)
	   CALL Display One Field (Range1)
	   CALL Display One Field (Range2)
 	   CALL Display One Field (Angle)
 10     CONTINUE           

C Set global for current variable index and update the kriging list
        RETURN
        END

C----------------------------------------------------------------------
C Display KrigList  - Display Kriging List for variables/models

        SUBROUTINE Display KrigList

	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (REVERSE = 2, NORMAL = 0)

        INCLUDE 'krige.dec'

        INTEGER*4       I, Pos
	CHARACTER*10	Menu Name, Val*2

	DATA Menu Name /'VSELECT'/

	DO 5 I = 1, MAXVARK
	  CALL Erase (I+6, 4, 11)
 5	CONTINUE
	IF (NkVar .LE. 0) RETURN

C Put out selected variable names
        DO 10 I = 1, MAXVARK
	   WRITE (Val, '(I2)') I
	   CALL PutStr (Val, 2, I+6, 1, 0)
	   IF (I .LE. NkVar) 
     +         CALL PutStr (VarNam (KrigVar (I)), 10, I+6, 4, NORMAL)
 10     CONTINUE

C Highlight menu item for current variable
	CALL PutStr ('', 1, Current Var+6, 14, 2)
	CALL Set Menu Position (Menu Name, Current Var)
        RETURN
        END          
        
C----------------------------------------------------------------------
C Delete VarModel - allow user to delete variable/model (KRIGE)

        SUBROUTINE Delete VarModel (Index)
	IMPLICIT INTEGER*4 (A-Z)

	PARAMETER (REVERSE = 2, NORMAL = 0)

        INCLUDE 'krige.dec'

        INTEGER*4       Index, I, J
	LOGICAL	GetYesNo, Verified 

C Prompt for deletion
	Verified = .FALSE.
	Verified = GetYesNo (20, 2,
     +	 'Are you sure you want to delete this entry? <Y/N>')
	IF (.NOT. Verified) GOTO 100

C If Index was not last list element, then compress arrays        
        IF (Index .LT. NkVar) THEN
           DO 10 I = Index, NkVar-1
              DO 20 J = 1, 4
                 Mtype   (J, I) = Mtype   (J, I+1)
                 Sill    (J, I) = Sill    (J, I+1)
                 VrMajor (J, I) = VrMajor (J, I+1)
                 VrMinor (J, I) = VrMinor (J, I+1)
                 VrAngle (J, I) = VrAngle (J, I+1)  
 20           CONTINUE
              KrigVar (I) = KrigVar (I+1)
	      Nugget  (I) = Nugget  (I+1)
	      Mglobal (I) = Mglobal (I+1) 
 10        CONTINUE
        ENDIF
  
C Zero the last list element
        DO 30 J = 1, 4
           Mtype   (J, NKvar) = 0
           Sill    (J, NkVar) = 0.0
           VrMajor (J, NkVar) = 0.0
           VrMinor (J, NkVar) = 0.0
           VrAngle (J, NkVar) = 0.0
 30     CONTINUE
        KrigVar (NkVar) = 0
        Nugget  (NkVar) = 0.0
	Mglobal (NkVar) = 0.0

C Decrement list size
        NkVar = NkVar - 1
	IF (Current Var .GT. NkVar) Current Var = NkVar

C Load variable/models parameters into screen fields & display new list
 	CALL Load VarModel
	CALL Display KrigList
 100	IF (Verified .AND. NkVar .GT. 0)  CALL Flash (20, 2,
     +	 'Variable/Model have been deleted... (press any key)')
	IF (NkVar .EQ. 0) THEN   
	   CALL Beep        
	   CALL Flash (20, 2, 'Kriging list is empty... (press a key)')
	ENDIF
	RETURN
	END 


