C Parmfile.for - parameter file read and write routines
C----------------------------------------------------------------------
C Read Parameters - Reads parameter file for program COKRIGING
C
        SUBROUTINE Read Parameters (File Name, Error)
        IMPLICIT INTEGER*4 (A-Z)

		INCLUDE 'cokrig.inc'

        LOGICAL         Error
        CHARACTER*65    File Name, Signature*9
        INTEGER*4       Struc, Jvar, LUN
	real radcon, asill
        DATA            LUN /10/

        Error = .FALSE.

C Open File
        OPEN (FILE = File Name, UNIT = 10, 
     +   STATUS = 'OLD', ERR = 100)
666	format(a)

        READ (LUN,666) Data File 
        READ (LUN,666) OutFile
        READ (LUN,666) PchFile
        READ (LUN,666) Title
        read(LUN,*) ipkrig, mvar, idbug, ilist, idual
	read(lun,*) icx, icy, icz, (icv(i),i = 1, mvar)
        read(lun,*) xeast, ynorth, zelev
        read(lun,*) xlbl, ylbl, zlbl
        read(lun,*) npx, npy, npz, nse, nfe,
     &        nsn, nfn, nsb, nfb, minhol, maxhol
        read(lun,*) azmuth, dip, radiia, radiib, radiic

      radcon = asin(1.0) / 90.0
      sazm = sin(azmuth * radcon)
      cazm = cos(azmuth * radcon)
      sdip = sin(dip * radcon)
      cdip = cos(dip * radcon)
      if (radiib .gt. 0.0) then
         aff1 = radiia / radiib
      else
         aff1 = 0.0
      end if
      if (radiic .gt. 0.0) then
         aff2 = radiia / radiic
      else
         aff2 = 0.0
      end if

	dimen = 3
	if (icz .eq. 0) dimen = 2

        do 62 i = 1, mvar
           read(lun,666, err=100) name(i+dimen)
 62     continue
        read(lun,*) (wgt(i),i = 1, mvar)
        do 70 j = 1, mvar
           ntermp(j) = nxcol
           np = ntermp(j) + 1
           read(lun,*) nterm(j), ex(np), ey(np), ez(np)
           nxcol = nxcol + 1
           if (nterm(j) .lt. 1) nterm(j) = 1
           do 65 k = 2, nterm(j)
              np = ntermp(j) + k
              nxcol = nxcol + 1
              if (np .gt. mterm) goto 100
              read(lun,*) iblank, ex(np), ey(np), ez(np)
 65        continue
 70      continue
       do 95 i = 1, mvar*(mvar+1)/2
          read(lun,*) ii, jj, inest, intyp, asill
         if (ii .gt. jj) then
            kk = ndg(ii) + jj
         else
            kk = ndg(jj) + ii
         end if
         nest(kk) = inest
         ntypcs(kk) = intyp
         sill(kk) = asill

	  do 93 j = nestp(kk) + 1, nestp(kk) + nest(kk)
             read(lun,*) nvtype(j), nsign(j), c(j),
     &        aaxis(j), baxis(j), caxis(j), theta(j), beta(j)
	      if (baxis(j) .gt. 0.0) then
	      afaob(j) = aaxis(j) / baxis(j)
	      else
	      afaob(j) = 0.0
	      end if
	      if (caxis(j) .gt. 0.0) then
	      afaoc(j) = aaxis(j) / caxis(j)
	      else
	      afaoc(j) = 0.0
	      end if
	      stheta(j) = sin(theta(j) * radcon)
	      ctheta(j) = cos(theta(j) * radcon)
	      sbeta(j) = sin(beta(j) * radcon)
	      cbeta(j) = cos(beta(j) * radcon)
   93    continue
   95  continue

        CLOSE (10)
        RETURN

C Error Encountered Reading Parameter File
 100    Error = .TRUE.
        CLOSE (10)
        RETURN
        END

C----------------------------------------------------------------------
C Save Parameters - Writes parameter file for program COKRIGING
C
        SUBROUTINE Save Parameters (File Name, Error)
        IMPLICIT INTEGER*4 (A-Z)

		INCLUDE 'cokrig.inc'

        LOGICAL         Error, Exist
        INTEGER*4       IntVal, Struc, Jvar
        CHARACTER*65    File Name, Signature*17
        DATA            LUN /10/
        DATA            Signature /'COKRIGING'/

        Error = .FALSE.

C Open File
        OPEN (UNIT = LUN, FILE = File Name, 
     +   status='unknown', err = 100)

664	format(2(i6,1x),e13.6,/)
665	format(5(i6,1x),/)
666	format(a)
667	format(3(/,1x,a,/))
669	format(6(e13.6,1x),/)
670	format(3(i6,1x,2(e13.6,1x),2(i6,1x),/))

        Error = .FALSE.

C File Names Record
        WRITE(LUN,666) Data File 
        WRITE(LUN,666) OutFile
        WRITE(LUN,666) PchFile
        WRITE(LUN,666) Title
        WRITE(LUN,*) ipkrig, mvar, idbug, ilist, idual
	if (dimen .eq. 3) then
           write (lun,*) icx, icy, icz, (icv(i),i = 1, mvar)
	else
           write (lun,*) icx, icy, 0, (icv(i),i = 1, mvar)
	end if
        write(lun, *) xeast, ynorth, zelev
        write(lun, *) xlbl, ylbl, zlbl
        write(lun, '(11(i5,x))') npx, npy, npz, nse, nfe,
     &        nsn, nfn, nsb, nfb, minhol, maxhol
        write(lun, *) azmuth, dip, radiia, radiib, radiic
        do 62 i = 1, mvar
           write(lun,'(a)', err=100) name(i+dimen)
 62     continue
        write(lun,*) (wgt(i),i = 1, mvar)
        do 70 j = 1, mvar
           ntermp(j) = nxcol
           np = ntermp(j) + 1
           write(lun,*) nterm(j), ex(np), ey(np), ez(np)
           nxcol = nxcol + 1
           if (nterm(j) .lt. 1) nterm(j) = 1
           do 65 k = 2, nterm(j)
              np = ntermp(j) + k
              nxcol = nxcol + 1
              if (np .gt. mterm) goto 100
              write(lun,*) iblank, ex(np), ey(np), ez(np)
 65        continue
 70    continue
       do 95 ii = 1, mvar
	do 94 jj = ii, mvar
	  kk = ndg(jj) + ii
          write(lun,*) ii, jj, nest(kk), ntypcs(kk), sill(kk)
	  do 93 j = nestp(kk) + 1, nestp(kk) + nest(kk)
             write(lun,*) nvtype(j), nsign(j), c(j),
     &        aaxis(j), baxis(j), caxis(j), theta(j), beta(j)
   93    continue
   94   continue
   95  continue

        CLOSE (10)
        RETURN

C Error Encountered Writing Parameter File
 100    Error = .TRUE.
        CALL Flash (20, 2, 'WRITE error during parameter save')
        CLOSE (10)
        RETURN
        END

C----------------------------------------------------------------------
C Assign Screen Fields - set up screen fields for new parameters (COKRIGING)

        SUBROUTINE Assign Screen Fields
        IMPLICIT INTEGER*4 (A-Z)

		INCLUDE  'cokrig.inc'
		INCLUDE  '../common/screen.str'

        INTEGER*4 Field1, Field2, Field3, Fld Index
        CHARACTER Num*1, Scratch*13
        DATA Scratch /'             '/


        CALL Set Character Value('FILEPREFIX', File Prefix)
        CALL Set Integer Value ('DIMEN     ',Dimen)
        CALL Set Integer Value ('VARK      ',Mvar)
        CALL Set Character Value('DATAFILE  ', Data File)
        CALL Set Character Value('PCHFILE   ', PchFile)
        CALL Set Character Value('OUTFILE   ', OutFile )
        CALL Set Character Value('OUTTITLE  ', Title    )

        CALL Set Integer   Value ('SW IDBUG  ', IDBUG)
        CALL Set Integer   Value ('SW ILIST  ', ILIST)
        CALL Set Integer   Value ('TY KRIGE  ', IDUAL)
        CALL Set Integer   Value ('TY PTBLOCK', IPKRIG)
        CALL Set Integer   Value ('TY NPX    ', NPX)
        CALL Set Integer   Value ('TY NPY    ', NPY)
        CALL Set Integer   Value ('TY NPZ    ', NPZ)
        CALL Set 4FloatingPoint Value ('GR XORG   ', XEAST, 3)
        CALL Set 4FloatingPoint Value ('GR YORG   ', YNORTH, 3)
        CALL Set 4FloatingPoint Value ('GR ZORG   ', ZELEV, 3)
        CALL Set 4FloatingPoint Value ('GR XCSIZE ', XLBL, 3)
        CALL Set 4FloatingPoint Value ('GR YCSIZE ', YLBL, 3)
        CALL Set 4FloatingPoint Value ('GR ZCSIZE ', ZLBL, 3)
        CALL Set Integer   Value ('GR NSE    ', NSE)
        CALL Set Integer   Value ('GR NSN    ', NSN)
        CALL Set Integer   Value ('GR NSB    ', NSB)
        CALL Set Integer   Value ('GR NFE    ', NFE)
        CALL Set Integer   Value ('GR NFN    ', NFN)
        CALL Set Integer   Value ('GR NFB    ', NFB)

        CALL Set Integer   Value ('SE MINHOL ', MINHOL)
        CALL Set Integer   Value ('SE MAXHOL ', MAXHOL)

        CALL Set 4FloatingPoint Value ('SE AZMUTH ', AZMUTH, 3)
        CALL Set 4FloatingPoint Value ('SE DIP    ', DIP, 3)
        CALL Set 4FloatingPoint Value ('SE RADIIA ', RADIIA, 3)
        CALL Set 4FloatingPoint Value ('SE RADIIB ', RADIIB, 3)
        CALL Set 4FloatingPoint Value ('SE RADIIC ', RADIIC, 3)
C*******Initialize drift menu values.
        CALL SET INTEGER   VALUE('DF NUM    ',1)
        CALL SET INTEGER   VALUE('DF TERM   ',NTERM(1))
        CALL SET INTEGER   VALUE('DF TERMI  ',1)
        NP = NTERMP(MVAR) + NTERM(MVAR)
        CALL SET 4FLOATINGPOINT VALUE ('DF XEXPI  ',EX(1),3)
        CALL SET 4FLOATINGPOINT VALUE ('DF YEXPI  ',EY(1),3)
        CALL SET 4FLOATINGPOINT VALUE ('DF ZEXPI  ',EZ(1),3)
        CALL SET TOGGLE POSITION      ('DF VAR    ',(ICV(1)-1))
C*******Initialize variogram screen values.
        KK = NDG(MVAR) + MVAR
        CALL SET INTEGER VALUE('VRM ENTRY  ',KK)
        CALL SET INTEGER VALUE('VRM CROSS  ',NTYPCS(KK))
        CALL SET INTEGER VALUE('VRM NEST   ',NEST(KK))
        CALL SET 4 FLOATING POINT VALUE('VRM SILL   ',SILL(KK),3)
        J = ((KK - 1)*maxn) + NEST(KK)
        CALL SET INTEGER VALUE('VRM NUM    ',NEST(KK))
        CALL SET INTEGER VALUE('VRM TYPE   ',NVTYPE(J))
        LOCATION = ((NSIGN(J) * NSIGN(J)) - NSIGN(J)) / 2
        CALL SET TOGGLE POSITION('VRM SIGN   ',LOCATION)
        CALL SET 4 FLOATING POINT VALUE('VRM CILL   ',C(J),3)
        CALL SET 4 FLOATING POINT VALUE('VRM RANGEA ',AAXIS(J),3)
        CALL SET 4 FLOATING POINT VALUE('VRM RANGEB ',BAXIS(J),3)
        CALL SET 4 FLOATING POINT VALUE('VRM RANGEC ',CAXIS(J),3)
        CALL SET 4 FLOATING POINT VALUE('VRM AZMUTH ',THETA(J),3)
        CALL SET 4 FLOATING POINT VALUE('VRM DIP    ',BETA(J),3)
        CALL SET TOGGLE POSITION ('VRM VARIA  ',ICV(MVAR)-1)

        RETURN
        END
