cc    $LARGE
C     BoxVplot.for - variogram boxplot for VARIO
C----------------------------------------------------------------------
C     Box Vplot - BoxPlot for VARIO
      
      SUBROUTINE Box Vplot
      IMPLICIT INTEGER*4 (A-Z)
      
      INCLUDE 'vario.dec'
      
      REAL*4	    TxMin, TxMax, TyMin, TyMax, TxTinc, TyTinc
      REAL*4	    TMinx, TMaxx, TMiny, TMaxy
      REAL*4      Dx, Dy, Mx, My, Tx, Ty, RMIN, RMAX
      REAL*4	    Xfudge, YFudge, Width
      INTEGER*4   I, J, N, LENSTR, L, TnX, TnY
      CHARACTER   TTitle*70, Vlabel*30, Xlabel*40, Ylabel*40
      character*72 message, menu choice
      
cclong11/30/93
      CALL New Screen (9)
      call put menu ('POSTSCR')
      call set character value('PSFILEN','boxplot.ps')
cclong11/30/93
      
C     check for no data
      IF (Nkept .LT. 1) RETURN
      
C     Compute axis boundry and tic interval parameters
 1    message = 'Computing Boxplot...' 
      i = lenstr(message)
      CALL PutStr (message,i, 20, 2, 2)
      TXmin	=  RMIN (AvgDist,  Nlag)
      TXmax	=  RMAX (AvgDist,  NLag)
      TYmin	=  RMIN (Vmin,     Nlag)
      TYmax   =  RMAX (Vmax,     Nlag)
      CALL NeatAx (TXmin, TXmax, TXtinc, TNx)
      CALL NeatAx (TYmin, TYmax, TYtinc, TNy)
      
C     Compute symbol sizes, and scaling stuff
      Dx 	= ABS (TXmax - TXmin)
      Dy 	= ABS (TYmax - TYmin)
      Xfudge  = Dx * 0.15
      Yfudge  = Dy * 0.2
      TMinx 	= TXmin - (Xfudge*1.9)
      TMiny 	= TYmin -  Yfudge
      TMaxx 	= TXmax + (Xfudge*3.8)
      TMaxy 	= TYmax + (Yfudge*1.5)
      Mx 	= Dx * .01 / Aspect 
      My 	= Dy * .01
      
C     Set up labels
      IF (Log) THEN
         L = LENSTR (Varnam (Var))
         Vlabel = 'LN'//Varnam (Var) (1:L) //')'
      ELSE
         Vlabel = VarNam (Var)
      ENDIF
      TTitle = 'Boxplot for '//Vlabel
      Xlabel = 'Distance '
      Ylabel = 'Difference squared'
      
C     graphics setup 
      CALL Zsetup (INT2 (Gmode), Ierr)
      CALL Zcolor (INT2 (White))
      CALL Zlbdir (0.0)
      CALL Zlocat (XMinDev, XmaxDev, YminDev, YmaxDev)
      CALL Zscale (TMinx, TMaxx, TMiny, TMaxy)
      CALL Grframe (Xmaxdev, Ymaxdev, Blue) 
      
C     Draw and label the axes
      CALL Axes (TTitle, Xlabel, Ylabel, ' ',
     +     TXmin, TXmax, TYmin, TYmax, TXtinc, TYtinc, DevCode)
      
C     Plot variogram Values
      Width = Dx *.035
      DO 10 I = 1, Nlag
         CALL Boxplot (VMin (I), VQ1 (I), VMedian (I), 
     +        Vmean (I), VQ3 (I), Vmax (I), 
     +        .FALSE., AvgDist (I), Width, (Dy*.007))
 10   CONTINUE
      
      CALL Plot Vstats (tXmin, tXmax, tYmin, tYmax)
      
cclong11/30/93
      CALL Erase(20,2,76)
      call get character value('PSFILEN',message)
      CALL Erase(5,10,60)
      call putstr(message(1:60),60,5,10,2)
      CALL Get Menu Choice ('POSTSCR',Menu choice)
      if (menu choice .eq. 'File') then
         CALL Get Field
         call get character value('PSFILEN',message)
         IF (lenstr(message) .EQ. 0) THEN
            Message = 
     &           'Blank file name given - no can do!'
            CALL Erase (20, 2, 76)
            CALL Flash (20, 2,message)
            goto 1
         ENDIF 
      else if (menu choice .eq. 'Quit') then
         goto 666
      end if
      i = lenstr(message)
      call putstr(message(1:60),60,5,10,2)
      j = lenstr(fileprefix)
      call turn_ps_on(fileprefix(1:j)//message(1:i))
      goto 1
cclong 11/30/93
      
 666  call reset()
	RETURN
	END

