C Compute.for - computaion routines for VARIO
C
C----------------------------------------------------------------------
C ***  Compute  - compute variogram results

	SUBROUTINE Compute 
	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'vario.dec'

	CHARACTER*10	Number

	Totalpairs = 0
	DO 10 I = 1, NLag+1
	   IF (I .GT. MAXLAG) GOTO 10
	   CALL Compute Lag Results (I)
	   NumPair = Pairs (I)
	   IF (Pairs (I) .NE. 0) THEN
	      TotalPairs = TotalPairs + Pairs (I)
	      CALL Display Result
     +		 (I, Pairs (I), AvgDist (I), Estimate (I))
	   ENDIF
 10	CONTINUE

 	WRITE (Number (1:10), '(I10)') TotalPairs
	CALL PutStr (Number, 10, 3, 42, 0)
	CALL Erase (20, 2, 76)
	RETURN
	END


C----------------------------------------------------------------------
C ***  Compute Results  - compute variogram results
C
C Numpair 	- number of pairs in lag
C Dmin 		- Minimum Distance for lag (all pairs > Dmin)
C Dmax 		- maximum distance         (all pairs <= dmax)
C MeanDist	- average lag interpair distance
C MeanFrom	- mean of pair first points
C MeanTo	    - mean of pair second points
C----------------------------------------------------------------------
C Compute lag results for VARIO result screen
	
	SUBROUTINE Compute Lag Results (I)
	IMPLICIT INTEGER*4 (A-Z)
	INCLUDE 'vario.dec'

	INTEGER*4	LagNum, NumDat, NumPair, Ptr, I
	REAL*4	    	Z1, Z2, Angl, Dist, Incr, Incr2
	REAL*4		Rnp, Np2, Dmax, Dmin
        REAL*8      	SumFrom, SumTo, SumSqFrom, SumSqTo, Sum, SumSq
     &       , real8
	LOGICAL 	Retain

	CALL PutStr (' Computing lag results ...    ', 30, 20, 2, 2)
	NumPair      = 0
	Ptr   	     = 0
	SumFrom      = 0.0
	SumTo        = 0.0
	SumSqFrom    = 0.0
	SumSqTo      = 0.0
	Sum          = 0.0
	SumSq        = 0.0
	Pairs 	     (I) = 0
	AvgDist      (I) = 0.0
	Mfrom 	     (I) = 0.0
	Mto   	     (I) = 0.0
	LagMean      (I) = 0.0
	Vmin 	     (I) = 0.0
	Vmax 	     (I) = 0.0
	VQ1  	     (I) = 0.0
	Vmean        (I) = 0.0
	VMedian      (I) = 0.0
	VQ3  	     (I) = 0.0
	Estimate     (I) = 0.0
	GamPower1    (I) = 0.0
	GamPower2    (I) = 0.0
	GamRelative  (I) = 0.0
	NonErgodic   (I) = 0.0
	VarianceFrom (I) = 0.0
	VarianceTo   (I) = 0.0
	LagVariance  (I) = 0.0
	Dmax = LagCutoff (I)
	IF (I .EQ. 1) THEN
	   Dmin = LagMinDist 
	ELSE
	   Dmin = LagCutoff (I-1)
	   IF (I .GT. Nlag) Dmax = MaxDist
	ENDIF

	CALL SearchB (Distance, Npair, Dmin, Ptr)
	IF (Ptr .EQ. 0) Ptr = 1
 5	IF (Distance (Ptr) .LE. Dmin .AND. Ptr .LT. Npair) THEN
	   	Ptr = Ptr + 1
          GOTO 5
	ENDIF	
	IF (Ptr .GE. Npair) RETURN

10   	IF (Distance (Ptr) .LE. Dmax .AND.
     +	   NumPair .LT. MAXPAIRLAG .AND. Ptr .LT. Npair) THEN
 	   Z1 = Data (From (Ptr))
	   Z2 = Data (To   (Ptr))
	   Angl = ABS (Direct (Ptr) - Direction) * 0.0174533
           real8 = angl
	   Dist	= ABS (Distance (Ptr) * dSIN (real8))
	     IF (Retain (Angl, Dist, Z1, Z2)) THEN
	       IF (NumPair .LT. MAXPAIRLAG)THEN
               NumPair = NumPair + 1
	       ELSE
               CALL Flash (20, 2,'Maximum pairs reached ... ')
               GOTO 20
	       ENDIF
               real8 = Angl
	       IF (dCOS (real8) .LT. 0.0) THEN
	         SumFrom    = SumFrom   + Z2
	         SumTo      = SumTo     + Z1
	         SumSqFrom  = SumSqFrom + (Z2 * Z2)
	         SumSqTo    = SumSqTo   + (Z1 * Z1)
	       ELSE
	         SumFrom    = SumFrom   + Z1
	         SumTo      = SumTo     + Z2
	         SumSqFrom  = SumSqFrom + (Z1 * Z1)
	         SumSqTo    = SumSqTo   + (Z2 * Z2)
	       ENDIF
	       Incr		       = ABS (Z1-Z2)
	       Incr2                   = Incr * Incr
	       Difference (NumPair)    = Incr2
	       DiffPtr    (NumPair)    = Ptr
	       GamPower1  (I)          = GamPower1 (I) + Incr
	       GamPower2  (I)          = GamPower2 (I) + Incr2
	       VMean   (I) 	       = VMean (I)     + Incr2
	       AvgDist (I)	       = AvgDist (I)   + Distance (Ptr)
	       NonErgodic (I)          = NonErgodic (I)+ (Z1 * Z2) 
	     ENDIF
	     Ptr = Ptr + 1
	     GOTO 10
	   ENDIF
 20   	CONTINUE
      	IF (NumPair .LE. 0) GOTO 999
	Pairs       (I) = Numpair
	Mfrom       (I) = SumFrom / NumPair
	Mto         (I) = SumTo   / NumPair
	LagMean     (I) = (Mfrom (I) + Mto (I)) / 2.0
	AvgDist     (I) = AvgDist (I) / NumPair
	VMean       (I) = VMean   (I) / NumPair
	GamPower1   (I) = GamPower1 (I) / (NumPair+NumPair)
	GamPower2   (I) = GamPower2 (I) / (NumPair+NumPair)
	IF (LagMean (I) .NE. 0) GamRelative (I) = 
     +                  GamPower2 (I) / (LagMean (I) * LagMean (I))
        Sum             = SumFrom   + SumTo 
        SumSq           = SumSqFrom + SumSqTo
        Rnp             = FLOAT (NumPair * (Numpair - 1))
        Np2             = FLOAT (NumPair+NumPair)
	NonErgodic  (I) = NonErgodic (I) / FLOAT (NumPair) - 
     +                            Mfrom (I) * Mto (I)
        NonErgodic  (I) = Variance - NonErgodic (I)
	IF (NumPair .GT. 1) THEN
         LagVariance (I)  = (Np2*SumSq-Sum*Sum) / (Np2 * (Np2 - 1.0))
         VarianceTo (I)   = (FLOAT(NumPair)*SumSqTo   - 
     +                            SumTo*SumTo) / Rnp
         VarianceFrom (I) = (FLOAT(NumPair)*SumSqFrom - 
     +                            SumFrom*SumFrom) / Rnp
	ENDIF

        IF (GammaType .EQ. GAMABS1) THEN
	  	Estimate (I)	= GamPower1 (I)
        ELSEIF (GammaType .EQ. GAMABS2) THEN
	  	Estimate (I)	= GamPower2 (I)
        ELSEIF (GammaType .EQ. GAMREL ) THEN
	  	Estimate (I)	= GamRelative (I)
        ELSEIF (GammaType .EQ. GAMERGO) THEN
	  	Estimate (I)	= NonErgodic (I)
        ENDIF

	IF (NumPair .GT. 1) THEN
	  CALL Qsort  (Difference, DiffPtr, NumPair)
	  IF (MOD (NumPair, 2) .EQ. 0) THEN
	     K = NumPair / 2
	     Vmedian (I) = (Difference (K)+Difference (K+1))/2.0
	  ELSE
	     VMedian (I) = Difference ((NumPair+1)/2)
	  ENDIF
	  VMin (I)  	= Difference (1)
	  VQ1  (I)  	= Difference (NumPair*.25)
	  VQ3  (I)	= Difference (NumPair*.75)
	  VMax (I)  	= Difference (NumPair)
	ELSE
	  VMin (I)  	= Difference (1)
	  VQ1  (I)  	= Difference (1)
	  VMedian (I) 	= Difference (1)
	  VQ3  (I)	= Difference (1)
	  VMax (I)  	= Difference (1)
	ENDIF			     
999	CONTINUE
	CALL Erase (20, 2, 75)
 	RETURN
	END

c----------------------------------------------------------------------
c ***	Retain - returns true if pair is to be retained

	LOGICAL FUNCTION Retain (Angle, D, Z1, Z2)
	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'vario.dec'

	REAL*4	Angle, D, Z1, Z2, Dth
        real*8 real8

	Retain = .FALSE.
        real8 = Tolerance * 0.0174533
	Dth = dSIN (real8)
        real8 = ANGLE
	IF ((dABS(dSIN(real8)).LE.Dth) .AND. (D .LE. BandWidth)) THEN
	  IF (Z1 .GE. VarMin .AND. Z1 .LE. VarMax .AND.
     +        Z2 .GE. VarMin .AND. Z2 .LE. VarMax) Retain = .TRUE.
	ENDIF
	RETURN
	END

