
c
c This is a set of subroutines to take care of estimating model parameters
c

      subroutine guess(npnts,nweight,x,y,nmodels,choice,sill,range)

      
      include 'guess2.inc'

      integer npnts, i, choice(0:models), nmodels, nweight(1)
      real x(1), y(1), ymin(3), ymax(3), xmin(3), xmax(3)
     &     , para(3), weight(points), weighthold
     &     , sum(3), sumsq(3), range(0:models), sill(0:models)
     &     , nugget(4), f12, f23, f123, yminimum, ymaximum, yhold
     &     , log20, sqrtlog20

      logical alter

      include 'guess.data'
      data log20, sqrtlog20 /2.9957323, 1.7308184/

      call putstr('Guessing a model... ',20,20,2,2)
      do i = 1, npnts
         weight(i) = nweight(i)
      enddo
      
cclong 94/3/1: why wasn't this here?
      do i = 1, 3
         xmin(i) = x(i)
         ymin(i) = y(i)
      enddo
cclong 94/3/1

      if (ymin(3) .gt. ymin(2)) then
         yhold = ymin(3)
         ymin(3) = ymin(2)
         ymin(2) = yhold
         yhold = xmin(3)
         xmin(3) = xmin(2)
         xmin(2) = yhold
         weighthold = weight(3)
         weight(3) = weight(2)
         weight(2) = weighthold
      end if
      if (ymin(2) .gt. ymin(1)) then
         yhold = ymin(2)
         ymin(2) = ymin(1)
         ymin(1) = yhold
         yhold = xmin(2)
         xmin(2) = xmin(1)
         xmin(1) = yhold
         weighthold = weight(2)
         weight(2) = weight(1)
         weight(1) = weighthold
      end if
      if (ymin(3) .gt. ymin(2)) then
         yhold = ymin(3)
         ymin(3) = ymin(2)
         ymin(2) = yhold
         yhold = xmin(3)
         xmin(3) = xmin(2)
         xmin(2) = yhold
         weighthold = weight(3)
         weight(3) = weight(2)
         weight(2) = weighthold
      end if

      do i = 1, 3
         xmax(i) = xmin(i)
         ymax(i) = ymin(i)
      enddo

      do 100 i = 4, npnts
         if (y(i) .lt. ymin(3)) then
            ymin(1) = ymin(2)
            ymin(2) = ymin(3)
            ymin(3) = y(i)
            xmin(1) = xmin(2)
            xmin(2) = xmin(3)
            xmin(3) = x(i)
         end if
         if (y(i) .gt. ymax(3)) then
            ymax(1) = ymax(2)
            ymax(2) = ymax(3)
            ymax(3) = y(i)
            xmax(1) = xmax(2)
            xmax(2) = xmax(3)
            xmax(3) = x(i)
         end if
 100  continue
      f12 = (ymin(1)-ymin(2))/(xmin(1)-xmin(2))
      f23 = (ymin(2)-ymin(3))/(xmin(2)-xmin(3))
      f123 = (f12 - f23)/(xmin(1)-xmin(3))
      yminimum = ymin(1) - f12*xmin(1) + f123*xmin(1)*xmin(1)
      ymaximum = (ymax(1)+ymax(2)+ymax(3))/3.
      if (abs(yminimum) .lt. ymin(3)) then 
         nugget(1) = abs(yminimum)
         nugget(2) = abs(yminimum)
         nugget(3) = abs(yminimum)
      else
         nugget(1) = ymin(3)*.5
         nugget(2) = ymin(3)*.8
         nugget(3) = ymin(3)*.5
      end if

      sill(1) = (ymaximum - nugget(1))*1.1
      sill(2) = (ymaximum - nugget(2))*1.1
      sill(3) = (ymaximum - nugget(3))*1.1

      sum(1) = 0
      sumsq(1) = 0
      sum(2) = 0
      sumsq(2) = 0
      sum(3) = 0
      sumsq(3) = 0

      do 200 i = 1, npnts

         if (y(i) - nugget(1) .lt. sill(1)/1.1) then
            yhold = -alog(1.0 - (y(i) - nugget(1))/sill(1))
            sum(1) = sum(1) + yhold*x(i)
            sumsq(1) = sumsq(1) + yhold*yhold
         end if

         if (y(i) - nugget(2) .lt. sill(2)/1.1) then
            yhold = -alog(1.0 - (y(i) - nugget(2))/sill(2))
            sum(2) = sum(2) + sqrt(yhold)*x(i)
            sumsq(2) = sumsq(2) + yhold
         end if

         if (y(i) - nugget(3) .lt. sill(3)/1.1) then
            sum(3) = sum(3) + sill(3)*x(i)*(y(i) - nugget(3))
            sumsq(3) = sumsq(3) + (y(i) - nugget(3))*(y(i) - nugget(3))
         end if

 200  continue

      range(1) = sum(1)/sumsq(1)*log20
      range(2) = sum(2)/sumsq(2)*sqrtlog20
      range(3) = sum(3)/sumsq(3)

      call regress(x,y,para,npnts)
      range(4) = para(3)
      sill(4) = para(2)
      nugget(4) = para(1)

      if (nugget(4) .gt. 0) then
         sill(0) = (nugget(1)+nugget(2)+nugget(3)+nugget(4))/4.0
      else
         sill(0) = (nugget(1)+nugget(2)+nugget(3))/3.0
      end if

      do i = 1, 3
         choice(i) = i
      enddo
      nmodels=3
      alter = .true.
      call putstr('Adapting initial models...  ',28,20,2,2)
      call grope(nmodels, npnts, weight, x, y
     &     , choice, sill, range, alter)

      return
      end

*****************************************************************************

      subroutine guess2(npnts,nweight,x,y,nmodels,choice,sill,range)

      
      include 'guess2.inc'

      integer npnts, i, choice(0:models), nmodels, nweight(1)
      real x(1), y(1), weight(points), range(0:models), sill(0:models)
      logical alter

      include 'guess.data'

      call putstr('Refining the model...',21,20,2,2)
      do i = 1, npnts
         weight(i) = nweight(i)
      enddo
      alter = .false.
      call grope(nmodels, npnts, weight, x, y
     &     , choice, sill, range, alter)

      return
      end


*****************************************************************************

      subroutine grope(nmodels, npoints, weight, dis, var
     &     , choice, bestsill, bestrange,alter)

      
      include 'guess2.inc'

      integer nmodels, npoints, nits, i,j,ii, choice(0:models), next
     &     , ntimes, newnmodels, several, iterates
      parameter (nits=1)
      real p(0:models,3),para(0:models,3)
     &     , paradiff(0:models,3)
     &     , fit, fmin, r
     &     , bestnugget, bestsill(0:models), bestrange(0:models)
     &     , sill, range, f, dis(1), var(1)
     &     , total, weight(points), x(2,points), xx(2,points)
     &     , m(models,points,2:3)
     &     , rtot, realsill
      logical again, alter
      character*40 message
      external f
      include 'guess.data'

      range = 0
      realsill = 0
      para(0,1) = bestsill(0)
      paradiff(0,1) = bestsill(0)
C AND CONTINUING WITH THE NON-NUGGET MODELS:
      do 4 i = 1, nmodels
         para(i,2) = bestsill(i)
         para(i,3) = bestrange(i)
         if (alter) para(i,2) = para(i,2)*.5
         paradiff(i,2) = para(i,2)
         paradiff(i,3) = bestrange(i)*.5
         realsill = realsill + para(i,2)
         range = range + para(i,3)
 4    continue
      if (alter) realsill = realsill/float(nmodels)
      realsill = realsill + para(0,1)

      do 10 i = 1, npoints
         x(1,i) = dis(i)
         x(2,i) = var(i)
         total = total + weight(i)
 10   continue
      do 12 i = 1, npoints
         weight(i) = weight(i)/total
 12   continue

      if (bestrange(0) .ne. 0) then
         bestrange(0) = 0
         do ii = 1, npoints
            xx(1,ii) = x(1,ii)/range
            xx(2,ii) = x(2,ii)/realsill
         end do
         p(0,1) = para(0,1)/realsill
         do i = 1, nmodels
            p(i,2) = para(i,2)/realsill
            p(i,3) = para(i,3)/range
         end do
         fit = f(xx, weight, npoints, nmodels, m, p, choice)
         write(message,*) fit
         message = 'Model fit: '//message
         call flash(20,2,message)
         return
      end if

      fmin = 1.0e31
      ntimes = 0
      several = 0
      iterates = 10**(nmodels+1)

 2    call rand1_1(r)
      do 500 i = 1, iterates

         rtot = 0
         range = 0
         sill = 0

         call randomize(r)
         p(0,1) = para(0,1) + paradiff(0,1)*r
         do 100 j = 1, nmodels
            call randomize(r)
            p(j,2) = para(j,2) + paradiff(j,2)*r
            rtot = rtot + (r+1)*.5
            call randomize(r)
            p(j,3) = para(j,3) + paradiff(j,3)*r
            sill = sill + p(j,2)
            range = range + p(j,3)
 100     continue
         if (.not. again) then
            do 150 j = 1, nmodels
               p(j,2) = p(j,2)/rtot
 150        continue
            if (alter) sill = sill/rtot
         end if

         if (alter) then
            sill = sill/float(nmodels)
            range = range/float(nmodels)
         end if
         sill = sill + p(0,1)

         p(0,1) = p(0,1)/sill
         do 200 j = 1, nmodels
            p(j,2) = p(j,2)/sill
            p(j,3) = p(j,3)/range
 200     continue
         do 250 ii = 1, npoints
            xx(1,ii) = x(1,ii)/range
            xx(2,ii) = x(2,ii)/sill
 250     continue

         fit = f(xx, weight, npoints, nmodels, m, p, choice)

         if (fit .lt. fmin) then
            fmin = fit
            bestnugget = p(0,1)*sill
            write(message,*) fit
            message = 'Better fit: '//message
            call putstr(message,40,20,2,2)
            do 400 j = 1, nmodels
               bestsill(j)   = p(j,2)*sill
               bestrange(j)  = p(j,3)*range
 400        continue
         end if
 500  continue

      again = .false.
      if (ntimes .lt. 5) then
         iterates = iterates/2
         ntimes = ntimes + 1
         next = 0
         para(0,1) = bestnugget
         paradiff(0,1) = bestnugget/float(ntimes+1)
         if (bestnugget .lt. para(0,1)*.1 .or. bestnugget .gt. 
     &        .95*para(0,1))  again = .true.
         newnmodels = nmodels
         do 600 j = 1, nmodels
            if (bestsill(j) .lt. para(j,2)*.05) then
               again = .true.
               newnmodels = newnmodels - 1
               goto 600
            else
               next = next + 1
               choice(next) = choice(j)
               paradiff(next,2) = bestsill(j)/float(ntimes+2)
               paradiff(next,3) = bestrange(j)/float(ntimes+2)
               if (bestsill(j) .gt. .95*para(j,2))  then
                  again = .true.
                  paradiff(next,2) = bestsill(j)*.5
                  paradiff(next,3) = bestrange(j)*.5
               end if
               para(next,2) = bestsill(j)
               para(next,3) = bestrange(j)
            end if
 600     continue
      end if
      nmodels = newnmodels
      if (again) goto 2

 666  bestsill(0) = bestnugget
      return
      end

c******************************************************************

      function f(xx, weight, npoints, nmodels, m, p, choice)
C
C     THIS IS THE FUNCTION TO BE MINIMIZED, REPRESENTING A WEIGHTED
C     BEST-FIT OF THE DATA SUPPLIED BY THE USER TO THE MODELS.
C
      include 'guess2.inc'
      
      integer npoints, i, j, nmodels, choice(0:models)
      real p(0:models,3), m(models,points,2:3)
      real weight(points), xx(2,points)
      real f, stuff, var
      include 'guess.data'

C     GET THE VECTORS OF PARTIALS FOR THE VARIOUS MODELS:
      call modelmaker(p, choice, xx,
     &                        weight, npoints, nmodels, m)
C     THIS IS ACTUALLY JUST A WASTEFUL WAY OF CALCULATING THE
C     MODEL VARIOGRAM, SINCE FOR THE NON-NUGGET MODELS THEY 
C     TAKE THE VALUES 
C              MODEL(J) =  SILL(J) * D(MODEL(J))/D(SILL(J)
C     AT ALL POINTS.

      f = 0
      do 10 i = 1, npoints
         var = p(0,1)
         do 5 j = 1, nmodels
C           VAR = VAR +  SILL(J)    * D(MODEL(J))/D(SILL(J))
            var = var + p(j,2)   *      m(j,i,2)
 5       continue
         stuff = xx(2,i)/var - 1.
C        THIS IS THE FUNCTION TO BE MINIMIZED:
         f = f + weight(i)*stuff*stuff
 10   continue
      return
      end

*****************************************************************************

      subroutine modelmaker(p,choice, x,
     &                        weight, npoints, nmodels, m)

C     MODELMAKER CONSTRUCTS VECTORS OF THE PARTIAL DERIVATIVES OF
C     EACH MODEL, WRT THE SILL AND RANGE, FOR ALL THE DATA INPUT 
C     BY THE USER: ALL THE MODELS, FOR ALL THE LAG CLASSES.

      include 'guess2.inc'
      real x(2,points), weight(points)
      real m(models,points,2:3), p(0:models,3), a, s
     &     , log20, sqrtlog20
      integer nmodels, npoints, i, k, choice(0:models)

      include 'guess.data'
      data log20, sqrtlog20 /2.9957323, 1.7308184/

C     DO THIS FOR EACH MODEL THE USER INPUT:
      do 100 k = 1, nmodels
C        S IS THE SILL OF THE Kth MODEL, AND A IS ITS RANGE:
         s = p(k,2)
         a = p(k,3)

         if (a .eq. 0) then
            do i = 1, npoints
               m(k,i,2) = 0
               m(k,i,3) = 0
            enddo
            goto 100
         end if

C        IF WE HAVE AN EXPONENTIAL OR GAUSSIAN MODEL:
         if (choice(k) .lt. 3) then
C           WE NEED TO SCALE THE RANGE ACCORDINGLY:
            if (choice(k) .eq. 1) then
C              EXPONENTIAL, AND 
               a = a/log20
            else
C              GAUSSIAN, AND 
               a = a/sqrtlog20
            end if
C           FOR EACH POINT WE COMPUTE DERIVATIVES W.R.T. THE SILL
C           AND THE RANGE:
            do 10 i = 1, npoints
               m(k,i,2) = (1 - exp(-(x(1,i)/a)**choice(k)))
               m(k,i,3) = -s*(choice(k)*((x(1,i)/a)**choice(k))
     &              *exp(-(x(1,i)/a)**choice(k)))/a
 10         continue
C           WE NEED TO RESCALE THE RANGE (UNDO WHAT WE JUST DID):
            if (choice(k) .eq. 1) then
               a = a*log20
            else
               a = a*sqrtlog20
            end if

C        IF WE HAVE A SPHERICAL MODEL:
         else if (choice(k) .eq. 3) then
C           AGAIN, FOR ALL THE POINTS THE USER GIVES, WE CALCULATE 
C           THE DERIVATIVES OF SILL AND RANGE:
            do 20 i = 1, npoints
C              TWO CASES BECAUSE OF THE CUT-OFF IN THE RANGE VALUE:
               if (a .gt. x(1,i)) then
                  m(k,i,2) = x(1,i)*(3 - x(1,i)*x(1,i)/(a*a))/(2*a)
                  m(k,i,3) = s*3*x(1,i)*(x(1,i)*x(1,i)/
     &                             (a*a) - 1)/(2*a*a)
               else
                  m(k,i,2) = 1
                  m(k,i,3) = 0
               end if
 20         continue
C        IF WE HAVE A LINEAR WITH SILL MODEL:
         else 
C           TWO CASES BECAUSE OF THE CUT-OFF IN THE RANGE VALUE:
            do 30 i = 1, npoints
               if (x(1,i) .lt. a) then
                  m(k,i,2) = x(1,i)/a
                  m(k,i,3) = -s*x(1,i)/(a*a)
               else
                  m(k,i,2) = 1
                  m(k,i,3) = 0
               end if
 30         continue
         end if
 100  continue
      return
      end

*****************************************************************************

      subroutine regress(xx,yy,para,n)

      
      include 'guess2.inc'

      integer n, i
      real*8 x(points),y(points), xmean, ymean, a(2), b(1)
      real*8 c(0:2), ymax
      real  para(3), xx(1), yy(1)
      complex zeros(2),z
      logical moved
      include 'guess.data'
      
      do 5 i = 1, n
         x(i) = xx(i)
         y(i) = yy(i)
         xmean = xmean + x(i)
         ymean = ymean + y(i)
         if (ymax .lt. y(i)) ymax = y(i)
 5    continue

      xmean = xmean/(1.*n)
      ymean = ymean/(1.*n)
      if (xmean .ne. 0 .and. ymean .ne. 0) then
         do 6 i = 1, n
            x(i) = x(i)/xmean
            y(i) = y(i)/ymean
 6       continue
      else 
         do 7 i = 1, n
            x(i) = x(i) - xmean + 1
            y(i) = y(i) - ymean + 1
 7       continue
         moved = .true.
      end if

      do 10 i = 1, n
         c(2) = c(2) + (x(i)-2)*(y(i)-1)
         c(1) = c(1) - y(i)*(y(i)-1) + x(i)*(x(i)-1)
         c(0) = c(0) - x(i)*(y(i)-1)
cclong: fu pointed this out. Strange....
cc         a(3) = a(3) - x(i)*(x(i)-1)
cclong
 10   continue

cclong: this could be better from the numerical analysis perspective!
      z = c(1)*c(1) - 4*c(2)*c(0)
      zeros(1) = (-c(1)+sqrt(z))/(2*c(2))
      zeros(2) = (-c(1)-sqrt(z))/(2*c(2))

      a(1) = real(zeros(1))
      a(2) = real(zeros(2))

      if (a(1) .lt. a(2)) a(1) = a(2)
      b(1) = 1 - a(1)

      if (moved) then
         b(1) = b(1) + ymean - 1 -a(1)*(xmean - 1)
      else
         a(1) = a(1)*ymean/xmean
         b(1) = b(1)*ymean
      end if

      para(1) = ymean - a(1)*xmean
      para(2) = ymax - para(1)
      para(3) = para(2)/a(1)

      return
      end

