C
C Vario.for - variogram analysis program
C----------------------------------------------------------------------
	PROGRAM VARIO
	IMPLICIT INTEGER*4 (a-z)
	INCLUDE 'vario.dec'
        character*80    geoeas_home

        include '../common/color.dec'

cc Note that the get_geoeas_home line needs to come first, or there
cc will be problems on some terminals.
cc    The program will speed up if this is your private copy, and you
cc want to replace the call by the following example:  
cc    My geoeas_dir is 
cc             /aplm3/ael/dmyers/dgeoeas/unix_version
cc so I could replace the lines below by 
cc        CALL Read Structure ('/aplm3/ael/dmyers/dgeoeas/unix_version'
cc     &       //'/vario/vario.scr')
cc
        call graphics_in
        call get_geoeas_dir(10,geoeas_home)
        CALL Read Structure  (geoeas_home(1:lenstr(geoeas_home))
     &       //'/vario/vario.scr')

ccc replaces old grafinit:
        graphics = .true.
        aspect     = 1
        DevCode    = 1
ccc
c	call system("xmessage -message set")
        CALL set up screen()
c	call system("xmessage -message clear")
        CALL Clear Screen

c	call system("xmessage -message initialize")
        CALL Initialize
c	call system("xmessage -message readsystemdefaults")
        CALL Read System Defaults
c	call system("xmessage -message introscreen")
        IF (Intro) CALL Intro Screen
c	call system("xmessage -message getscreenfiel")
        CALL Get Screen Fields
        CALL Write System Defaults
        CALL SetMod (INT2 (StartMode))
 	END

C----------------------------------------------------------------------
C Intro Screen - 	displays screen frame/label/fields
C			for the introductory screen

	SUBROUTINE Intro Screen
c	call system("xmessage -message intro1")
	CALL Clear Screen
c	call system("xmessage -message intro2")
	CALL Set Screen (1)
c	call system("xmessage -message intro3")
	CALL Display Frame
c	call system("xmessage -message intro4")
	CALL Display Labels
cclong  changed this 	CALL Locate Cursor (25, 0)     to
c	call system("xmessage -message intro5")
	CALL Locate Cursor (23, 0)
c	call system("xmessage -message intro6")
	CALL Flash (20, 2, 'Press any key to begin the program ')
	RETURN
	END

C----------------------------------------------------------------------
C Initialize - initialize VARIO global values
C
	SUBROUTINE Initialize 
	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'vario.dec'

cc 	CHARACTER*10	Blanks
cc	INTEGER*4	Fld Index, Field

	Ndata 	= 0
	Npair 	= 0
	Nkept 	= 0
	NumNeg 	= 0
	NMiss   = 0
	Xvar	= 1
	Yvar	= 2
	Var	= 3
	TotalPairs = 0
	
	MinDist	= 0.0
	MaxDist = 0.0
	XCMin	= 0.0
	XCMax	= 1.0
	YCMin	= 0.0
	YCMax	= 1.0
	Log	 = .FALSE.
	GammaType = GAMABS2

	Nugget = 0.0
	DO 10 I = 1, MAXSTRUC
	   Mtype (I) = 0
	   Sill  (I) = 0.0
	   Range (I) = 0.0
 10	CONTINUE

	Direction    = 0.0
	Tolerance    = 90.0
	BandWidth    = 1.E30
	Missing	     = 1.E31
	   	
C Erase screen message area
        DO 444 I = 11, 18
           CALL Erase (I, 42, 35)
 444    CONTINUE

	RETURN
	END
C----------------------------------------------------------------------
C Display Options header - sets up header for VARIO options screen
C
	SUBROUTINE Display Options Header
	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'vario.dec'

	CHARACTER	Number*13, Rfmt*8
	INTEGER*4	L, LENSTR
	DATA		Rfmt /'(G13.3)'/

	IF (Log) THEN
	  L = LENSTR (Varnam (Var))
	  CALL PutStr ('LN ('//VarNam (Var)(1:L)//')', L+5, 1, 11, 0)
	ELSE
	  CALL PutStr (VarNam (Var), 10, 1, 12, 0)
	ENDIF
	WRITE (Number , Rfmt) VarMin
	CALL PutStr (Number, 13, 2, 12, 0)
	WRITE (Number , Rfmt) VarMax
	CALL PutStr (Number, 13, 3, 12, 0)

	CALL PutStr (Pair File, 14, 1, 64, 0)
	WRITE (Number , Rfmt) Distance (1)
	CALL PutStr (Number, 13, 2, 64, 0)
	WRITE (Number , Rfmt) Distance (Npair)
	CALL PutStr (Number, 13, 3, 64, 0)
	RETURN
	END	

C----------------------------------------------------------------------
C ReInitialize - Reinitialize VARIO global values
C
	SUBROUTINE ReInitialize 
	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'vario.dec'

	CALL Initialize
	CALL Set Toggle Position       ('LOGOPTION ', 0)
	CALL Display One Field         ('LOGOPTION ')
	CALL Set Toggle Position       ('VARIOTYPE ', GAMABS2)
	CALL Set Character Value       ('MINZ      ', '          MIN')
	CALL Display One Field         ('MINZ      ')
	CALL Set Character Value       ('MAXZ      ', '          MAX')
	CALL Display One Field         ('MAXZ      ')
	CALL Set Character Value       ('PAIRFILE  ', Pair File)
	CALL Display One Field         ('PAIRFILE  ')
	CALL Set 4Floating Point Value ('DIRECTION ', Direction, 3)
	CALL Set 4Floating Point Value ('TOLERANCE ', Tolerance, 3)
	CALL Set Character Value       ('BANDWIDTH ', '          MAX')
	CALL Set Character Value       ('LAGFILE   ', 'LagResult.dat')
	CALL Reset Lags
	RETURN
	END

C----------------------------------------------------------------------
C Get Screen Fields - 	displays screen frame/label/fields
C			gets the screen fields for the current screen

	SUBROUTINE Get Screen Fields 

	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (MAINSCR  = 2, VOSCREEN = 3, VRSCREEN = 4,
     +		   LRSCREEN = 5, MOSCREEN = 6, GOSCREEN = 7,
     +		   ESCREEN = 8,
     +		   PLOTMODEL = 1, NOMODEL = 0)
 
	INCLUDE 'vario.dec'

	CHARACTER*10	Main Menu, VO Menu, VR Menu
	CHARACTER*10	LR Menu,   MO Menu, GO Menu, Lag Menu
	CHARACTER 	Menu Choice*10, Scratch*10
     &       , fldname*10
cc	change 'logical*1' to 'logical'
	LOGICAL		GetYesNo, Exit
	LOGICAL		Error, Computed
	INTEGER*4	LagChoice

cclong
cc Needed for the guessing of variogram model:
        integer choice(0:maxstruc), nmodels
        real guesssill(0:maxstruc), guessrange(0:maxstruc)
cclong

	DATA Main Menu	/'MAINMENU  '/
	DATA VO Menu    /'VOMENU   '/, VR Menu /'VRMENU '/
	DATA LR Menu    /'LRMENU   '/, MO Menu /'MOMENU '/
	DATA GO Menu    /'GOMENU   '/, Lag Menu /'LAGMENU '/

 	CALL Build File Name (Data File, Pair File, '.pcf')

C Paint Screen
  5	CALL New Screen (MAINSCR)
	CALL Set Character Value ('PAIRFILE  ', Pair File)

C Main screen
 10 	CALL Put Menu (Main Menu)

 20	CALL Get Menu Choice (Main Menu, Menu Choice)	
 	IF      (Menu Choice .EQ. 'Quit     ') THEN
	  Exit = GetYesNo (20, 2, 'Do you really want to QUIT? <Y/N>')
	  IF (Exit) THEN
CCLONG
             CALL CLEAR SCREEN
             CALL Reset Screen
CC
            RETURN
          END IF

	ELSE IF (Menu Choice .EQ. 'Variable  ') THEN
	  IF (Ndata .GT. 0 .AND. Ndata .GT. 0 .AND. Npair.GT. 0)
     +	   CALL Get Field Group

	ELSE IF (Menu Choice .EQ. 'Limits   ') THEN
	  IF (Ndata .GT. 0 .AND. Ndata .GT. 0 .AND. Npair.GT. 0)
     +	   CALL Get Field Group

C----------------------------------------------------------------------
C Variogram Options Screen
	ELSE IF (Menu Choice .EQ. 'Options/Ex') THEN
	  IF (Nvar .EQ. 0 .OR. Ndata .EQ. 0 .OR. Npair .EQ. 0) GOTO 20
 25  	  CALL New Screen (VOSCREEN)
	  CALL Display Options Header
	  CALL Set Menu Position (VO Menu, 1)
 30	  CALL Put Menu   (VO Menu)
 35	  CALL Get Menu Choice (VO Menu, Menu Choice)
	  Computed = .FALSE.
	  IF     (Menu Choice .EQ. 'Quit      ') THEN
	    GOTO 5 
   	  ELSE IF (Menu Choice .EQ. 'Edit Lags ') THEN
	    IF (Nlag .EQ. 0) THEN
		  CALL Set Menu Position (VO Menu, 3) 
	      GOTO 30
		ELSE
		  CALL Get Field Group
	    ENDIF 
	  ELSE IF (Menu Choice .EQ. 'Post Plot ') THEN
	    CALL PostPlot
	    GOTO 25

C----------------------------------------------------------------------
C Variogram Results Screen
	  ELSE IF (Menu Choice .EQ. 'Execute   ') THEN
          GammaType = GAMABS2
          CALL Set Toggle Position ('VARIOTYPE ', GAMABS2)
	    IF (Nlag .EQ. 0) THEN
	      CALL Beep
	      CALL Set Menu Position (VO Menu, 3) 
	      GOTO 30
	    ENDIF 
 40	    CALL New Screen (VRSCREEN)
	    CALL Display Results Header
 	    CALL Put Menu   (Lag Menu)  
	    IF (.NOT. Computed) THEN
	       CALL Compute 
C            call system("xmessage -message vplot 1")
               CALL Vplot Defaults
	       Computed = .TRUE.
	    ELSE
	       CALL Display Results
	    ENDIF
	    CALL Set Menu Position (VR Menu, 2)
 45	    CALL Put Menu   (VR Menu)
 50	    CALL Get Menu Choice (VR Menu, Menu Choice)
	    IF      (Menu Choice .EQ. 'Quit      ') THEN
	      GOTO 25 
	    ELSE IF (Menu Choice .EQ. 'Plot      ') THEN
C              call system("xmessage -message vplot 2")
	      CALL Vplot (NOMODEL)
	      GOTO 40
	    ELSE IF (Menu Choice .EQ. 'Box Plot  ') THEN
	      CALL Box Vplot
	      GOTO 40

C----------------------------------------------------------------------
C Variogram Modeling
	    ELSE IF (Menu Choice .EQ. 'Model     ') THEN
 55	      CALL New Screen (MOSCREEN)
	      CALL Display Model Results 
	      CALL Set Menu Position (MO Menu, 2)
 60	      CALL Put Menu   (MO Menu)
 65	      CALL Get Menu Choice (MO Menu, Menu Choice) 
	      IF      (Menu Choice .EQ. 'Quit      ') THEN
	        GOTO 40 
	      ELSE IF (Menu Choice .EQ. 'Plot      ') THEN
C                call system("xmessage -message vplot 3")
	        CALL Vplot (PLOTMODEL)
	        GOTO 55
C----------------------------------------------------------------------
C Graph Options Screen
	      ELSE IF (Menu Choice .EQ. 'Options   ') THEN
	        CALL Set Menu Position (GO Menu, 1)
 70	        CALL New Screen (GOSCREEN)
 75	        CALL Put Menu   (GO Menu)
 80	        CALL Get Menu Choice (GO Menu, Menu Choice)
	        IF      (Menu Choice .EQ. 'Quit      ') THEN
	          GOTO 55 
	        ELSE IF (Menu Choice .EQ. 'Plot      ') THEN
C                  call system("xmessage -message vplot 4")
	          CALL Vplot (PLOTMODEL)
	          GOTO 70 
	        ELSE
	          CALL Get Field Group
	        ENDIF
	        GOTO 80
C----------------------------------------------------------------------
C Autofit option
	      ELSE IF (Menu Choice .EQ. 'Auto') THEN
cclong                 call guess(nlag+1,pairs,avgdist,estimate
                 call guess(nlag,pairs,avgdist,estimate
     &                , nmodels, choice, guesssill, guessrange)
                 nugget = guesssill(0)
                 fldname = 'NUGGET'
                 CALL Set4Floating Point Value
     &                   (Fldname,nugget, 3)
                 call display one field (fldname)
                 do i = 1, nmodels
                    if (choice(i) .eq. 3) then
                       mtype(i) = 1
                    else if (choice(i) .eq. 1) then
                       mtype(i) = 3
                    else
                       mtype(i) = choice(i)
                    end if
                    write(scratch(1:1),'(i1)') i

                    fldname = 'MOPARMA  '//scratch(1:1)
                    sill(i) = guesssill(i)
                    CALL Set4Floating Point Value
     &                   (Fldname,guesssill(i), 3)
                    call display one field (fldname)

                    fldname = 'MOPARMB  '//scratch(1:1)
                    range(i) = guessrange(i)
                    CALL Set4Floating Point Value
     &                   (Fldname,guessrange(i), 3)
                    call display one field (fldname)

                    fldname = 'MOTYPE   '//scratch(1:1)
                    CALL Set toggle position (fldname,mtype(i))
                    call display one field (fldname)
                 enddo

C                 call system("xmessage -message vplot 5")
                 CALL Vplot (PLOTMODEL)
                 CALL Set Menu Position (MO Menu, 1)
cc1/13/94
                 CALL New Screen (MOSCREEN)
                 CALL Display Model Results 
cc1/13/94
                 GOTO 60
C----------------------------------------------------------------------
C save or write
	      ELSE IF (Menu Choice .EQ. 'Load' .or.
     &                Menu Choice .EQ. 'Save') THEN
                 if (lenstr(parmfile) .eq. 0 .or.
     &                char(0) .eq. parmfile(1:1)) then
                    call Build File Name (data file,parmfile,'.kpf')
                    call set character value('Paramfile',parmfile)
                 end if

                 CALL Get Field Group
                 call get character value('Paramfile',parmfile)
                 if (lenstr(parmfile) .eq. 0) goto 60
                 IF (Menu Choice .EQ. 'Save') THEN
                    fldname = 'ZVARIABLE'
                    CALL get toggle value (fldname,j,scratch)
                    call save parameters (parmfile,error,j+1)
                    if (error) call flash(20,2,
     &                   'Error saving parameters...press return.')
                 else IF (Menu Choice .EQ. 'Load') THEN
                    call read parameters (parmfile,error,1)
                    if (error) then
                       call flash(20,2,
     &                      'Error reading parameters...press return.')
                       goto 60
                    end if
                    fldname = 'NUGGET'
                    CALL Set4Floating Point Value
     &                   (Fldname,nugget, 3)
                    call display one field (fldname)
                    nmodels = 0
                    do i = 1, maxstruc
                       if (mtype(i) .ne. 0) then
                          nmodels = nmodels+1
                          mtype(nmodels) = mtype(i)
                          sill(nmodels) = sill(i)
                          range(nmodels) = range(i)
                          write(scratch(1:1),'(i1)') nmodels
                          
                          fldname = 'MOPARMA  '//scratch(1:1)
                          CALL Set4Floating Point Value
     &                         (Fldname,sill(i), 3)
                          call display one field (fldname)
                          
                          fldname = 'MOPARMB  '//scratch(1:1)
                          CALL Set4Floating Point Value
     &                         (Fldname,range(i), 3)
                          call display one field (fldname)
                          
                          fldname = 'MOTYPE   '//scratch(1:1)
                          CALL Set toggle position (fldname,mtype(i))
                          call display one field (fldname)
                       end if
                    enddo
                    do i = nmodels+1, maxstruc
                       mtype(i) = 0
                       sill(i) = 0
                       range(i) = 0
                       write(scratch(1:1),'(i1)') i
                       fldname = 'MOTYPE   '//scratch(1:1)
                       CALL Set toggle position (fldname,0)
                       call display one field (fldname)
                       call Erase Model(i)
                    enddo
C                    call system("xmessage -message vplot 6")
                    CALL Vplot (PLOTMODEL)
                 end if
                 CALL Set Menu Position (MO Menu, 1)
cc1/13/94
                 CALL New Screen (MOSCREEN)
                 CALL Display Model Results 
cc1/13/94
                 GOTO 60
C----------------------------------------------------------------------
C refine option, or fit:
	      ELSE IF (Menu Choice .EQ. 'Refine' .or. 
     &                Menu Choice .EQ. 'Fit') THEN
                 guesssill(0) = nugget
                 nmodels = 0
                 do i = 1, maxstruc
                    if (mtype(i) .ne. 0) then
                       nmodels = nmodels + 1
                       mtype(nmodels) = mtype(i)
                       if (mtype(nmodels) .eq. 3) then
                          choice(nmodels) = 1
                       else if (mtype(nmodels) .eq. 1) then
                          choice(nmodels) = 3
                       else
                          choice(nmodels) = mtype(nmodels)
                       end if
                       guesssill(nmodels) = sill(i)
                       guessrange(nmodels) = range(i)
                    end if
                 enddo                    
                 if (Menu Choice .EQ. 'Fit') then
                    guessrange(0) = 666
cclong                    call guess2(nlag+1,pairs,avgdist,estimate
                    call guess2(nlag,pairs,avgdist,estimate
     &                   , nmodels, choice, guesssill, guessrange)
                    CALL Set Menu Position (MO Menu, 1)
cc1/13/94
                    CALL New Screen (MOSCREEN)
                    CALL Display Model Results 
cc1/13/94
                    GOTO 60
                 end if
cclong                 call guess2(nlag+1,pairs,avgdist,estimate
                 call guess2(nlag,pairs,avgdist,estimate
     &                , nmodels, choice, guesssill, guessrange)
                 nugget = guesssill(0)
                 fldname = 'NUGGET'
                 CALL Set4Floating Point Value
     &                   (Fldname,nugget, 3)
                 call display one field (fldname)
                 do i = 1, nmodels
                    if (choice(i) .eq. 3) then
                       mtype(i) = 1
                    else if (choice(i) .eq. 1) then
                       mtype(i) = 3
                    else
                       mtype(i) = choice(i)
                    end if
                    write(scratch(1:1),'(i1)') i

                    if (mtype(i) .ne. 0) then
                       fldname = 'MOPARMA  '//scratch(1:1)
                       sill(i) = guesssill(i)
                       CALL Set4Floating Point Value
     &                      (Fldname,guesssill(i), 3)
                       call display one field (fldname)
                       
                       fldname = 'MOPARMB  '//scratch(1:1)
                       range(i) = guessrange(i)
                       CALL Set4Floating Point Value
     &                      (Fldname,guessrange(i), 3)
                       call display one field (fldname)
                       
                       fldname = 'MOTYPE   '//scratch(1:1)
                       CALL Set toggle position (fldname,mtype(i))
                       call display one field (fldname)
                    end if
                 enddo
                 do i = nmodels+1, maxstruc
                    mtype(i) = 0
                    write(scratch(1:1),'(i1)') i
                    fldname = 'MOTYPE   '//scratch(1:1)
                    CALL Set toggle position (fldname,0)
                    call display one field (fldname)
                    call Erase Model(i)
                 enddo
                 CALL Vplot (PLOTMODEL)
                 CALL Set Menu Position (MO Menu, 1)
cc1/13/94
                 CALL New Screen (MOSCREEN)
                 CALL Display Model Results 
cc1/13/94
                 GOTO 60
C----------------------------------------------------------------------
	      ELSE
	        CALL Get Field Group
	      ENDIF
              GOTO 65    

C----------------------------------------------------------------------
C Lag Results Screen

	    ELSE IF (Menu Choice .EQ. 'Lag Result') THEN
	      CALL PutStr
     +  ('Select Lag  (use arrow keys, <enter> when done)',47,20,2,2)
 	      CALL Get Menu Choice (Lag Menu, Menu Choice) 
 85         CALL Get Menu Value (Lag Menu, LagChoice, Scratch)
		  CALL Erase (20, 2, 75)
 		  IF (Pairs (LagChoice) .EQ. 0) THEN
	        CALL Beep
	        CALL Flash (20, 2, 'No pairs in this Lag ')
	        GOTO 50
	      ENDIF
	      CurrentLag = LagChoice
              
	      CALL Compute Lag Results (LagChoice)
90            call new screen(lrscreen)
	
	      CALL Write Lag Results (LagChoice)
	      CALL Set Menu Position (LR Menu, 1)
   	      CALL Put Menu   (LR Menu  )
 95	      CALL Get Menu Choice (LR Menu, Menu Choice) 
	      IF      (Menu Choice .EQ. 'Quit      ') THEN
	        GOTO 40
	      ELSE IF (Menu Choice .EQ. 'Histogram ') THEN
                CALL Histo (LagChoice)
	      ELSE IF (Menu Choice .EQ. 'Scatter   ') THEN
                CALL Scatter (LagChoice)
	      ELSE IF (Menu Choice .EQ. 'Examine   ') THEN
	        CALL NewScreen (ESCREEN) 
		CALL Examine (LagChoice)
	      ELSE
	        CALL Get Field Group
	        GOTO 95
	      ENDIF
	      GOTO 90
C---------------------------------------------------------------------
	    ELSE
	      CALL Get Field Group
	    ENDIF
	    GOTO 45
	  ELSE
	    CALL Get Field Group
	  ENDIF
	  GOTO 30 	   
	ELSE
	  CALL Get Field Group
	ENDIF
	GOTO 20
	END	

C----------------------------------------------------------------------
C Get Field Group - get a group of fields, perform processes

	SUBROUTINE Get Field Group 
	IMPLICIT INTEGER*4 (A-Z)

	PARAMETER (Main Menu Field = 3)
	PARAMETER (Menu Field      = 4)

	INCLUDE '../common/screen.str'
	
	LOGICAL		Error, Repaint

 10	CALL Get Field	
	CALL Perform Process (SC Field Name (Current Field),
     +                        Error, Repaint) 
	IF (SC Field Type (Next Field) .NE. Main Menu Field .AND.
     +	    SC Field Type (Next Field) .NE. Menu Field) GOTO 10

	IF (Repaint) THEN
	   CALL New Screen (Current Screen)
	ENDIF

	RETURN
	END

C----------------------------------------------------------------------
C New Screen (Screen number) - sets up a new screen
C
	SUBROUTINE New Screen (Screen Number)
	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (Main Menu Field = 3)
	PARAMETER (Menu Field      = 4)

	INCLUDE '../common/screen.str'
	INCLUDE 'vario.dec'

	CHARACTER	Scratch*6, Ifmt*4
	DATA Ifmt 	/'(I6)'/

	CALL Clear Screen
	CALL Set Screen (Screen Number)
	CALL Display Frame
	CALL Display Labels

	DO 10 I = Begin Screen (Current Screen),
     +	         End Screen (Current Screen)
	  IF (SC Field Type (I) .NE. Main Menu Field .AND.
     +	      SC Field Type (I) .NE. Menu Field)
     +          CALL Write Field (i, SC Attribute (i))
  10	CONTINUE

C Erase screen message area
	IF (Current Screen .EQ. 1) THEN
 	  DO 444 I = 11, 18
	    CALL Erase (I, 42, 35)
 444 	  CONTINUE
	  WRITE (Scratch, Ifmt) Nkept
	  CALL PutStr (Scratch, 6, 6, 70, 0)
	  WRITE (Scratch, Ifmt) NumNeg
	  CALL PutStr (Scratch, 6, 7, 70, 0)
	  WRITE (Scratch, Ifmt) Nmiss
	  CALL PutStr (Scratch, 6, 8, 70, 0)
	  WRITE (Scratch, Ifmt) NVar
	  CALL PutStr (Scratch, 6, 6, 50, 0)
	  WRITE (Scratch, Ifmt) Ndata
	  CALL PutStr (Scratch, 6, 7, 50, 0)
	  WRITE (Scratch, Ifmt) Npair
	  CALL PutStr (Scratch, 6, 8, 50, 0)
	ENDIF

C Erase Message Line
	CALL Erase (20, 2, 75)
	RETURN
	END

C----------------------------------------------------------------------
C Read System Defaults

	SUBROUTINE Read System Defaults
	IMPLICIT INTEGER*4 (A-Z)
 
	INCLUDE 'vario.dec'

	CHARACTER*20  String

	OPEN (UNIT = 10, FILE = 'geoeas.def', STATUS = 'OLD',
     +			 ERR=999)
	READ (10, '(A)', ERR=999,END=999) File Prefix
	READ (10, '(A)', ERR=999,END=999) Data File
	READ (10, '(A)', ERR=999,END=999) String
	Intro = (String (7:8) .EQ. 'ON' .OR.
     +           String (7:8) .EQ. 'on')
	CALL Set Character Value ('FILEPREFIX', File Prefix)
	CLOSE (10)
	RETURN

 999	CLOSE (10)
	Intro = .TRUE.
	RETURN
	END

C----------------------------------------------------------------------
C Write System Defaults

	SUBROUTINE Write System Defaults
	IMPLICIT INTEGER*4 (A-Z)
 
	INCLUDE 'vario.dec'

	OPEN (UNIT = 10, FILE = 'geoeas.def', STATUS = 'UNKNOWN',
     +			ERR=999)
	WRITE (10, '(A)', ERR = 999) File Prefix
	WRITE (10, '(A)', ERR = 999) Data File
	IF (Intro) THEN
	  WRITE (10, '(A)', ERR = 999) 'INTRO=ON'
	ELSE
	  WRITE (10, '(A)', ERR = 999) 'INTRO=OFF'
	ENDIF
 999	CLOSE (10)
	RETURN
	END


