C Graph.for
C-------------------------------------------------------------------
C Plot Neighbors - graph of neighborhood for program XVALID
C
      SUBROUTINE Plot Neighbors (X0, Y0, Neighbors, N, Quit)
	IMPLICIT INTEGER*4 (A-Z)

	PARAMETER (OTHER = 0, HERC = 1, CGA = 2, EGA = 3)

		include  'xvalid.dec'

C Passed
        REAL*4          X0, Y0
        INTEGER*4       Neighbors (MAXNEIGHBOR), N
	  LOGICAL		  Quit

C Local Variables
        REAL*4        X, Y, Dx, Dy, Mx, My, Bx, By, Tx, Ty
        REAL*4        Xfudge, Yfudge, Dtr, Factor
        REAL*4        CosA, SinA, CosE, SinE

        INTEGER*4     Ptr, L, L2, Angl, Ierr
        INTEGER*4    Scan, Key, DevMinX, DevMaxX, DevMinY, DevMaxY

        CHARACTER     Plot Title*30, Title2*50, Xlabel*10, Ylabel*10
        character message*60, menu choice*10

        DATA Dtr /0.0174533/

C Set up labels
        IF (DevCode .EQ. 0) RETURN
	WRITE (Title2, 5) X0, Y0
 5      FORMAT ('Point: (',F13.3,',',F13.3,')') 
        Plot Title      = 'Plot of Neighbors'
        Xlabel = Varnam (XVar)
        Ylabel = Varnam (YVar)

C Compute SQUARE Device space (corrected by device pixel aspect ratio)
 1      DevMinX		= 0
	DevMinY		= 0
	DevMaxY		= YmaxDev
	IF (DevCode .EQ. OTHER) THEN
	   RETURN
	ELSE IF (DevCode .EQ. HERC) THEN
	   Factor 	= 29./45.
	ELSE IF (DevCode .EQ. CGA) THEN
	   Factor 	= 5./12.
	ELSE IF (DevCode .EQ. EGA) THEN
	   Factor 	= 35./48.
	ENDIF
	DevMaxX = FLOAT (DevMaxY) / Factor
  
C  Calculate other scaling information
	Dx = xmax - xmin
	Dy = ymax - ymin
	Mx = dx * .005/Aspect
	My = dy * .005
	Tx = (Maxx - Minx) * .005
	Ty = (Maxy - Miny) * .007

C Start graphics mode
        CALL Zsetup (Gmode, Ierr)

C Clear the screen
        call zclear()

C Set text attributes (8x8, white on black border)
        CALL Zlbdir (0.0)
        CALL Zlocat (DevMinX, DevMaxX, DevMinY, DevMaxY)

C Set scaling window
        CALL Zscale (Minx, Maxx + Tx, miny, Maxy +Ty)
        call grframe(DevMinX, DevMinY, blue)
        CALL Zcolor (INT2 (White))

C Draw and label the axes
	CALL Axes (Plot Title, Xlabel, Ylabel, Title2,
     +		   Xmin, Xmax, Ymin, Ymax, Xtinc, Ytinc, DevCode)

C Plot data points 
        DO 15 I = 1, NData
           CALL Cross  (XData (I), Ydata (I), Mx, My, White, White)
 15     CONTINUE

C Plot center of ellipse
	Tx = Mx * 1.5
	Ty = My * 1.5
      CALL Box (X0, Y0, Tx, Ty, Blue, White)

C Draw search ellipse
      CALL Zcolor (INT2 (Red))
        CosE = COS (SrAngle*Dtr)
        SinE = SIN (SrAngle*Dtr)
        X = X0 + SrMajor * CosE 
        Y = Y0 + SrMajor * SinE 
        CALL Zmove (X, Y)
        DO 20 Angl =  6, 360, 6
           CosA = COS (FLOAT (Angl)*Dtr)
           SinA = SIN (FLOAT (Angl)*Dtr)
           Tx   = SrMajor * CosA
           Ty   = SrMinor * SinA 
           X    = X0 + (Tx*CosE - Ty*SinE)
           Y    = Y0 + (Tx*SinE + Ty*CosE)
           CALL Zplot (X, Y)             
 20     CONTINUE
C Draw Sector division lines
	IF (Nsector .EQ. 1) GOTO 40
        DO 30 Angl =  0, 360, 45
	 IF (MOD (Angl, 90) .NE. 0 .AND. Nsector .EQ. 4) GOTO 30
         CosA = COS (FLOAT (Angl)*Dtr)
         SinA = SIN (FLOAT (Angl)*Dtr)
         Tx   = SrMajor * CosA
         Ty   = SrMinor * SinA 
         X    = X0 + (Tx*CosE - Ty*SinE)
         Y    = Y0 + (Tx*SinE + Ty*CosE)
	 CALL Zmove (X0, Y0)
         CALL Zplot (X, Y)             
 30     CONTINUE

C Plot Neighbors
 40     CALL Zcolor (INT2 (Yellow))
	Mx = Mx * 1.5
	My = My * 1.5
        DO 50 I = 1, N
           Ptr  = Neighbors (I)
           CALL Plus (XData (Ptr), Ydata (Ptr), Mx, My, Yellow, White)
 50     CONTINUE

	CALL Getthekey(key)
        if (char(key) .eq. 'q' .or. char(key) .eq. 'Q') then
           keep = .false.
        else if (char(key) .eq. 'r' .or. char(key) .eq. 'R') then
           goto 1
        else if (char(key) .eq. 'p' .or. key .eq. 2002) then
cclong 11/30/93
           CALL New Screen (6)
           call put menu ('POSTSCR')
           call set character value('PSFILEN','neighbor.ps')
           
           CALL Erase(20,2,76)
           call get character value('PSFILEN',message)
           CALL Erase(5,10,60)
           call putstr(message(1:60),60,5,10,2)
           CALL Get Menu Choice ('POSTSCR',Menu choice)
           if (menu choice .eq. 'File') then
              CALL Get Field
              call get character value('PSFILEN',message)
              IF (lenstr(message) .EQ. 0) THEN
                 Message =
     &                'Blank file name given - no can do !'
                 CALL Erase (20, 2, 76)
                 CALL Flash (20, 2,message)
                 goto 1
              ENDIF
           else if (menu choice .eq. 'Quit') then
              goto 666
           end if
           i = lenstr(message)
           call putstr(message(1:60),60,5,10,2)
           j = lenstr(fileprefix)
           call turn_ps_on(fileprefix(1:j)//message(1:i))
           goto 1
cclong11/30/93
        end if
 666    call reset()
        
        RETURN
        END




	







