C
C Process.for
C----------------------------------------------------------------------
C Perform Process - perform application-specific functions for XVALID
C
	SUBROUTINE Perform Process (Field Name, Error, Repaint)
	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (Alpha Field     = 0)
	PARAMETER (Integer Field   = 1)
	PARAMETER (Real Field      = 2)
	PARAMETER (Toggle Field    = 5)

		include  'xvalid.dec'
		include  '../common/screen.str'

	CHARACTER	Message*75, Blanks*14, OldFile*14, FileName*65
	CHARACTER*10	Field Name,  MainMenu, Dummy, Return Field
	INTEGER*4	Fld Index, Index of Field, Field Type
	INTEGER*4	LENSTR, Position, I
	INTEGER*4	Field1, Field2, Field3, Pos
	LOGICAL		Error, Repaint, PutMessage, FExist
	LOGICAL		Started
        LOGICAL       GetYesNo, OverWrite
	REAL*4		Temp

	DATA MainMenu   /'MAINMENU  '/
	DATA Started	/.FALSE./

C initialize
	Error		= .FALSE.
	Repaint		= .FALSE.	
	PutMessage	= .FALSE.
	FExist		= .FALSE.
	Index of Field	= Fld Index (Field Name)
	Return Field	= SC Field Name (Next Field)
	Field Type	= SC Field Type (Index of Field)
	Pos		= 0

C Get a real value, or toggle position
	IF (Field Type .EQ. Real Field) THEN
	   CALL Get 4 Floating Point Value (Field Name, Temp)
	ELSE IF (Field Type .EQ. Toggle Field) THEN
           CALL Get Toggle Value (Field Name, Position, Dummy)
	ENDIF

C open data file, read in header information
	IF     (Field Name .EQ. 'FILEPREFIX') THEN
	  CALL Get Character Value (Field Name, File Prefix)
	  CALL Left Justify (File Prefix)
	  CALL Set Character Value (Field Name, File Prefix)

	ELSEIF (Field Name .EQ. 'DATAFILE  ') THEN
	  IF (Started) OldFile = Data File
	  CALL Get Character Value (Field Name, Data File)
	  IF (OldFile .NE. Data File) THEN
	     N = LENSTR (File Prefix)
	     IF (N .GT. 0) THEN 
	        File Name = File Prefix (1:N) // Data File
	     ELSE
	        File Name = Data File
	     ENDIF
	     Old File = Data File
	     CALL ReInitialize
	     Data File = Old File
	     CALL Set Character Value ('DATAFILE  ', Data File) 
	     CALL Display Fields
	     INQUIRE (FILE = File Name, EXIST = Fexist)  
	     IF (.NOT. Fexist) THEN
	        Error = .TRUE.
	        Message = 'ERROR - data file not found'
                Return Field = Main Menu 
	        Data File = Blanks (1:14)
                CALL Set Character Value (Field Name, Data File)   
	     ELSE
	       CALL Read Header Data (Error)
	       IF (Error) THEN
	         Error = .FALSE. 
                 CALL ReInitialize
                 Return Field = Main Menu
	       ELSE
	         Old File = Data File
	         Return Field = 'XVARIABLE '
	  	 Started = .TRUE.
               ENDIF
	    ENDIF
	  ENDIF

C Get the Coordinate Variables
	ELSEIF (Field Name .EQ. 'XVARIABLE ') THEN
           Xvar = Position + 1

	ELSEIF (Field Name .EQ. 'YVARIABLE ') THEN
           Yvar = Position + 1
	   IF (Xvar .EQ. Yvar) THEN
              Error   = .TRUE.
	      Message = 'ERROR - X and Y must be different variables '
              Return Field = 'XVARIABLE '
	   ENDIF

C Get the kriging variable
	ELSEIF (Field Name .EQ. 'VARIABLE  ') THEN
           Var 	= Position + 1

C Get the log option
	ELSEIF (Field Name .EQ. 'LOGOPTION ') THEN
	   Log = (Position .EQ. 1)
	   CALL Read Data (Error)
	   IF (Error) THEN
	      Error = .FALSE.
	      CALL ReInitialize
	      CALL New Screen (1)
              Return Field = Main Menu 
           ENDIF

C----------------------------------------------------------------------
C Kriging type
	ELSEIF (Field Name .EQ. 'TY KRIGE  ') THEN
	  Ktype = Position
	  Field1 = Fld Index ('VM NUGGET ')
	  IF (Ktype .NE. 1) THEN
	    SC Carriage Return (Field1) = 2
	    SC Down            (Field1) = 2
	    SC Right           (Field1) = 2
	    Mglobal = 0.0
	    CALL Set 4 Floating Point Value ('VM MGLOBAL', 0.0, 3)
	    CALL Erase Field ('VM MGLOBAL')
	  ELSE
	    SC Carriage Return (Field1) = 1
	    SC Down            (Field1) = 1
	    SC Right           (Field1) = 1
	  ENDIF 
C----------------------------------------------------------------------
C get the search options
	ELSEIF (Field Name (1:2) .EQ. 'SE') THEN
          Field1 = Fld Index ('SE MAXPO  ')
          Field2 = Fld Index ('SE MINPT  ')
          Field3 = Fld Index ('SE MAXEMPT')
	  IF      (Field Name (3:10) .EQ. ' RMAJOR ') THEN
	    IF (Temp .LE. 0.0) THEN
	       Error 	= .TRUE.
	       Message	= 'Radius must be .GT. 0 - (press any key)'
	       Temp 	= SrMajor
	       Return Field = Field Name
	    ELSE
	       SrMajor = Temp 
	       IF (Character .EQ. 13) THEN
	         SrMinor = SrMajor
	         CALL Set 4Floating Point Value ('SE RMINOR ', Temp, 3)
	       ENDIF
	    ENDIF
	  ELSE IF (Field Name (3:10) .EQ. ' RMINOR ') THEN
	    IF (Temp .LE. 0.0) THEN
	       Error 	= .TRUE.
	       Message	= 'Radius must be .GT. 0 - (press any key)'
	       Temp 	= SrMinor
	       Return Field = Field Name
	    ELSE IF (Temp .GT. SrMajor) THEN
	       Error 	= .TRUE.
	       Message 	=
     +	 'Minor radius may not be greater than major - (press any key)'
	       Temp 	= SrMinor
	       Return Field = Field Name
	    ELSE
	       SrMinor 	= Temp 
	    ENDIF
      	  ELSE IF (Field Name (3:10) .EQ. ' ANGLE  ') THEN
	    IF (Temp .LT. 0.0 .OR. Temp .GE. 180.0) THEN
	       Error 	= .TRUE.
	       Message	=
     +  'Angle must be .GE. 0  and .LT. 180 - (press any key)'
	       Temp 	= 0.0
	       SrAngle 	= 0.0
	       Return Field = Field Name
	    ELSE
	       SrAngle = Temp
	    ENDIF
	  ELSE IF (Field Name (3:10) .EQ. ' MINDIST') THEN
	    IF (Temp .LT. 0.0) THEN
	       Error = .TRUE.
	       Message=
     +          'Min. Distance must be .GE. 0 - (press any key)'
	       Temp    = 0.0
	       MinDist = 0.0
	       Return Field = Field Name
	    ELSE
	       MinDist = Temp
	    ENDIF
	  ELSE IF (Field Name (3:10) .EQ. ' DTYPE  ') THEN
	     Euclidean = (Position .EQ. 0)
	  ELSE IF (Field Name (3:10) .EQ. ' ETYPE  ') THEN
             IF (Position .EQ. 0) THEN
               Nsector = 1      
               SC Members  (Field1) = 24
               SC Members  (Field3) = 1
               SC Position (Field3) = 0
               CALL Write Field (Field3, SC Attribute (Field3))
             ELSEIF (Position .EQ. 1) THEN
               Nsector = 4
               SC Members  (Field1) = 16
               SC Members  (Field3) = 4
             ELSEIF (Position .EQ. 2) THEN
               Nsector = 8
               SC Members  (Field1) = 8
               SC Members  (Field3) = 8
             ENDIF 
	  ELSE IF (Field Name (3:10) .EQ. ' MAXPO  ') THEN
            MaxPs = Position + 1
            MaxP  = MaxPs * Nsector
	    IF (Maxp .GT. 24) THEN
               SC Members  (Field2) = 24
	    ELSE
               SC Members  (Field2) = MaxP-1
	    ENDIF
	  ELSE IF (Field Name (3:10) .EQ. ' MINPT  ') THEN
	    MinP = Position + 1
	  ELSE IF (Field Name (3:10) .EQ. ' MAXEMPT') THEN
	    MaxEmpty = Position + 1
	  ENDIF
C----------------------------------------------------------------------
C get the Model Parameters
	ELSE IF (Field Name .EQ. 'VM NUGGET ') THEN
	  IF (Temp .LT. 0.0) THEN
	     Error 	= .TRUE.
	     Message	= 'Nugget must be .GE. 0 - (press any key)'
	     Nugget 	= 0.0
	     Temp   	= 0.0
	     Return Field = Field Name
	  ELSE
	     Nugget = Temp
	  ENDIF 
	ELSEIF (Field Name .EQ. 'VM MGLOBAL') THEN
	  Mglobal 	= Temp

	ELSEIF (Field Name (1:2) .EQ. 'VM') THEN
	  READ (Field Name (10:10), '(I1)') Pos
	  IF (Field Name(4:7).NE.'TYPE'.AND.Mtype(Pos).EQ.0) THEN
	    CALL Erase Field (Field Name)
	    Temp = 0.0
	  ELSE
	   IF      (Field Name (4:7) .EQ. 'TYPE') THEN
	    Mtype (Pos) = Position
            if (position .eq. 0) then
               if (pos .ne. maxstruc) then
                  Return Field = Field Name
                  write(Return Field(10:10),'(i1)') pos+1
               else if (pos .eq. maxstruc) then
                  Return Field = 'OPTIONS3  '
               end if
            end if

	   ELSE IF (Field Name (4:7) .EQ. 'SILL') THEN
	    IF (Temp .LE. 0.0) THEN
	       Error 	= .TRUE.
	       Message 	=
     +          'This parameter must be .GT. 0 - (press any key)'
	       Temp 	= 0.0
	       Return Field = Field Name
	    ELSE
	       Sill (Pos) = Temp
	    ENDIF 
	   ELSE IF (Field Name (4:9) .EQ. 'RMAJOR') THEN
	    IF (Temp .LE. 0.0) THEN
	       Error 	= .TRUE.
	       Message 	=
     +          'This parameter must be .GT. 0 - (press any key)'
	       Temp 	= 0.0
	       Return Field = Field Name
	    ELSE
	       VrMajor (Pos) = Temp
	       IF (Character .EQ. 13) THEN
	         VrMinor (Pos) = Temp
	         Dummy = FieldName (1:4)//'MINOR'//FieldName (10:10)
	         CALL Set 4Floating Point Value (Dummy, Temp, 3)
	       ENDIF 
	    ENDIF 
	   ELSE IF (Field Name (4:9) .EQ. 'RMINOR') THEN
	    IF (Temp .LT. 0.0 .OR. Temp .GT. VrMajor (Pos)) THEN
	       Error 	= .TRUE.
	       Message 	=
     +          'Minor range must be in [0. - Rmajor] (Press any key)'
	       Temp 	= VrMajor (Pos)
	       Return Field = Field Name
	    ELSE
	       VrMinor (Pos) = Temp
	    ENDIF 
	   ELSE IF (Field Name (4:8) .EQ. 'ANGLE') THEN
	    IF (Temp .LT. 0.0 .OR. Temp .GE. 180.0) THEN
	       Error 	= .TRUE.
	       Message	=
     +  'Angle must be .GE. 0  and .LT. 180 - (press any key)'
	       VrAngle (Pos) = 0.0
	       Temp 	= 0.0
	       Return Field = Field Name
	    ELSE
	       VrAngle (Pos) = Temp
	    ENDIF
	   ENDIF
	  ENDIF
C---------------------------------------------------------------------
	ELSEIF (Field Name .EQ. 'OUTFILE   ') THEN
	  CALL Erase (20, 2, 76)
	  CALL Get Character Value (Field Name, Output File)
	  N = LENSTR (File Prefix)
	  IF (N .GT. 0) THEN 
	     File Name = File Prefix (1:N) // Output File
	  ELSE
	     File Name = Output File
	  ENDIF
          if (LENSTR (File Name) .ne. 0) then
             OverWrite = .TRUE.
             INQUIRE (FILE = File Name, EXIST = FExist)
             IF (FExist) THEN
                OverWrite = GetYesNo (20, 2, 
     +               Output File//' already on disk, OverWrite? <Y/N>')
             ENDIF
             IF (OverWrite) THEN
                CALL Write Estimates (File Name, Error)
                IF (Error) THEN
                   Message = 'ERROR writing to file (press any key)'
                ELSE
                   CALL Erase (20, 2, 76)
                   CALL Flash (20, 2, 'Estimates written to '
     &                  //OutputFile)
                   GOTO 90
                ENDIF
             ENDIF
          else
             CALL Flash (20, 2, 'Sorry: null filename given.')
	  endif
C---------------------------------------------------------------------
	ELSEIF (Field Name .EQ. 'TYPSCATTER') THEN
	  IF (Graphics) THEN
	    CALL Scatter (Position)
	    CALL New Screen (4)
	    CALL Write Results 
	    CALL Put Menu ('RESULTS   ')
	    Next Field = Fld Index ('RESULTS   ')
	    RETURN
	  ELSE
	    CALL Beep
	    Error = .TRUE.
	    Message =
     +      'No supported graphics hardware found (press a key)'
	  ENDIF  

	ELSE
	  CONTINUE
	ENDIF

C Set the real value at 3 decimal places
  	IF (Field Type .EQ. Real Field) THEN
	   CALL Set 4 Floating Point Value (Field Name, Temp, 3)
	   IF (Pos .NE. 0 .AND. Mtype (Pos) .EQ. 0) GOTO 90
	ENDIF

C write out field, in case an error caused it to be blanked out
	CALL Display One Field (Field Name)

C if an error occurred, put out the message
 90	IF (Error) CALL Flash (20, 2, Message)

C Set up Next Field to be processed
	Next Field = Fld Index (Return Field)

C Erase screen message area

 1001	IF (Current Screen .EQ. 2) THEN
 	   DO 444 I = 11, 18
	     CALL Erase (I, 42, 35)
 444 	   CONTINUE
	ENDIF

	RETURN
	END

C----------------------------------------------------------------------
C Erase Model - erase a model with no model type
C
	SUBROUTINE Erase Model (Number)
	IMPLICIT INTEGER*4 (A-Z)

	INTEGER*4	Number
	CHARACTER	Field*10, Num*1, Fmt*4, Scratch*13

		include  'xvalid.dec'

	DATA Fmt 	/'(I1)'/
	DATA Scratch 	/'             '/
	WRITE (Num, Fmt) Number

	CALL Erase (14+Number, 4, 75) 

	Field = 'VM SILL  '//Num
	Sill (Number) = 0.0
	CALL Set Character Value (Field, Scratch)

	Field = 'VM RMAJOR'//Num
	VrMajor (Number) = 0.0
	CALL Set Character Value (Field, Scratch)

	Field = 'VM RMINOR'//Num
	VrMinor (Number) = 0.0
	CALL Set Character Value (Field, Scratch)
	
	Field = 'VM ANGLE '//Num
	VrAngle (Number) = 0.0
	CALL Set Character Value (Field, Scratch)
	RETURN
	END	

