
C Readdata.for - file input routines for STATS
C
C----------------------------------------------------------------------
C ***  Read Header Data - get data from input file 

	SUBROUTINE Read Header Data  (Error)
	IMPLICIT INTEGER*4 (A-Z)
 	
		include  'xvalid.dec'

	LOGICAL		Error
	CHARACTER*80	Blanks*10, Scratch*5
	CHARACTER*65	File Name

	DATA Blanks /'          '/

C Build File name
	N = LENSTR (File Prefix)
	IF (N .GT. 0) THEN 
	  File Name = File Prefix (1:N) // Data File
	ELSE
	  File Name = Data File
	ENDIF

C Open File for input
	CALL PutStr ('Reading Header Data ',20, 20, 2, 2)
	Error 	= .FALSE.
	OPEN(UNIT = 10, FILE = File Name, Status = 'unknown',ERR = 999)

C Read header string into header character variable
	READ(10, '(A)', ERR = 999, END = 999) Title

C Get number of variables in file
	READ(10, *, ERR = 999, END = 999) nvar

	IF (Nvar .LT. 3) THEN 
	   CALL Flash (20, 2, 
     +              'Too few variables in file  (press any key)') 
	   GOTO 999
	ELSEIF (Nvar .GT. MAXVAR) THEN
	   CALL Flash (20, 2, 
     +              'Too many variables in file  (press any key)') 
	   GOTO 999
	ENDIF

C Get variable names for each variable in file
  	DO 20 I = 1,  Nvar
 	  READ (10,'(2A10)', ERR = 999, END = 999)
     +                                Varnam (i), Units (i)
 20     CONTINUE        

C Load variable names into toggle fields for screen processing
	CALL Load Toggle Values  ('XVARIABLE ',10,Nvar, VarNam, 0)
	CALL Load Toggle Values  ('YVARIABLE ',10,Nvar, VarNam, 1)
	CALL Load Toggle Values  ('VARIABLE  ',10,Nvar, VarNam, 2)
	CALL Set Toggle Position ('XVARIABLE ', 0)
	CALL Set Toggle Position ('YVARIABLE ', 1)
	CALL Set Toggle Position ('VARIABLE  ', 2)
	CALL Set Toggle Position ('LOGOPTION ', 0)
	Log = .FALSE.
	Xvar = 1
	Yvar = 2
	if (var .eq. 0) Var  = 3

C display new field values
	CALL Display One Field  ('XVARIABLE ')
	CALL Display One Field  ('YVARIABLE ')
	CALL Display One Field  ('VARIABLE  ')
	CALL Display One Field  ('LOGOPTION ')

C display number of variables
	WRITE (Scratch, '(I5)') Nvar
	CALL PutStr (Scratch, 5, 6, 57, 0)
	Ndata 	= 0
	CLOSE (10)
	RETURN

C error has been found in data of file
 999	Error = .TRUE.
	CLOSE (10)
	CALL Beep
	CALL PutStr ('     ERROR reading data file ... ',33,11,43,2)
	CALL PutStr ('An ERROR was encountered in the  ',33,12,43,0)
	CALL PutStr ('header section of the data file. ',33,13,43,0)
	CALL PutStr ('Check the file name, and that the',33,14,43,0)
	CALL PutStr ('  named file has the the standard',33,15,43,0)
	CALL PutStr ('  data file format.              ',33,16,43,0)
        CALL PutStr ('Consult the Users Manual for more',33,17,43,0)
        CALL PutStr ('information about file format.   ',33,18,43,0)
	CALL Erase Field ('XVARIABLE ')
	CALL Erase Field ('YVARIABLE ')
	CALL Erase Field ('VARIABLE  ')
	CALL Flash (20, 2, ' Press any key to exit ')
	Ndata = 0
	Nvar  = 0
	RETURN
	END

C----------------------------------------------------------------------
C Read Data - read data into memory

	SUBROUTINE Read Data (Error)
	IMPLICIT INTEGER*4 (A-Z)
	
		include  '../common/screen.str'
		include  'xvalid.dec'

	CHARACTER 	Dummy*75, Scratch*5, File Name*65, Ifmt*4
	LOGICAL		Error
	REAL*4		DataRec (MAXVAR), Dx, Dy, DistMax

C Initialize Variables
	DATA Ifmt /'(I5)'/

	CALL PutStr ('Reading Data Values ...  ', 25, 20, 2, 2)

C Build File name
	N = LENSTR (File Prefix)
	IF (N .GT. 0) THEN 
	  File Name = File Prefix (1:N) // Data File
	ELSE
	  File Name = Data File
	ENDIF

C Open File for input
	Error 	= .FALSE.
	OPEN(UNIT = 10, FILE = File Name, Status = 'unknown', ERR = 999)

C Read header string 
	READ(10, '(A)', ERR = 999, END = 999) Dummy

C Get number of variables in file
	READ(10, *, ERR = 999, END = 999) Nvar

	IF (Nvar .LT. 1 .OR. Nvar .GT. MAXVAR) GOTO 999

C Get variable names for each variable in file
  	DO 20 I = 1,  Nvar
 	  READ (10,'(2A10)', ERR = 999, END = 999) Dummy, Dummy
 20     CONTINUE        

	Ndata  		= 0
	NMiss		= 0
	NumNeg		= 0
	Nrecord		= 0

	Xmin		= 1.E30
	Xmax		= -1.E30
	Ymin		= Xmin
	Ymax		= Xmax
        
	DO 30 Nrec = 1, MAXDATA
	   READ (10, *, END = 900, ERR = 999) (DataRec (i), i=1, Nvar)
	   Nrecord		= Nrecord + 1
	   IF (Datarec ( Var) .LT. Missing .AND.
     +         Datarec (XVar) .LT. Missing .AND.
     +         Datarec (YVar) .LT. Missing) THEN
              IF (DataRec (Var) .LE. 0.0) NumNeg = NumNeg + 1
	      IF (Log) THEN
	         IF (DataRec (Var) .LE. 0) THEN
	            NMiss		= NMiss + 1	
		    GOTO 30
		 ELSE
	            Ndata 		= Ndata + 1
	            Xdata (Ndata)	= DataRec (Xvar)
	            Ydata (Ndata)	= DataRec (Yvar)
	            Data (Ndata)	= ALOG (DataRec (Var))
	            Variable (Ndata)	= Data (Ndata)
	            Yvalues (Ndata)  	= Ydata (Ndata) 
	            YvalPtr (Ndata) 	= Ndata
	         ENDIF
	      ELSE
	   	 Ndata 		= Ndata + 1
	         Xdata (Ndata)	= DataRec (Xvar)
	         Ydata (Ndata)	= DataRec (Yvar)
	         Data  (Ndata) 	= DataRec (Var)
	         Variable (Ndata) = Data (Ndata)
	         Yvalues (Ndata)  = Ydata (Ndata) 
	         YvalPtr (Ndata) = Ndata
	      ENDIF
	      IF (Xdata (Ndata) .GT. Xmax) Xmax = Xdata (Ndata)
	      IF (Ydata (Ndata) .GT. Ymax) Ymax = Ydata (Ndata)
	      IF (Xdata (Ndata) .LT. Xmin) Xmin = Xdata (Ndata)
	      IF (Ydata (Ndata) .LT. Ymin) Ymin = Ydata (Ndata)
	   ELSE
	      NMiss = NMiss + 1
	   ENDIF
 30	CONTINUE

C check if more than MAXDATA records
	READ (10, *, END = 900, ERR = 999) (DataRec (i), i=1, Nvar)
	CALL Beep
	CALL PutStr(' The number of records in the data ',35,11,42,2)
	CALL PutStr(' file exceeds the program limits.  ',35,12,42,2)
	CALL PutStr(' Only the maximum allowed number   ',35,13,42,0)
	CALL PutStr(' of coordinate values have been    ',35,14,42,0)
	CALL PutStr(' stored in memory, the rest will   ',35,15,42,0)
	CALL PutStr(' not be used ...                   ',35,16,42,0)
	CALL Flash (20, 2, 'Press any key to continue ')

 900	IF (Ndata .LE. 1) GOTO 999
 	CLOSE (10)

	WRITE (Scratch, Ifmt) NVar
	CALL PutStr (Scratch, 5, 6, 57, 0)

	WRITE (Scratch, Ifmt) Nrecord
	CALL PutStr (Scratch, 5, 7, 57, 0)
	WRITE (Scratch, Ifmt) NMiss
	CALL PutStr (Scratch, 5, 8, 57, 0)
	IF (NumNeg .GT. 0) THEN
	   WRITE (Scratch, Ifmt) Numneg
	   CALL Left Justify (Scratch)
	   N = LENSTR (Scratch)
	   CALL PutStr ('('//Scratch (1:N)//' Obs<=0)',N+9, 8, 64, 0)
	ELSE
	   CALL Erase (8, 64, 14)
	ENDIF

C Sort Data values
	CALL PutStr ('Sorting Data Values ...  ', 25, 20, 2, 2)
	CALL Qsort  (Yvalues, YvalPtr, Ndata)
	CALL Stats  (Variable,   Ndata, VN, VNmiss,
     +                          VMin, VQ1, Vmedian, VQ3, VMax, 
     +                          VMean, Vstd)

C Calculate Quartiles
	Q1 = VQ1
	Q2 = VMedian
	Q3 = VQ3

C Calculate ticmark and max axis values
	CALL Neatax (Ymin, Ymax, Ytinc, Nytic)
	CALL Neatax (Xmin, Xmax, Xtinc, Nxtic)
        
C Calculate Defaults for the Variogram model and search parameters
	IF (SrMajor .EQ. 0.0 .OR. SrMinor .EQ. 0.0) THEN
	    Dx = ABS (Xmax - Xmin)
	    Dy = ABS (Ymax - Ymin)
	    SrMajor = AMAX1 (Dx, Dy) * .25
	    SrMinor = SrMajor
	    SrAngle = 0.0
	    MinDist = 0.0	
	    CALL Set 4Floating Point Value ('SE RMAJOR ', SrMajor, 3)
	    CALL Set 4Floating Point Value ('SE RMINOR ', SrMinor, 3)
	    CALL Set 4Floating Point Value ('SE ANGLE  ', SrAngle, 3)
	    CALL Set 4Floating Point Value ('SE MINDIST', Mindist, 3)
	ENDIF	    
C Default model
C     IF (GamMax .EQ. 0.0) THEN
C         Mtype   (1) = 1
C         Sill    (1) = Vstd*Vstd
C         VrMajor (1) = SrMajor*.75
C	    VrMinor (1) = SrMinor*.75
C	    VrAngle (1) = 0.0    
C	    CALL Set Toggle Position       ('VM TYPE  1', 1)
C	    CALL Set 4Floating Point Value ('VM RMAJOR1', VrMajor (1), 3)
C	    CALL Set 4Floating Point Value ('VM RMINOR1', VrMinor (1), 3)
C	    CALL Set 4Floating Point Value ('VM SILL  1', Sill    (1), 3)
C	    CALL Set 4Floating Point Value ('VM ANGLE 1', VrAngle (1), 3)
C	ENDIF		   
	CALL Erase (20, 2, 75)
	RETURN

C error has been found in data
 999	Error 		= .TRUE.
	CLOSE (10)
	CALL Beep
	WRITE (Scratch, '(I5)') Nrecord+Nvar+1
	CALL PutStr ('     ERROR reading data file ... ',33,11,43,2)
	CALL PutStr ('An ERROR was encountered reading ',33,12,43,0)
	CALL PutStr ('record #         in the data file',33,13,43,0)
	CALL Putstr (Scratch, 5, 13, 52, 2) 
	CALL PutStr ('Check the file name, and that the',33,14,43,0)
	CALL PutStr ('  named file has the the standard',33,15,43,0)
	CALL PutStr ('  data file format.              ',33,16,43,0)
        CALL PutStr ('Consult the Users Manual for more',33,17,43,0)
        CALL PutStr ('information about file format.   ',33,18,43,0)
	CALL Erase Field ('XVARIABLE ')
	CALL Erase Field ('YVARIABLE ')
	CALL Erase Field ('VARIABLE  ')
cc	CALL Flash (20, 2, ' Press any key to exit ')

        call flash(20,2,'An error has been found in the data file.')
        CALL putstr ('Type "c" to continue anyway:     ',33,20, 2,0)
        call getthekey(i)
        if (char(i) .eq. 'c' .or. char(i) .eq. 'C') then
           error = .false.
           CALL Erase (20, 2, 75)
           goto 900
        end if

	Ndata = 0
	Nvar  = 0
	CALL Erase (20, 2, 75)
	RETURN
	END

C----------------------------------------------------------------------
C Show screen storage
	SUBROUTINE Show Screen Storage

		include '../common/screen.str'

	CALL Clear Screen
	K = Total Number of Screens
	J = End Label (K)
	write (*,*) 'Screen Storage Requirements '
	write (*,*)
	write (*,*) '# Screens  :',K                 
	write (*,*) '# Fields   :',End Screen (K)
	write (*,*) '# Labels   :',End Label  (K)
	write (*,*) '# Frames   :',End Frame  (K)
	write (*,*) 'String size:', LB Pointer (J) + LB Length (J) - 1
	write (*,*)
	write (*,*) 'These values must be smaller that those declared'
	write (*,*) 'in ../common/screen.str '
	CALL Flash (20, 2, 'press a key')
	RETURN
	END



