
C Stats.for
C----------------------------------------------------------------------
C Stats - calculate stats for a given variable

	SUBROUTINE Stats (Var, Ndata, N, Nmiss, 
     +                         Min, Q1, Median, Q3, Max,
     +                         Mean, StdDev)
	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (MAXDATA = 1000)

	REAL*4     Var (1), Min, Q1, Median, Q3, Max, Mean, StdDev
	REAL*8	   Sum, SumSq, Term1, Term2
	REAL*4	   Missing, V (MAXDATA)
	INTEGER*4	I, J, N,  Nmiss, Ndata, Q1Lim, Q2Lim, Q3Lim 
	INTEGER*4	TN

	DATA Missing 	/1.E31/

	IF (NDATA .EQ. 0) RETURN

	Min	= 0.0
	Max 	= 0.0
	Median	= 0.0
	Q1	= 0.0
	Q3	= 0.0
	Mean	= 0.0
	StdDev	= 0.0
	Sum   	= 0.0
	SumSq 	= 0.0
	NMiss 	= 0
	N	= 0
	DO 20 I = 1, Ndata
	   IF (Var (I) .LT. Missing) THEN
              N 	= N + 1
              V (N) 	= Var (I) 
	      Sum 	= Sum   + V (N)
	      SumSq 	= SumSq + (V(N) * V(N))
	   ELSE
              NMiss = NMiss + 1  
	   ENDIF   	
 20	CONTINUE
	
	IF (N .GT. 0) THEN
	   Q1Lim 	= IFIX (N*.25)
	   Q2Lim	= IFIX (N*.50)
	   Q3Lim	= IFIX (N*.75)
	   CALL Qsort1 (V, N)
	   Min 		= V (1)
	   Q1  		= V (Q1Lim)
	   Median 	= V (Q2Lim)
	   Q3		= V (Q3Lim)
	   Max		= V (N)
	   Mean		= Sum / N
	   TN		= N * (N-1) 
	   Term1	= N * SumSq
	   Term2	= Sum * Sum
	   IF ((Term1-Term2) .LT. 1.E-10) THEN
                StdDev  = 0.0
	   ELSE 
	   	StdDev 	= SQRT ((Term1 - Term2) / TN)
	   ENDIF
	ENDIF
	RETURN
	END	


