
C Xvalid.for
C-----------------------------------------------------------------------
	PROGRAM XVALID
	IMPLICIT INTEGER*4 (a-z)

        include 'xvalid.dec'

        character*80    geoeas_home
 
        include '../common/color.dec'

cc Note that the get_geoeas_home line needs to come first, or there
cc will be problems on some terminals.
cc    The program will speed up if this is your private copy, and you
cc want to replace the call by the following example:
cc    My geoeas_dir is
cc             /aplm3/ael/dmyers/dgeoeas/unix_version
cc so I could replace the lines below by 
cc        CALL Read Structure ('/aplm3/ael/dmyers/dgeoeas/unix_version'
cc     &       //'/xvalid/xvalid.scr')
cc
        call graphics_in
        call get_geoeas_dir(10,geoeas_home)
        CALL Read Structure (geoeas_home(1:lenstr(geoeas_home))
     &       //'/xvalid/xvalid.scr')


ccc replaces old grafinit:
        graphics = .true.
        aspect     = 1
        DevCode    = 1
ccc
	call set up screen()
	CALL Clear Screen

        CALL Initialize
        CALL Read System Defaults
        IF (Intro) CALL Intro Screen
        CALL Get Screen Fields
        CALL Write System Defaults
        CALL SetMod (INT2 (StartMode))
	END

C----------------------------------------------------------------------
C Intro Screen - 	displays screen frame/label/fields
C			for the introductory screen

	SUBROUTINE Intro Screen
	CALL Clear Screen
	CALL Set Screen (1)
	CALL Display Frame
	CALL Display Labels
	CALL Locate Cursor (23, 0)
	CALL Flash (20, 2, 'Press any key to begin the program ')
	RETURN
	END

C-----------------------------------------------------------------------
C Interface  statements for video status function

cc	interface to INTEGER*4 function vstats[C]
cc     1		(c_adap[reference],ega_mon[reference],mode[reference],
cc      1		 at[reference],sec_mon[reference])
cc	INTEGER*4 c_adap,ega_mon,mode,at,sec_mon
cc	end

C----------------------------------------------------------------------
C Initialize - initialize XVALID global values
C
	SUBROUTINE Initialize 
	IMPLICIT INTEGER*4 (A-Z)

		include 'xvalid.dec'

        INTEGER*4     Pos
        CHARACTER*10  Dummy

        Xvar		    = 1
        Yvar		    = 2
        Var           = 3
        Nvar          = 0

        MinDist	= 0.00001
        CALL Set 4Floating Point Value ('SE MINDIST', Mindist, 3)
        CALL Get Toggle Value      ('SE DTYPE  ', Pos, Dummy)
        Euclidean = (Pos .EQ. 0)
        CALL Get Toggle Value      ('SE ETYPE  ', Pos, Dummy)
        MinP          = Pos+1
        CALL Get Toggle Value      ('SE MAXPO  ', Pos, Dummy)
        MaxPs         = Pos+1
        CALL Get Toggle Value      ('SE MINPT  ', Pos, Dummy)
        Nsector       = Pos+1
        CALL Get Toggle Value      ('SE MAXEMPT', Pos, Dummy)
        MaxEmpty      = Pos
        
        Ktype           = 0
        Missing         = 1.E31
        Debug System    = .FALSE.
        Debug Neighbors = .FALSE.
        Debug Weights   = .FALSE.
        Log		= .FALSE.
        
        Minimum = -1.E30
        Maximum = +1.E30
        
        Data File = ' '        

        RETURN			
        END			

C----------------------------------------------------------------------
C ReInitialize - Reinitialize XVALID global values
C
	SUBROUTINE ReInitialize 
	IMPLICIT INTEGER*4 (A-Z)

		include 'xvalid.dec'
		include '../common/screen.str'

        CHARACTER*10	Scratch*13
	INTEGER*4	Fld Index, Field

	DATA Scratch /'             '/
	CALL Initialize
C----------------------------------------------------------------------
C init variable names
	CALL Set Toggle Position      ('XVARIABLE ', 0)
	CALL Set Toggle Position      ('YVARIABLE ', 1)
	CALL Set Toggle Position      ('VARIABLE  ', 2)
	CALL Set Toggle Position      ('LOGOPTION ', 0)

C----------------------------------------------------------------------
C initialize options screen fields

C init kriging type
	CALL Set Toggle Position      ('TY KRIGE  ', 0)

C set pointers to skip global mean (default is ordinary kriging)
	Field = Fld Index ('VM NUGGET ')
	SC Carriage Return (Field) = 2
	SC Down            (Field) = 2
	SC Right           (Field) = 2

C initmodel parameters
C	CALL Set 4 Floating Point Value ('VM NUGGET ', 0.0, 3)
C	CALL Set Character Value ('VM MGLOBAL', Scratch)
C	CALL Set Toggle Position ('VM TYPE  1', 0)
C	CALL Set Toggle Position ('VM TYPE  2', 0)
C	CALL Set Toggle Position ('VM TYPE  3', 0)
C	CALL Set Toggle Position ('VM TYPE  4', 0)
C	CALL Set Character Value ('VM SILL  1', Scratch)
C	CALL Set Character Value ('VM SILL  2', Scratch)
C	CALL Set Character Value ('VM SILL  3', Scratch)
C	CALL Set Character Value ('VM SILL  4', Scratch)
C	CALL Set Character Value ('VM RMAJOR1', Scratch)
C	CALL Set Character Value ('VM RMAJOR2', Scratch)
C	CALL Set Character Value ('VM RMAJOR3', Scratch)
C	CALL Set Character Value ('VM RMAJOR4', Scratch)
C	CALL Set Character Value ('VM RMINOR1', Scratch)
C	CALL Set Character Value ('VM RMINOR2', Scratch)
C	CALL Set Character Value ('VM RMINOR3', Scratch)
C	CALL Set Character Value ('VM RMINOR4', Scratch)
C	CALL Set Character Value ('VM ANGLE 1', Scratch)
C	CALL Set Character Value ('VM ANGLE 2', Scratch)
C	CALL Set Character Value ('VM ANGLE 3', Scratch)
C	CALL Set Character Value ('VM ANGLE 4', Scratch)
	RETURN
	END

C----------------------------------------------------------------------
C Get Screen Fields - 	displays screen frame/label/fields
C			gets the screen fields for the current screen

	SUBROUTINE Get Screen Fields 

	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (MAINSCR  = 2, RSCREEN = 4, OSCREEN = 3, DSCREEN = 5)
 
		include '../common/screen.str'
		include 'xvalid.dec'

	CHARACTER*10	Main Menu, R Menu, O Menu, fldname
	CHARACTER 	Menu Choice*10, Scratch*10, oldfile*14
     &       , filename*60
	LOGICAL		GetYesNo, Exit
	LOGICAL		Error, Quit

	DATA Main Menu/'MAINMENU  '/
	DATA R Menu   /'RESULTS   '/, O Menu  /'OPTIONS   '/ 

C Paint Screen
  5	CALL New Screen (MAINSCR)
	CALL Set Character Value ('DATAFILE  ', Data File)
	
C Main screen
 10 	CALL Put Menu (Main Menu)

 20	CALL Get Menu Choice (Main Menu, Menu Choice)	
 	IF      (Menu Choice .EQ. 'Quit     ') THEN
	  Exit = GetYesNo (20, 2, 'Do you really want to QUIT? <Y/N>')
cclong
	  IF (Exit) then
             call clear screen
             call reset screen
             RETURN
          end if
cc

	ELSE IF (Menu Choice .EQ. 'Variables ') THEN
           IF (Nvar .EQ. 0) THEN
              CALL Beep
           ELSE
              CALL Get Field Group
              GOTO 10
           ENDIF
           
        ELSE IF (Menu Choice .EQ. 'Load' .or.
     &          Menu Choice .eq. 'Save') THEN
           if (lenstr(parmfile) .eq. 0 .or.
     &          char(0) .eq. parmfile(1:1)) then
              call Build File Name (data file,parmfile,'.kpf')
              call set character value('Paramfile',parmfile)
           end if
           CALL Get Field Group
           call get character value('Paramfile',parmfile)
           call erase(20,2,76)
           if (Menu Choice .EQ. 'Save') then
              fldname = 'VARIABLE'
              CALL get toggle value (fldname,j,scratch)
              call save parameters (parmfile,error,j+1)
              if (error) goto 10
           else
              OldFile = Data File
              call read parameters (parmfile,error,krigvar)
              if (error) goto 10
              CALL Set 4Floating Point Value ('SE RMAJOR ', SrMajor, 3)
              CALL Set 4Floating Point Value ('SE RMINOR ', SrMinor, 3)
              CALL Set 4Floating Point Value ('SE ANGLE  ', SrAngle, 3)
              CALL Set 4Floating Point Value ('SE MINDIST', Mindist, 3)

              N = LENSTR (File Prefix)
              IF (N .GT. 0) THEN 
                 File Name = File Prefix (1:N) // Data File
              ELSE
                 File Name = Data File
              ENDIF

              var = krigvar

              CALL Read Header Data (Error)
              IF (Error) THEN
                 CALL ReInitialize
              ELSE
                 CALL Read Data (Error)
                 IF (Error) CALL ReInitialize
              ENDIF
              if (error) then
                 data file = oldfile
                 goto 10
              end if

              CALL Set Character Value ('DATAFILE  ', Data File) 
              call display one field('DATAFILE  ') 
              fldname = 'VARIABLE'
              CALL set toggle position (fldname,var-1)
              fldname = 'VM NUGGET'
              CALL Set4Floating Point Value
     &             (Fldname,nugget,3)
              call display one field(fldname) 
              fldname = 'VM MGLOBAL'
              CALL Set4Floating Point Value
     &             (Fldname,mglobal,3)
              nmodels = 0
              do i = 1, maxstruc
                 if (mtype(i) .ne. 0) then
                    nmodels = nmodels+1
                    mtype(nmodels) = mtype(i)
                    sill(nmodels) = sill(i)
                    vrmajor(nmodels) = vrmajor(i)
                    vrminor(nmodels) = vrminor(i)
                    vrangle(nmodels) = vrangle(i)

                    write(scratch(1:1),'(i1)') nmodels
                    
                    fldname = 'VM SILL  '//scratch(1:1)
                    CALL Set4Floating Point Value
     &                   (Fldname,sill(i), 3)
                    fldname = 'VM RMAJOR'//scratch(1:1)
                    CALL Set4Floating Point Value
     &                   (Fldname,vrmajor(i), 3)
                    fldname = 'VM RMINOR'//scratch(1:1)
                    CALL Set4Floating Point Value
     &                   (Fldname,vrminor(i), 3)
                    fldname = 'VM ANGLE '//scratch(1:1)
                    CALL Set4Floating Point Value
     &                   (Fldname,vrangle(i), 3)
                    fldname = 'VM TYPE  '//scratch(1:1)
                    CALL Set toggle position (fldname,mtype(i))
                 end if

              enddo
              do i = nmodels+1, maxstruc
                 mtype(i) = 0
                 vrmajor(i) = 0
                 vrminor(i) = 0
                 vrangle(i) = 0
                 sill(i) = 0
                 write(scratch(1:1),'(i1)') i
                 fldname = 'VM TYPE  '//scratch(1:1)
                 CALL Set toggle position (fldname,0)
                 fldname = 'VM SILL  '//scratch(1:1)
                 CALL Set Character Value (fldname,'')
                 fldname = 'VM RMAJOR'//scratch(1:1)
                 CALL Set Character Value (fldname,'')
                 fldname = 'VM RMINOR'//scratch(1:1)
                 CALL Set Character Value (fldname,'')
                 fldname = 'VM ANGLE '//scratch(1:1)
                 CALL Set Character Value (fldname,'')
              enddo
              goto 25

           end if

C----------------------------------------------------------------------
C Options screen
	ELSE IF (Menu Choice .EQ. 'Options/Ex') THEN
	  IF (Nvar .EQ. 0 .OR. Ndata .EQ. 0) THEN
	    CALL Beep
	    GOTO 20
	  ENDIF
 25       CALL New Screen (OSCREEN)
   	  CALL Write Options Header
	  CALL Set Menu Position (O Menu, 2)
 30	  CALL Put Menu   (O Menu)
 35	  CALL Get Menu Choice (O Menu, Menu Choice)   
	  IF      (Menu Choice .EQ. 'Quit      ') THEN
	     GOTO 5
C---------------------------------------------------------------------- 
C Results screen
	  ELSE IF (Menu Choice .EQ. 'Execute   ') THEN
	    CALL Check Parms
	    CALL Kriger	(Quit)
	    IF (Quit) THEN
	       CALL Flash (20, 2, 'Kriging cancelled, Press any key')
	       GOTO 25
	    ENDIF
 
 40	    CALL New Screen (RSCREEN)
   	    CALL Write Results 
	    CALL Set Menu Position (R Menu, 1)
 45	    CALL Put Menu   (R Menu)
 50	    CALL Get Menu Choice (R Menu, Menu Choice)
	    IF      (Menu Choice .EQ. 'Quit      ') THEN
	       GOTO 25
	    ELSE IF (Menu Choice .EQ. 'Error Map ') THEN
	       IF (Graphics) THEN
	         CALL PlotData (0, 1)
	         GOTO 40
	       ELSE
	         CALL Beep
	         CALL Flash (20, 2,
     +	        'No supported graphics hardware found (press any key)')
	       ENDIF
	    ELSE IF (Menu Choice .EQ. 'Histogram ') THEN
	       IF (Graphics) THEN
	         CALL Histogram 
	         GOTO 40
	       ELSE
	         CALL Beep
	         CALL Flash (20, 2,
     +	        'No supported graphics hardware found (press any key)')
	       ENDIF
	    ELSE IF (Menu Choice .EQ. 'Examine   ') THEN
	       CALL New Screen (DSCREEN)
	       CALL Examine
	       GOTO 40
	    ELSE 
               CALL Get Field Group
	    ENDIF
	    GOTO 50	   
C---------------------------------------------------------------------- 
	  ELSE
	    CALL Get Field Group
	  ENDIF
	  GOTO 35	  
C----------------------------------------------------------------------
	ELSE
          CALL Get Field Group
	ENDIF

	GOTO 20
	END	

C----------------------------------------------------------------------
C Get Field Group - get a group of fields, perform processes

	SUBROUTINE Get Field Group 
	IMPLICIT INTEGER*4 (A-Z)

	PARAMETER (Main Menu Field = 3)
	PARAMETER (Menu Field      = 4)

		include '../common/screen.str'
	
	LOGICAL		Error, Repaint

 10	CALL Get Field	
	CALL Perform Process (SC Field Name (Current Field),
     +                     Error, Repaint) 
	IF (SC Field Type (Next Field) .NE. Main Menu Field .AND.
     +	    SC Field Type (Next Field) .NE. Menu Field) GOTO 10

	IF (Repaint) THEN
	   CALL New Screen (Current Screen)
	ENDIF

	RETURN
	END

C----------------------------------------------------------------------
C New Screen (Screen number) - sets up a new screen
C
	SUBROUTINE New Screen (Screen Number)
	IMPLICIT INTEGER*4 (A-Z)

		include '../common/screen.str'

	PARAMETER (Main Menu Field = 3)
	PARAMETER (Menu Field      = 4)

	CALL Clear Screen
	CALL Set Screen (Screen Number)
	CALL Display Frame
	CALL Display Labels

	DO 10 I = Begin Screen (Current Screen),
     +	         End Screen (Current Screen)
	  IF (SC Field Type (I) .NE. Main Menu Field .AND.
     +	      SC Field Type (I) .NE. Menu Field)
     +	      CALL Write Field (i, SC Attribute (i))

  10	CONTINUE
	
	CALL Erase (20, 2, 76)
	RETURN
	END

C----------------------------------------------------------------------
C Write Header - put out header for Options screen

      SUBROUTINE Write Options Header
	IMPLICIT INTEGER*4 (A-Z)
 
		include 'xvalid.dec'

	CHARACTER*65	File Name, Dummy*3
	INTEGER*4	Position
	
	N = LENSTR (File Prefix)
	IF (N .GT. 0) THEN 
	  File Name = File Prefix (1:N) // Data File
	ELSE
	  File Name = Data File
	ENDIF

	N = LENSTR (File Name)
	CALL PutStr (File Name,      N, 2, 14, 0)
	CALL PutStr (VarNam (Xvar), 10, 4, 14, 0)
	CALL PutStr (VarNam (Yvar), 10, 5, 14, 0)
	CALL PutStr (VarNam (Var),  10, 6, 14, 0)
	CALL Get Toggle Value ('LOGOPTION ', Position, Dummy)
	CALL PutStr (Dummy,          3, 7, 14, 0)  
	RETURN
	END

C----------------------------------------------------------------------
C Write Results 

      SUBROUTINE Write Results
	IMPLICIT INTEGER*4 (A-Z)
 
		include 'xvalid.dec'

	CHARACTER*65	File Name, Dummy*8, Scratch*13, Rfmt*8, Ifmt*8
	INTEGER*4	Position

	DATA Rfmt /'(F13.3)'/, Ifmt /'(I13)'/
	
	N = LENSTR (File Prefix)
	IF (N .GT. 0) THEN 
	  File Name = File Prefix (1:N) // Data File
	ELSE
	  File Name = Data File
	ENDIF

	N = LENSTR (File Name)
	CALL PutStr (File Name,      N, 2, 15, 0)
	CALL PutStr (VarNam (Xvar), 10, 3, 15, 0)
	CALL PutStr (VarNam (Yvar), 10, 4, 15, 0)
	IF (Log) THEN
	   CALL PutStr ('LN ('//VarNam (Var)//')',  15, 5, 15, 0)
	ELSE
	   CALL PutStr (VarNam (Var),  10, 5, 15, 0)
	ENDIF

	CALL Get Toggle Value ('TY KRIGE  ', Position, Dummy)
	CALL PutStr (Dummy, 8, 6, 15, 0)

	WRITE (Scratch, '(I13)') Ndata
	CALL PutStr (Scratch, 13, 5, 57, 0)
	WRITE (Scratch, '(I13)') Nmiss
	CALL PutStr (Scratch, 13, 6, 57, 0)

	IF (Ktype .EQ. 1) THEN
	   WRITE (Scratch, Rfmt) Mglobal
	   CALL PutStr ('Global Mean    : '//Scratch, 30, 4, 40, 0)
	ENDIF

	WRITE (Scratch ,Rfmt) Vmin
	CALL PutStr (Scratch, 13, 10, 13, 0)
	WRITE (Scratch ,Rfmt) Emin
	CALL PutStr (Scratch, 13, 10, 26, 0)
	WRITE (Scratch ,Rfmt) Dmin
	CALL PutStr (Scratch, 13, 10, 39, 0)
	WRITE (Scratch ,Rfmt) Smin
	CALL PutStr (Scratch, 13, 10, 52, 0)
	WRITE (Scratch ,Rfmt) Zmin
	CALL PutStr (Scratch, 13, 10, 65, 0)

	WRITE (Scratch ,Rfmt) VQ1
	CALL PutStr (Scratch, 13, 11, 13, 0)
	WRITE (Scratch ,Rfmt) EQ1
	CALL PutStr (Scratch, 13, 11, 26, 0)
	WRITE (Scratch ,Rfmt) DQ1
	CALL PutStr (Scratch, 13, 11, 39, 0)
	WRITE (Scratch ,Rfmt) SQ1
	CALL PutStr (Scratch, 13, 11, 52, 0)
	WRITE (Scratch ,Rfmt) ZQ1
	CALL PutStr (Scratch, 13, 11, 65, 0)
 
	WRITE (Scratch ,Rfmt) VMedian
	CALL PutStr (Scratch, 13, 12, 13, 0)
	WRITE (Scratch ,Rfmt) EMedian
	CALL PutStr (Scratch, 13, 12, 26, 0)
	WRITE (Scratch ,Rfmt) DMedian
	CALL PutStr (Scratch, 13, 12, 39, 0)
	WRITE (Scratch ,Rfmt) SMedian
	CALL PutStr (Scratch, 13, 12, 52, 0)
	WRITE (Scratch ,Rfmt) ZMedian
	CALL PutStr (Scratch, 13, 12, 65, 0)

	WRITE (Scratch ,Rfmt) VQ3
	CALL PutStr (Scratch, 13, 13, 13, 0)
	WRITE (Scratch ,Rfmt) EQ3
	CALL PutStr (Scratch, 13, 13, 26, 0)
	WRITE (Scratch ,Rfmt) DQ3
	CALL PutStr (Scratch, 13, 13, 39, 0)
	WRITE (Scratch ,Rfmt) SQ3
	CALL PutStr (Scratch, 13, 13, 52, 0)
	WRITE (Scratch ,Rfmt) ZQ3
	CALL PutStr (Scratch, 13, 13, 65, 0)

	WRITE (Scratch ,Rfmt) VMax
	CALL PutStr (Scratch, 13, 14, 13, 0)
	WRITE (Scratch ,Rfmt) EMax
	CALL PutStr (Scratch, 13, 14, 26, 0)
	WRITE (Scratch ,Rfmt) DMax
	CALL PutStr (Scratch, 13, 14, 39, 0)
	WRITE (Scratch ,Rfmt) SMax
	CALL PutStr (Scratch, 13, 14, 52, 0)
	WRITE (Scratch ,Rfmt) ZMax
	CALL PutStr (Scratch, 13, 14, 65, 0)

	WRITE (Scratch ,Ifmt) VN
	CALL PutStr (Scratch, 13, 16, 13, 0)
	WRITE (Scratch ,Ifmt) EN
	CALL PutStr (Scratch, 13, 16, 26, 0)
	WRITE (Scratch ,Ifmt) DN
	CALL PutStr (Scratch, 13, 16, 39, 0)
	WRITE (Scratch ,Ifmt) SN
	CALL PutStr (Scratch, 13, 16, 52, 0)
	WRITE (Scratch ,Ifmt) ZN
	CALL PutStr (Scratch, 13, 16, 65, 0)

	WRITE (Scratch ,Rfmt) VMean
	CALL PutStr (Scratch, 13, 17, 13, 0)
	WRITE (Scratch ,Rfmt) EMean
	CALL PutStr (Scratch, 13, 17, 26, 0)
	WRITE (Scratch ,Rfmt) DMean
	CALL PutStr (Scratch, 13, 17, 39, 0)
	WRITE (Scratch ,Rfmt) SMean
	CALL PutStr (Scratch, 13, 17, 52, 0)
	WRITE (Scratch ,Rfmt) ZMean
	CALL PutStr (Scratch, 13, 17, 65, 0)

	WRITE (Scratch ,Rfmt) VStd
	CALL PutStr (Scratch, 13, 18, 13, 0)
	WRITE (Scratch ,Rfmt) EStd
	CALL PutStr (Scratch, 13, 18, 26, 0)
	WRITE (Scratch ,Rfmt) DStd
	CALL PutStr (Scratch, 13, 18, 39, 0)
	WRITE (Scratch ,Rfmt) SStd
	CALL PutStr (Scratch, 13, 18, 52, 0)
	WRITE (Scratch ,Rfmt) ZStd
	CALL PutStr (Scratch, 13, 18, 65, 0)

        IF (NZeroDist .GT. 0) THEN
          CALL Beep
          WRITE (Scratch(1:5), '(I5)') NZeroDist
          CALL PutStr (Scratch(1:5)//
     +   ' Pts. kriged with duplicate neighbors',43,3,35,2)
        ENDIF
	RETURN
	END

C----------------------------------------------------------------------
C Read System Defaults

	SUBROUTINE Read System Defaults
	IMPLICIT INTEGER*4 (A-Z)
 
		include 'xvalid.dec'

	CHARACTER*20  String

	OPEN (UNIT = 10, FILE = 'geoeas.def', STATUS = 'OLD',
     +			 ERR=999)
	READ (10, '(A)', ERR=999,END=999) File Prefix
	READ (10, '(A)', ERR=999,END=999) Data File
	READ (10, '(A)', ERR=999,END=999) String
	Intro = (String (7:8) .EQ. 'ON' .OR.
     +           String (7:8) .EQ. 'on')
	CALL Set Character Value ('FILEPREFIX', File Prefix)
	CLOSE (10)
	RETURN

 999	CLOSE (10)
	INTRO = .TRUE.
	RETURN
	END

C----------------------------------------------------------------------
C Write System Defaults

	SUBROUTINE Write System Defaults
	IMPLICIT INTEGER*4 (A-Z)
 
		include 'xvalid.dec'

	OPEN (UNIT = 10, FILE = 'geoeas.def', STATUS = 'UNKNOWN',
     +			ERR=999)
	WRITE (10, '(A)', ERR = 999) File Prefix
	WRITE (10, '(A)', ERR = 999) Data File
	IF (Intro) THEN
	  WRITE (10, '(A)', ERR = 999) 'INTRO=ON'
	ELSE
	  WRITE (10, '(A)', ERR = 999) 'INTRO=OFF'
	ENDIF
 999	CLOSE (10)
	RETURN
	END
